/* Generated by Pyrex 0.9.9 on Mon Nov 30 08:55:53 2015 */

#define PY_SSIZE_T_CLEAN
#include "Python.h"
#include "structmember.h"
#ifndef PY_LONG_LONG
  #define PY_LONG_LONG LONG_LONG
#endif
#if PY_VERSION_HEX < 0x02050000
  typedef int Py_ssize_t;
  #define PY_SSIZE_T_MAX INT_MAX
  #define PY_SSIZE_T_MIN INT_MIN
  #define PyInt_FromSsize_t(z) PyInt_FromLong(z)
  #define PyInt_AsSsize_t(o)	PyInt_AsLong(o)
#endif
#if !defined(WIN32) && !defined(MS_WINDOWS)
  #ifndef __stdcall
    #define __stdcall
  #endif
  #ifndef __cdecl
    #define __cdecl
  #endif
#endif
#ifdef __cplusplus
#define __PYX_EXTERN_C extern "C"
#else
#define __PYX_EXTERN_C extern
#endif
#include <math.h>
#include "dnet.h"


typedef struct {PyObject **p; int i; char *s; long n;} __Pyx_StringTabEntry; /*proto*/

static PyObject *__pyx_m;
static PyObject *__pyx_b;
static int __pyx_lineno;
static char *__pyx_filename;
static char **__pyx_f;

static char __pyx_mdoc[] = "dumb networking library\n\nThis module provides a simplified interface to several low-level\nnetworking routines, including network address manipulation, kernel\narp(4) cache and route(4) table lookup and manipulation, network\nfirewalling, network interface lookup and manipulation, IP tunnelling,\nand raw IP packet and Ethernet frame transmission.\n";

static void __Pyx_Raise(PyObject *type, PyObject *value, PyObject *tb); /*proto*/

static PyObject *__Pyx_GetName(PyObject *dict, PyObject *name); /*proto*/

static int __Pyx_ArgTypeTest(PyObject *obj, PyTypeObject *type, int none_allowed, char *name); /*proto*/

static PyObject *__Pyx_UnpackItem(PyObject *); /*proto*/
static int __Pyx_EndUnpack(PyObject *); /*proto*/

static int __Pyx_InitStrings(__Pyx_StringTabEntry *t); /*proto*/

static void __Pyx_AddTraceback(char *funcname); /*proto*/

/* Declarations from dnet */


/* Declarations from implementation of dnet */

struct __pyx_obj_4dnet_eth {
  PyObject_HEAD
  eth_t *eth;
};

struct __pyx_obj_4dnet_ip {
  PyObject_HEAD
  ip_t *ip;
};

struct __pyx_obj_4dnet_addr {
  PyObject_HEAD
  struct addr _addr;
};

struct __pyx_obj_4dnet___addr_ip4_iter {
  PyObject_HEAD
  unsigned long cur;
  unsigned long max;
};

struct __pyx_obj_4dnet_arp {
  PyObject_HEAD
  arp_t *arp;
};

struct __pyx_obj_4dnet_intf {
  PyObject_HEAD
  intf_t *intf;
};

struct __pyx_obj_4dnet_route {
  PyObject_HEAD
  route_t *route;
};

struct __pyx_obj_4dnet_fw {
  PyObject_HEAD
  fw_t *fw;
};

struct __pyx_obj_4dnet_rand {
  PyObject_HEAD
  rand_t *rand;
};

enum  {
  __pyx_e_4dnet_TEADELTA = 0x9e3779b9,
  __pyx_e_4dnet_TEAROUNDS = 32,
  __pyx_e_4dnet_TEASBOXSIZE = 128,
  __pyx_e_4dnet_TEASBOXSHIFT = 7
};

struct __pyx_obj_4dnet___rand_xrange {
  PyObject_HEAD
  rand_t *rand;
  unsigned long cur;
  unsigned long enc;
  unsigned long max;
  unsigned long mask;
  unsigned long start;
  unsigned long sboxmask;
  unsigned int sbox[128];
  int left;
  int right;
  int kshift;
};

struct __pyx_obj_4dnet_tun {
  PyObject_HEAD
  tun_t *tun;
  char *buf;
  int mtu;
};












static PyTypeObject *__pyx_ptype_4dnet_eth = 0;
static PyTypeObject *__pyx_ptype_4dnet_ip = 0;
static PyTypeObject *__pyx_ptype_4dnet_addr = 0;
static PyTypeObject *__pyx_ptype_4dnet___addr_ip4_iter = 0;
static PyTypeObject *__pyx_ptype_4dnet_arp = 0;
static PyTypeObject *__pyx_ptype_4dnet_intf = 0;
static PyTypeObject *__pyx_ptype_4dnet_route = 0;
static PyTypeObject *__pyx_ptype_4dnet_fw = 0;
static PyTypeObject *__pyx_ptype_4dnet_rand = 0;
static PyTypeObject *__pyx_ptype_4dnet___rand_xrange = 0;
static PyTypeObject *__pyx_ptype_4dnet_tun = 0;
static PyObject *__pyx_f_4dnet___memcpy(char *,PyObject *,int); /*proto*/
static PyObject *__pyx_f_4dnet___oserror(void); /*proto*/
static int __pyx_f_4dnet___arp_callback(struct arp_entry *,void *); /*proto*/
static PyObject *__pyx_f_4dnet_ifent_to_dict(struct intf_entry *); /*proto*/
static PyObject *__pyx_f_4dnet_dict_to_ifent(PyObject *,struct intf_entry *); /*proto*/
static int __pyx_f_4dnet___intf_callback(struct intf_entry *,void *); /*proto*/
static int __pyx_f_4dnet___route_callback(struct route_entry *,void *); /*proto*/
static PyObject *__pyx_f_4dnet_rule_to_dict(struct fw_rule *); /*proto*/
static PyObject *__pyx_f_4dnet_dict_to_rule(PyObject *,struct fw_rule *); /*proto*/
static int __pyx_f_4dnet___fw_callback(struct fw_rule *,void *); /*proto*/

static char __pyx_k1[] = "not a %d-byte binary string: %r";
static char __pyx_k2[] = "errno";
static char __pyx_k3[] = "append";
static char __pyx_k4[] = "invalid Ethernet address";
static char __pyx_k5[] = "invalid IP address";
static char __pyx_k6[] = "invalid IPv6 address";
static char __pyx_k7[] = "ADDR_TYPE_IP";
static char __pyx_k8[] = "IP_ADDR_BITS";
static char __pyx_k9[] = "ip";
static char __pyx_k10[] = "invalid network address";
static char __pyx_k11[] = "ADDR_TYPE_ETH";
static char __pyx_k12[] = "eth";
static char __pyx_k13[] = "ADDR_TYPE_IP6";
static char __pyx_k14[] = "ip6";
static char __pyx_k15[] = "non-Ethernet address";
static char __pyx_k16[] = "ETH_ADDR_LEN";
static char __pyx_k17[] = "not a 6-byte string";
static char __pyx_k18[] = "ETH_ADDR_BITS";
static char __pyx_k19[] = "non-IP address";
static char __pyx_k20[] = "IP_ADDR_LEN";
static char __pyx_k21[] = "not a 4-byte string";
static char __pyx_k22[] = "non-IPv6 address";
static char __pyx_k23[] = "IP6_ADDR_LEN";
static char __pyx_k24[] = "not a 16-byte string";
static char __pyx_k25[] = "IP6_ADDR_BITS";
static char __pyx_k26[] = "__copy__";
static char __pyx_k27[] = "__int__";
static char __pyx_k28[] = "<invalid network address>";
static char __pyx_k29[] = "loop";
static char __pyx_k30[] = "__iter_append";
static char __pyx_k31[] = "name";
static char __pyx_k32[] = "type";
static char __pyx_k33[] = "flags";
static char __pyx_k34[] = "mtu";
static char __pyx_k35[] = "ADDR_TYPE_NONE";
static char __pyx_k36[] = "addr";
static char __pyx_k37[] = "dst_addr";
static char __pyx_k38[] = "link_addr";
static char __pyx_k39[] = "alias_addrs";
static char __pyx_k40[] = "device";
static char __pyx_k41[] = "op";
static char __pyx_k42[] = "dir";
static char __pyx_k43[] = "proto";
static char __pyx_k44[] = "src";
static char __pyx_k45[] = "dst";
static char __pyx_k46[] = "sport";
static char __pyx_k47[] = "dport";
static char __pyx_k48[] = "IP_PROTO_TCP";
static char __pyx_k49[] = "IP_PROTO_UDP";
static char __pyx_k50[] = "start must be an integer";
static char __pyx_k51[] = "stop must be an integer";
static char __pyx_k52[] = "Address type (ADDR_TYPE_*) integer.";
static char __pyx_k53[] = "Address bitlength integer.";
static char __pyx_k54[] = "Raw address string.";
static char __pyx_k55[] = "Ethernet MAC address as binary string.";
static char __pyx_k56[] = "IPv4 address as binary string.";
static char __pyx_k57[] = "IPv6 address as binary string.";
static char __pyx_k58[] = "Tunnel interface name.";
static char __pyx_k59[] = "File descriptor for tunnel handle.";
static char __pyx_k60[] = "Dug Song <dugsong@monkey.org>";
static char __pyx_k61[] = "__author__";
static char __pyx_k62[] = "Copyright (c) 2003 Dug Song";
static char __pyx_k63[] = "__copyright__";
static char __pyx_k64[] = "BSD";
static char __pyx_k65[] = "__license__";
static char __pyx_k66[] = "http://libdnet.sourceforge.net/";
static char __pyx_k67[] = "__url__";
static char __pyx_k68[] = "1.12";
static char __pyx_k69[] = "__version__";
static char __pyx_k70[] = "ETH_TYPE_LEN";
static char __pyx_k71[] = "ETH_CRC_LEN";
static char __pyx_k72[] = "ETH_HDR_LEN";
static char __pyx_k73[] = "ETH_LEN_MIN";
static char __pyx_k74[] = "ETH_LEN_MAX";
static char __pyx_k75[] = "ETH_MTU";
static char __pyx_k76[] = "ETH_MIN";
static char __pyx_k77[] = "ETH_TYPE_PUP";
static char __pyx_k78[] = "ETH_TYPE_IP";
static char __pyx_k79[] = "ETH_TYPE_ARP";
static char __pyx_k80[] = "ETH_TYPE_REVARP";
static char __pyx_k81[] = "ETH_TYPE_8021Q";
static char __pyx_k82[] = "ETH_TYPE_IPV6";
static char __pyx_k83[] = "ETH_TYPE_MPLS";
static char __pyx_k84[] = "ETH_TYPE_MPLS_MCAST";
static char __pyx_k85[] = "ETH_TYPE_PPPOEDISC";
static char __pyx_k86[] = "ETH_TYPE_PPPOE";
static char __pyx_k87[] = "ETH_TYPE_LOOPBACK";
static char __pyx_k88[] = "\x000\x000\x000\x000\x000\x000";
static char __pyx_k89[] = "ETH_ADDR_UNSPEC";
static char __pyx_k90[] = "\x0ff\x0ff\x0ff\x0ff\x0ff\x0ff";
static char __pyx_k91[] = "ETH_ADDR_BROADCAST";
static char __pyx_k92[] = "IP_HDR_LEN";
static char __pyx_k93[] = "IP_OPT_LEN";
static char __pyx_k94[] = "IP_OPT_LEN_MAX";
static char __pyx_k95[] = "IP_HDR_LEN_MAX";
static char __pyx_k96[] = "IP_LEN_MAX";
static char __pyx_k97[] = "IP_LEN_MIN";
static char __pyx_k98[] = "IP_TOS_DEFAULT";
static char __pyx_k99[] = "IP_RF";
static char __pyx_k100[] = "IP_DF";
static char __pyx_k101[] = "IP_MF";
static char __pyx_k102[] = "IP_OFFMASK";
static char __pyx_k103[] = "IP_TTL_DEFAULT";
static char __pyx_k104[] = "IP_TTL_MAX";
static char __pyx_k105[] = "IP_PROTO_IP";
static char __pyx_k106[] = "IP_PROTO_ICMP";
static char __pyx_k107[] = "IP_PROTO_IGMP";
static char __pyx_k108[] = "IP_PROTO_IPV6";
static char __pyx_k109[] = "IP_PROTO_GRE";
static char __pyx_k110[] = "IP_PROTO_ESP";
static char __pyx_k111[] = "IP_PROTO_AH";
static char __pyx_k112[] = "IP_PROTO_ICMPV6";
static char __pyx_k113[] = "IP_PROTO_RAW";
static char __pyx_k114[] = "IP_PROTO_RESERVED";
static char __pyx_k115[] = "IP_PROTO_MAX";
static char __pyx_k116[] = "\x000\x000\x000\x000";
static char __pyx_k117[] = "IP_ADDR_ANY";
static char __pyx_k118[] = "\x0ff\x0ff\x0ff\x0ff";
static char __pyx_k119[] = "IP_ADDR_BROADCAST";
static char __pyx_k120[] = "\x07f\x000\x000\x001";
static char __pyx_k121[] = "IP_ADDR_LOOPBACK";
static char __pyx_k122[] = "\x0e0\x000\x000\x001";
static char __pyx_k123[] = "IP_ADDR_MCAST_ALL";
static char __pyx_k124[] = "\x0e0\x000\x000\x0ff";
static char __pyx_k125[] = "IP_ADDR_MCAST_LOCAL";
static char __pyx_k126[] = "IP6_HDR_LEN";
static char __pyx_k127[] = "IP6_LEN_MIN";
static char __pyx_k128[] = "IP6_LEN_MAX";
static char __pyx_k129[] = "IP6_MTU_MIN";
static char __pyx_k130[] = "IP6_HLIM_DEFAULT";
static char __pyx_k131[] = "IP6_HLIM_MAX";
static char __pyx_k132[] = "\x000\x000\x000\x000\x000\x000\x000\x000\x000\x000\x000\x000\x000\x000\x000\x000";
static char __pyx_k133[] = "IP6_ADDR_UNSPEC";
static char __pyx_k134[] = "\x000\x000\x000\x000\x000\x000\x000\x000\x000\x000\x000\x000\x000\x000\x000\x001";
static char __pyx_k135[] = "IP6_ADDR_LOOPBACK";
static char __pyx_k136[] = "ARP_HDR_LEN";
static char __pyx_k137[] = "ARP_ETHIP_LEN";
static char __pyx_k138[] = "ARP_HRD_ETH";
static char __pyx_k139[] = "ARP_HRD_IEEE802";
static char __pyx_k140[] = "ARP_PRO_IP";
static char __pyx_k141[] = "ARP_OP_REQUEST";
static char __pyx_k142[] = "ARP_OP_REPLY";
static char __pyx_k143[] = "ARP_OP_REVREQUEST";
static char __pyx_k144[] = "ARP_OP_REVREPLY";
static char __pyx_k145[] = "TCP_HDR_LEN";
static char __pyx_k146[] = "TH_FIN";
static char __pyx_k147[] = "TH_SYN";
static char __pyx_k148[] = "TH_RST";
static char __pyx_k149[] = "TH_PUSH";
static char __pyx_k150[] = "TH_ACK";
static char __pyx_k151[] = "TH_URG";
static char __pyx_k152[] = "TH_ECE";
static char __pyx_k153[] = "TH_CWR";
static char __pyx_k154[] = "TCP_PORT_MAX";
static char __pyx_k155[] = "TCP_WIN_MAX";
static char __pyx_k156[] = "TCP_OPT_EOL";
static char __pyx_k157[] = "TCP_OPT_NOP";
static char __pyx_k158[] = "TCP_OPT_MSS";
static char __pyx_k159[] = "TCP_OPT_WSCALE";
static char __pyx_k160[] = "TCP_OPT_SACKOK";
static char __pyx_k161[] = "TCP_OPT_SACK";
static char __pyx_k162[] = "TCP_OPT_ECHO";
static char __pyx_k163[] = "TCP_OPT_ECHOREPLY";
static char __pyx_k164[] = "TCP_OPT_TIMESTAMP";
static char __pyx_k165[] = "TCP_OPT_POCONN";
static char __pyx_k166[] = "TCP_OPT_POSVC";
static char __pyx_k167[] = "TCP_OPT_CC";
static char __pyx_k168[] = "TCP_OPT_CCNEW";
static char __pyx_k169[] = "TCP_OPT_CCECHO";
static char __pyx_k170[] = "TCP_OPT_ALTSUM";
static char __pyx_k171[] = "TCP_OPT_ALTSUMDATA";
static char __pyx_k172[] = "TCP_OPT_SKEETER";
static char __pyx_k173[] = "TCP_OPT_BUBBA";
static char __pyx_k174[] = "TCP_OPT_TRAILSUM";
static char __pyx_k175[] = "TCP_OPT_MD5";
static char __pyx_k176[] = "TCP_OPT_SCPS";
static char __pyx_k177[] = "TCP_OPT_SNACK";
static char __pyx_k178[] = "TCP_OPT_REC";
static char __pyx_k179[] = "TCP_OPT_CORRUPT";
static char __pyx_k180[] = "TCP_OPT_SNAP";
static char __pyx_k181[] = "TCP_OPT_TCPCOMP";
static char __pyx_k182[] = "TCP_OPT_MAX";
static char __pyx_k183[] = "UDP_HDR_LEN";
static char __pyx_k184[] = "UDP_PORT_MAX";
static char __pyx_k185[] = "INTF_TYPE_OTHER";
static char __pyx_k186[] = "INTF_TYPE_ETH";
static char __pyx_k187[] = "INTF_TYPE_LOOPBACK";
static char __pyx_k188[] = "INTF_TYPE_TUN";
static char __pyx_k189[] = "INTF_FLAG_UP";
static char __pyx_k190[] = "INTF_FLAG_LOOPBACK";
static char __pyx_k191[] = "INTF_FLAG_POINTOPOINT";
static char __pyx_k192[] = "INTF_FLAG_NOARP";
static char __pyx_k193[] = "INTF_FLAG_BROADCAST";
static char __pyx_k194[] = "INTF_FLAG_MULTICAST";
static char __pyx_k195[] = "FW_OP_ALLOW";
static char __pyx_k196[] = "FW_OP_BLOCK";
static char __pyx_k197[] = "FW_DIR_IN";
static char __pyx_k198[] = "FW_DIR_OUT";

static PyObject *__pyx_n_ADDR_TYPE_ETH;
static PyObject *__pyx_n_ADDR_TYPE_IP;
static PyObject *__pyx_n_ADDR_TYPE_IP6;
static PyObject *__pyx_n_ADDR_TYPE_NONE;
static PyObject *__pyx_n_ARP_ETHIP_LEN;
static PyObject *__pyx_n_ARP_HDR_LEN;
static PyObject *__pyx_n_ARP_HRD_ETH;
static PyObject *__pyx_n_ARP_HRD_IEEE802;
static PyObject *__pyx_n_ARP_OP_REPLY;
static PyObject *__pyx_n_ARP_OP_REQUEST;
static PyObject *__pyx_n_ARP_OP_REVREPLY;
static PyObject *__pyx_n_ARP_OP_REVREQUEST;
static PyObject *__pyx_n_ARP_PRO_IP;
static PyObject *__pyx_n_BSD;
static PyObject *__pyx_n_ETH_ADDR_BITS;
static PyObject *__pyx_n_ETH_ADDR_BROADCAST;
static PyObject *__pyx_n_ETH_ADDR_LEN;
static PyObject *__pyx_n_ETH_ADDR_UNSPEC;
static PyObject *__pyx_n_ETH_CRC_LEN;
static PyObject *__pyx_n_ETH_HDR_LEN;
static PyObject *__pyx_n_ETH_LEN_MAX;
static PyObject *__pyx_n_ETH_LEN_MIN;
static PyObject *__pyx_n_ETH_MIN;
static PyObject *__pyx_n_ETH_MTU;
static PyObject *__pyx_n_ETH_TYPE_8021Q;
static PyObject *__pyx_n_ETH_TYPE_ARP;
static PyObject *__pyx_n_ETH_TYPE_IP;
static PyObject *__pyx_n_ETH_TYPE_IPV6;
static PyObject *__pyx_n_ETH_TYPE_LEN;
static PyObject *__pyx_n_ETH_TYPE_LOOPBACK;
static PyObject *__pyx_n_ETH_TYPE_MPLS;
static PyObject *__pyx_n_ETH_TYPE_MPLS_MCAST;
static PyObject *__pyx_n_ETH_TYPE_PPPOE;
static PyObject *__pyx_n_ETH_TYPE_PPPOEDISC;
static PyObject *__pyx_n_ETH_TYPE_PUP;
static PyObject *__pyx_n_ETH_TYPE_REVARP;
static PyObject *__pyx_n_FW_DIR_IN;
static PyObject *__pyx_n_FW_DIR_OUT;
static PyObject *__pyx_n_FW_OP_ALLOW;
static PyObject *__pyx_n_FW_OP_BLOCK;
static PyObject *__pyx_n_INTF_FLAG_BROADCAST;
static PyObject *__pyx_n_INTF_FLAG_LOOPBACK;
static PyObject *__pyx_n_INTF_FLAG_MULTICAST;
static PyObject *__pyx_n_INTF_FLAG_NOARP;
static PyObject *__pyx_n_INTF_FLAG_POINTOPOINT;
static PyObject *__pyx_n_INTF_FLAG_UP;
static PyObject *__pyx_n_INTF_TYPE_ETH;
static PyObject *__pyx_n_INTF_TYPE_LOOPBACK;
static PyObject *__pyx_n_INTF_TYPE_OTHER;
static PyObject *__pyx_n_INTF_TYPE_TUN;
static PyObject *__pyx_n_IP6_ADDR_BITS;
static PyObject *__pyx_n_IP6_ADDR_LEN;
static PyObject *__pyx_n_IP6_ADDR_LOOPBACK;
static PyObject *__pyx_n_IP6_ADDR_UNSPEC;
static PyObject *__pyx_n_IP6_HDR_LEN;
static PyObject *__pyx_n_IP6_HLIM_DEFAULT;
static PyObject *__pyx_n_IP6_HLIM_MAX;
static PyObject *__pyx_n_IP6_LEN_MAX;
static PyObject *__pyx_n_IP6_LEN_MIN;
static PyObject *__pyx_n_IP6_MTU_MIN;
static PyObject *__pyx_n_IP_ADDR_ANY;
static PyObject *__pyx_n_IP_ADDR_BITS;
static PyObject *__pyx_n_IP_ADDR_BROADCAST;
static PyObject *__pyx_n_IP_ADDR_LEN;
static PyObject *__pyx_n_IP_ADDR_LOOPBACK;
static PyObject *__pyx_n_IP_ADDR_MCAST_ALL;
static PyObject *__pyx_n_IP_ADDR_MCAST_LOCAL;
static PyObject *__pyx_n_IP_DF;
static PyObject *__pyx_n_IP_HDR_LEN;
static PyObject *__pyx_n_IP_HDR_LEN_MAX;
static PyObject *__pyx_n_IP_LEN_MAX;
static PyObject *__pyx_n_IP_LEN_MIN;
static PyObject *__pyx_n_IP_MF;
static PyObject *__pyx_n_IP_OFFMASK;
static PyObject *__pyx_n_IP_OPT_LEN;
static PyObject *__pyx_n_IP_OPT_LEN_MAX;
static PyObject *__pyx_n_IP_PROTO_AH;
static PyObject *__pyx_n_IP_PROTO_ESP;
static PyObject *__pyx_n_IP_PROTO_GRE;
static PyObject *__pyx_n_IP_PROTO_ICMP;
static PyObject *__pyx_n_IP_PROTO_ICMPV6;
static PyObject *__pyx_n_IP_PROTO_IGMP;
static PyObject *__pyx_n_IP_PROTO_IP;
static PyObject *__pyx_n_IP_PROTO_IPV6;
static PyObject *__pyx_n_IP_PROTO_MAX;
static PyObject *__pyx_n_IP_PROTO_RAW;
static PyObject *__pyx_n_IP_PROTO_RESERVED;
static PyObject *__pyx_n_IP_PROTO_TCP;
static PyObject *__pyx_n_IP_PROTO_UDP;
static PyObject *__pyx_n_IP_RF;
static PyObject *__pyx_n_IP_TOS_DEFAULT;
static PyObject *__pyx_n_IP_TTL_DEFAULT;
static PyObject *__pyx_n_IP_TTL_MAX;
static PyObject *__pyx_n_TCP_HDR_LEN;
static PyObject *__pyx_n_TCP_OPT_ALTSUM;
static PyObject *__pyx_n_TCP_OPT_ALTSUMDATA;
static PyObject *__pyx_n_TCP_OPT_BUBBA;
static PyObject *__pyx_n_TCP_OPT_CC;
static PyObject *__pyx_n_TCP_OPT_CCECHO;
static PyObject *__pyx_n_TCP_OPT_CCNEW;
static PyObject *__pyx_n_TCP_OPT_CORRUPT;
static PyObject *__pyx_n_TCP_OPT_ECHO;
static PyObject *__pyx_n_TCP_OPT_ECHOREPLY;
static PyObject *__pyx_n_TCP_OPT_EOL;
static PyObject *__pyx_n_TCP_OPT_MAX;
static PyObject *__pyx_n_TCP_OPT_MD5;
static PyObject *__pyx_n_TCP_OPT_MSS;
static PyObject *__pyx_n_TCP_OPT_NOP;
static PyObject *__pyx_n_TCP_OPT_POCONN;
static PyObject *__pyx_n_TCP_OPT_POSVC;
static PyObject *__pyx_n_TCP_OPT_REC;
static PyObject *__pyx_n_TCP_OPT_SACK;
static PyObject *__pyx_n_TCP_OPT_SACKOK;
static PyObject *__pyx_n_TCP_OPT_SCPS;
static PyObject *__pyx_n_TCP_OPT_SKEETER;
static PyObject *__pyx_n_TCP_OPT_SNACK;
static PyObject *__pyx_n_TCP_OPT_SNAP;
static PyObject *__pyx_n_TCP_OPT_TCPCOMP;
static PyObject *__pyx_n_TCP_OPT_TIMESTAMP;
static PyObject *__pyx_n_TCP_OPT_TRAILSUM;
static PyObject *__pyx_n_TCP_OPT_WSCALE;
static PyObject *__pyx_n_TCP_PORT_MAX;
static PyObject *__pyx_n_TCP_WIN_MAX;
static PyObject *__pyx_n_TH_ACK;
static PyObject *__pyx_n_TH_CWR;
static PyObject *__pyx_n_TH_ECE;
static PyObject *__pyx_n_TH_FIN;
static PyObject *__pyx_n_TH_PUSH;
static PyObject *__pyx_n_TH_RST;
static PyObject *__pyx_n_TH_SYN;
static PyObject *__pyx_n_TH_URG;
static PyObject *__pyx_n_UDP_HDR_LEN;
static PyObject *__pyx_n_UDP_PORT_MAX;
static PyObject *__pyx_n___author__;
static PyObject *__pyx_n___copy__;
static PyObject *__pyx_n___copyright__;
static PyObject *__pyx_n___int__;
static PyObject *__pyx_n___iter_append;
static PyObject *__pyx_n___license__;
static PyObject *__pyx_n___url__;
static PyObject *__pyx_n___version__;
static PyObject *__pyx_n_addr;
static PyObject *__pyx_n_alias_addrs;
static PyObject *__pyx_n_append;
static PyObject *__pyx_n_device;
static PyObject *__pyx_n_dir;
static PyObject *__pyx_n_dport;
static PyObject *__pyx_n_dst;
static PyObject *__pyx_n_dst_addr;
static PyObject *__pyx_n_errno;
static PyObject *__pyx_n_eth;
static PyObject *__pyx_n_flags;
static PyObject *__pyx_n_ip;
static PyObject *__pyx_n_ip6;
static PyObject *__pyx_n_link_addr;
static PyObject *__pyx_n_loop;
static PyObject *__pyx_n_mtu;
static PyObject *__pyx_n_name;
static PyObject *__pyx_n_op;
static PyObject *__pyx_n_proto;
static PyObject *__pyx_n_sport;
static PyObject *__pyx_n_src;
static PyObject *__pyx_n_type;

static PyObject *__pyx_k1p;
static PyObject *__pyx_k4p;
static PyObject *__pyx_k5p;
static PyObject *__pyx_k6p;
static PyObject *__pyx_k10p;
static PyObject *__pyx_k15p;
static PyObject *__pyx_k17p;
static PyObject *__pyx_k19p;
static PyObject *__pyx_k21p;
static PyObject *__pyx_k22p;
static PyObject *__pyx_k24p;
static PyObject *__pyx_k28p;
static PyObject *__pyx_k50p;
static PyObject *__pyx_k51p;
static PyObject *__pyx_k60p;
static PyObject *__pyx_k62p;
static PyObject *__pyx_k66p;
static PyObject *__pyx_k68p;

static __Pyx_StringTabEntry __pyx_string_tab[] = {
  {&__pyx_n_ADDR_TYPE_ETH, 1, __pyx_k11, sizeof(__pyx_k11)},
  {&__pyx_n_ADDR_TYPE_IP, 1, __pyx_k7, sizeof(__pyx_k7)},
  {&__pyx_n_ADDR_TYPE_IP6, 1, __pyx_k13, sizeof(__pyx_k13)},
  {&__pyx_n_ADDR_TYPE_NONE, 1, __pyx_k35, sizeof(__pyx_k35)},
  {&__pyx_n_ARP_ETHIP_LEN, 1, __pyx_k137, sizeof(__pyx_k137)},
  {&__pyx_n_ARP_HDR_LEN, 1, __pyx_k136, sizeof(__pyx_k136)},
  {&__pyx_n_ARP_HRD_ETH, 1, __pyx_k138, sizeof(__pyx_k138)},
  {&__pyx_n_ARP_HRD_IEEE802, 1, __pyx_k139, sizeof(__pyx_k139)},
  {&__pyx_n_ARP_OP_REPLY, 1, __pyx_k142, sizeof(__pyx_k142)},
  {&__pyx_n_ARP_OP_REQUEST, 1, __pyx_k141, sizeof(__pyx_k141)},
  {&__pyx_n_ARP_OP_REVREPLY, 1, __pyx_k144, sizeof(__pyx_k144)},
  {&__pyx_n_ARP_OP_REVREQUEST, 1, __pyx_k143, sizeof(__pyx_k143)},
  {&__pyx_n_ARP_PRO_IP, 1, __pyx_k140, sizeof(__pyx_k140)},
  {&__pyx_n_BSD, 1, __pyx_k64, sizeof(__pyx_k64)},
  {&__pyx_n_ETH_ADDR_BITS, 1, __pyx_k18, sizeof(__pyx_k18)},
  {&__pyx_n_ETH_ADDR_BROADCAST, 1, __pyx_k91, sizeof(__pyx_k91)},
  {&__pyx_n_ETH_ADDR_LEN, 1, __pyx_k16, sizeof(__pyx_k16)},
  {&__pyx_n_ETH_ADDR_UNSPEC, 1, __pyx_k89, sizeof(__pyx_k89)},
  {&__pyx_n_ETH_CRC_LEN, 1, __pyx_k71, sizeof(__pyx_k71)},
  {&__pyx_n_ETH_HDR_LEN, 1, __pyx_k72, sizeof(__pyx_k72)},
  {&__pyx_n_ETH_LEN_MAX, 1, __pyx_k74, sizeof(__pyx_k74)},
  {&__pyx_n_ETH_LEN_MIN, 1, __pyx_k73, sizeof(__pyx_k73)},
  {&__pyx_n_ETH_MIN, 1, __pyx_k76, sizeof(__pyx_k76)},
  {&__pyx_n_ETH_MTU, 1, __pyx_k75, sizeof(__pyx_k75)},
  {&__pyx_n_ETH_TYPE_8021Q, 1, __pyx_k81, sizeof(__pyx_k81)},
  {&__pyx_n_ETH_TYPE_ARP, 1, __pyx_k79, sizeof(__pyx_k79)},
  {&__pyx_n_ETH_TYPE_IP, 1, __pyx_k78, sizeof(__pyx_k78)},
  {&__pyx_n_ETH_TYPE_IPV6, 1, __pyx_k82, sizeof(__pyx_k82)},
  {&__pyx_n_ETH_TYPE_LEN, 1, __pyx_k70, sizeof(__pyx_k70)},
  {&__pyx_n_ETH_TYPE_LOOPBACK, 1, __pyx_k87, sizeof(__pyx_k87)},
  {&__pyx_n_ETH_TYPE_MPLS, 1, __pyx_k83, sizeof(__pyx_k83)},
  {&__pyx_n_ETH_TYPE_MPLS_MCAST, 1, __pyx_k84, sizeof(__pyx_k84)},
  {&__pyx_n_ETH_TYPE_PPPOE, 1, __pyx_k86, sizeof(__pyx_k86)},
  {&__pyx_n_ETH_TYPE_PPPOEDISC, 1, __pyx_k85, sizeof(__pyx_k85)},
  {&__pyx_n_ETH_TYPE_PUP, 1, __pyx_k77, sizeof(__pyx_k77)},
  {&__pyx_n_ETH_TYPE_REVARP, 1, __pyx_k80, sizeof(__pyx_k80)},
  {&__pyx_n_FW_DIR_IN, 1, __pyx_k197, sizeof(__pyx_k197)},
  {&__pyx_n_FW_DIR_OUT, 1, __pyx_k198, sizeof(__pyx_k198)},
  {&__pyx_n_FW_OP_ALLOW, 1, __pyx_k195, sizeof(__pyx_k195)},
  {&__pyx_n_FW_OP_BLOCK, 1, __pyx_k196, sizeof(__pyx_k196)},
  {&__pyx_n_INTF_FLAG_BROADCAST, 1, __pyx_k193, sizeof(__pyx_k193)},
  {&__pyx_n_INTF_FLAG_LOOPBACK, 1, __pyx_k190, sizeof(__pyx_k190)},
  {&__pyx_n_INTF_FLAG_MULTICAST, 1, __pyx_k194, sizeof(__pyx_k194)},
  {&__pyx_n_INTF_FLAG_NOARP, 1, __pyx_k192, sizeof(__pyx_k192)},
  {&__pyx_n_INTF_FLAG_POINTOPOINT, 1, __pyx_k191, sizeof(__pyx_k191)},
  {&__pyx_n_INTF_FLAG_UP, 1, __pyx_k189, sizeof(__pyx_k189)},
  {&__pyx_n_INTF_TYPE_ETH, 1, __pyx_k186, sizeof(__pyx_k186)},
  {&__pyx_n_INTF_TYPE_LOOPBACK, 1, __pyx_k187, sizeof(__pyx_k187)},
  {&__pyx_n_INTF_TYPE_OTHER, 1, __pyx_k185, sizeof(__pyx_k185)},
  {&__pyx_n_INTF_TYPE_TUN, 1, __pyx_k188, sizeof(__pyx_k188)},
  {&__pyx_n_IP6_ADDR_BITS, 1, __pyx_k25, sizeof(__pyx_k25)},
  {&__pyx_n_IP6_ADDR_LEN, 1, __pyx_k23, sizeof(__pyx_k23)},
  {&__pyx_n_IP6_ADDR_LOOPBACK, 1, __pyx_k135, sizeof(__pyx_k135)},
  {&__pyx_n_IP6_ADDR_UNSPEC, 1, __pyx_k133, sizeof(__pyx_k133)},
  {&__pyx_n_IP6_HDR_LEN, 1, __pyx_k126, sizeof(__pyx_k126)},
  {&__pyx_n_IP6_HLIM_DEFAULT, 1, __pyx_k130, sizeof(__pyx_k130)},
  {&__pyx_n_IP6_HLIM_MAX, 1, __pyx_k131, sizeof(__pyx_k131)},
  {&__pyx_n_IP6_LEN_MAX, 1, __pyx_k128, sizeof(__pyx_k128)},
  {&__pyx_n_IP6_LEN_MIN, 1, __pyx_k127, sizeof(__pyx_k127)},
  {&__pyx_n_IP6_MTU_MIN, 1, __pyx_k129, sizeof(__pyx_k129)},
  {&__pyx_n_IP_ADDR_ANY, 1, __pyx_k117, sizeof(__pyx_k117)},
  {&__pyx_n_IP_ADDR_BITS, 1, __pyx_k8, sizeof(__pyx_k8)},
  {&__pyx_n_IP_ADDR_BROADCAST, 1, __pyx_k119, sizeof(__pyx_k119)},
  {&__pyx_n_IP_ADDR_LEN, 1, __pyx_k20, sizeof(__pyx_k20)},
  {&__pyx_n_IP_ADDR_LOOPBACK, 1, __pyx_k121, sizeof(__pyx_k121)},
  {&__pyx_n_IP_ADDR_MCAST_ALL, 1, __pyx_k123, sizeof(__pyx_k123)},
  {&__pyx_n_IP_ADDR_MCAST_LOCAL, 1, __pyx_k125, sizeof(__pyx_k125)},
  {&__pyx_n_IP_DF, 1, __pyx_k100, sizeof(__pyx_k100)},
  {&__pyx_n_IP_HDR_LEN, 1, __pyx_k92, sizeof(__pyx_k92)},
  {&__pyx_n_IP_HDR_LEN_MAX, 1, __pyx_k95, sizeof(__pyx_k95)},
  {&__pyx_n_IP_LEN_MAX, 1, __pyx_k96, sizeof(__pyx_k96)},
  {&__pyx_n_IP_LEN_MIN, 1, __pyx_k97, sizeof(__pyx_k97)},
  {&__pyx_n_IP_MF, 1, __pyx_k101, sizeof(__pyx_k101)},
  {&__pyx_n_IP_OFFMASK, 1, __pyx_k102, sizeof(__pyx_k102)},
  {&__pyx_n_IP_OPT_LEN, 1, __pyx_k93, sizeof(__pyx_k93)},
  {&__pyx_n_IP_OPT_LEN_MAX, 1, __pyx_k94, sizeof(__pyx_k94)},
  {&__pyx_n_IP_PROTO_AH, 1, __pyx_k111, sizeof(__pyx_k111)},
  {&__pyx_n_IP_PROTO_ESP, 1, __pyx_k110, sizeof(__pyx_k110)},
  {&__pyx_n_IP_PROTO_GRE, 1, __pyx_k109, sizeof(__pyx_k109)},
  {&__pyx_n_IP_PROTO_ICMP, 1, __pyx_k106, sizeof(__pyx_k106)},
  {&__pyx_n_IP_PROTO_ICMPV6, 1, __pyx_k112, sizeof(__pyx_k112)},
  {&__pyx_n_IP_PROTO_IGMP, 1, __pyx_k107, sizeof(__pyx_k107)},
  {&__pyx_n_IP_PROTO_IP, 1, __pyx_k105, sizeof(__pyx_k105)},
  {&__pyx_n_IP_PROTO_IPV6, 1, __pyx_k108, sizeof(__pyx_k108)},
  {&__pyx_n_IP_PROTO_MAX, 1, __pyx_k115, sizeof(__pyx_k115)},
  {&__pyx_n_IP_PROTO_RAW, 1, __pyx_k113, sizeof(__pyx_k113)},
  {&__pyx_n_IP_PROTO_RESERVED, 1, __pyx_k114, sizeof(__pyx_k114)},
  {&__pyx_n_IP_PROTO_TCP, 1, __pyx_k48, sizeof(__pyx_k48)},
  {&__pyx_n_IP_PROTO_UDP, 1, __pyx_k49, sizeof(__pyx_k49)},
  {&__pyx_n_IP_RF, 1, __pyx_k99, sizeof(__pyx_k99)},
  {&__pyx_n_IP_TOS_DEFAULT, 1, __pyx_k98, sizeof(__pyx_k98)},
  {&__pyx_n_IP_TTL_DEFAULT, 1, __pyx_k103, sizeof(__pyx_k103)},
  {&__pyx_n_IP_TTL_MAX, 1, __pyx_k104, sizeof(__pyx_k104)},
  {&__pyx_n_TCP_HDR_LEN, 1, __pyx_k145, sizeof(__pyx_k145)},
  {&__pyx_n_TCP_OPT_ALTSUM, 1, __pyx_k170, sizeof(__pyx_k170)},
  {&__pyx_n_TCP_OPT_ALTSUMDATA, 1, __pyx_k171, sizeof(__pyx_k171)},
  {&__pyx_n_TCP_OPT_BUBBA, 1, __pyx_k173, sizeof(__pyx_k173)},
  {&__pyx_n_TCP_OPT_CC, 1, __pyx_k167, sizeof(__pyx_k167)},
  {&__pyx_n_TCP_OPT_CCECHO, 1, __pyx_k169, sizeof(__pyx_k169)},
  {&__pyx_n_TCP_OPT_CCNEW, 1, __pyx_k168, sizeof(__pyx_k168)},
  {&__pyx_n_TCP_OPT_CORRUPT, 1, __pyx_k179, sizeof(__pyx_k179)},
  {&__pyx_n_TCP_OPT_ECHO, 1, __pyx_k162, sizeof(__pyx_k162)},
  {&__pyx_n_TCP_OPT_ECHOREPLY, 1, __pyx_k163, sizeof(__pyx_k163)},
  {&__pyx_n_TCP_OPT_EOL, 1, __pyx_k156, sizeof(__pyx_k156)},
  {&__pyx_n_TCP_OPT_MAX, 1, __pyx_k182, sizeof(__pyx_k182)},
  {&__pyx_n_TCP_OPT_MD5, 1, __pyx_k175, sizeof(__pyx_k175)},
  {&__pyx_n_TCP_OPT_MSS, 1, __pyx_k158, sizeof(__pyx_k158)},
  {&__pyx_n_TCP_OPT_NOP, 1, __pyx_k157, sizeof(__pyx_k157)},
  {&__pyx_n_TCP_OPT_POCONN, 1, __pyx_k165, sizeof(__pyx_k165)},
  {&__pyx_n_TCP_OPT_POSVC, 1, __pyx_k166, sizeof(__pyx_k166)},
  {&__pyx_n_TCP_OPT_REC, 1, __pyx_k178, sizeof(__pyx_k178)},
  {&__pyx_n_TCP_OPT_SACK, 1, __pyx_k161, sizeof(__pyx_k161)},
  {&__pyx_n_TCP_OPT_SACKOK, 1, __pyx_k160, sizeof(__pyx_k160)},
  {&__pyx_n_TCP_OPT_SCPS, 1, __pyx_k176, sizeof(__pyx_k176)},
  {&__pyx_n_TCP_OPT_SKEETER, 1, __pyx_k172, sizeof(__pyx_k172)},
  {&__pyx_n_TCP_OPT_SNACK, 1, __pyx_k177, sizeof(__pyx_k177)},
  {&__pyx_n_TCP_OPT_SNAP, 1, __pyx_k180, sizeof(__pyx_k180)},
  {&__pyx_n_TCP_OPT_TCPCOMP, 1, __pyx_k181, sizeof(__pyx_k181)},
  {&__pyx_n_TCP_OPT_TIMESTAMP, 1, __pyx_k164, sizeof(__pyx_k164)},
  {&__pyx_n_TCP_OPT_TRAILSUM, 1, __pyx_k174, sizeof(__pyx_k174)},
  {&__pyx_n_TCP_OPT_WSCALE, 1, __pyx_k159, sizeof(__pyx_k159)},
  {&__pyx_n_TCP_PORT_MAX, 1, __pyx_k154, sizeof(__pyx_k154)},
  {&__pyx_n_TCP_WIN_MAX, 1, __pyx_k155, sizeof(__pyx_k155)},
  {&__pyx_n_TH_ACK, 1, __pyx_k150, sizeof(__pyx_k150)},
  {&__pyx_n_TH_CWR, 1, __pyx_k153, sizeof(__pyx_k153)},
  {&__pyx_n_TH_ECE, 1, __pyx_k152, sizeof(__pyx_k152)},
  {&__pyx_n_TH_FIN, 1, __pyx_k146, sizeof(__pyx_k146)},
  {&__pyx_n_TH_PUSH, 1, __pyx_k149, sizeof(__pyx_k149)},
  {&__pyx_n_TH_RST, 1, __pyx_k148, sizeof(__pyx_k148)},
  {&__pyx_n_TH_SYN, 1, __pyx_k147, sizeof(__pyx_k147)},
  {&__pyx_n_TH_URG, 1, __pyx_k151, sizeof(__pyx_k151)},
  {&__pyx_n_UDP_HDR_LEN, 1, __pyx_k183, sizeof(__pyx_k183)},
  {&__pyx_n_UDP_PORT_MAX, 1, __pyx_k184, sizeof(__pyx_k184)},
  {&__pyx_n___author__, 1, __pyx_k61, sizeof(__pyx_k61)},
  {&__pyx_n___copy__, 1, __pyx_k26, sizeof(__pyx_k26)},
  {&__pyx_n___copyright__, 1, __pyx_k63, sizeof(__pyx_k63)},
  {&__pyx_n___int__, 1, __pyx_k27, sizeof(__pyx_k27)},
  {&__pyx_n___iter_append, 1, __pyx_k30, sizeof(__pyx_k30)},
  {&__pyx_n___license__, 1, __pyx_k65, sizeof(__pyx_k65)},
  {&__pyx_n___url__, 1, __pyx_k67, sizeof(__pyx_k67)},
  {&__pyx_n___version__, 1, __pyx_k69, sizeof(__pyx_k69)},
  {&__pyx_n_addr, 1, __pyx_k36, sizeof(__pyx_k36)},
  {&__pyx_n_alias_addrs, 1, __pyx_k39, sizeof(__pyx_k39)},
  {&__pyx_n_append, 1, __pyx_k3, sizeof(__pyx_k3)},
  {&__pyx_n_device, 1, __pyx_k40, sizeof(__pyx_k40)},
  {&__pyx_n_dir, 1, __pyx_k42, sizeof(__pyx_k42)},
  {&__pyx_n_dport, 1, __pyx_k47, sizeof(__pyx_k47)},
  {&__pyx_n_dst, 1, __pyx_k45, sizeof(__pyx_k45)},
  {&__pyx_n_dst_addr, 1, __pyx_k37, sizeof(__pyx_k37)},
  {&__pyx_n_errno, 1, __pyx_k2, sizeof(__pyx_k2)},
  {&__pyx_n_eth, 1, __pyx_k12, sizeof(__pyx_k12)},
  {&__pyx_n_flags, 1, __pyx_k33, sizeof(__pyx_k33)},
  {&__pyx_n_ip, 1, __pyx_k9, sizeof(__pyx_k9)},
  {&__pyx_n_ip6, 1, __pyx_k14, sizeof(__pyx_k14)},
  {&__pyx_n_link_addr, 1, __pyx_k38, sizeof(__pyx_k38)},
  {&__pyx_n_loop, 1, __pyx_k29, sizeof(__pyx_k29)},
  {&__pyx_n_mtu, 1, __pyx_k34, sizeof(__pyx_k34)},
  {&__pyx_n_name, 1, __pyx_k31, sizeof(__pyx_k31)},
  {&__pyx_n_op, 1, __pyx_k41, sizeof(__pyx_k41)},
  {&__pyx_n_proto, 1, __pyx_k43, sizeof(__pyx_k43)},
  {&__pyx_n_sport, 1, __pyx_k46, sizeof(__pyx_k46)},
  {&__pyx_n_src, 1, __pyx_k44, sizeof(__pyx_k44)},
  {&__pyx_n_type, 1, __pyx_k32, sizeof(__pyx_k32)},
  {&__pyx_k1p, 0, __pyx_k1, sizeof(__pyx_k1)},
  {&__pyx_k4p, 0, __pyx_k4, sizeof(__pyx_k4)},
  {&__pyx_k5p, 0, __pyx_k5, sizeof(__pyx_k5)},
  {&__pyx_k6p, 0, __pyx_k6, sizeof(__pyx_k6)},
  {&__pyx_k10p, 0, __pyx_k10, sizeof(__pyx_k10)},
  {&__pyx_k15p, 0, __pyx_k15, sizeof(__pyx_k15)},
  {&__pyx_k17p, 0, __pyx_k17, sizeof(__pyx_k17)},
  {&__pyx_k19p, 0, __pyx_k19, sizeof(__pyx_k19)},
  {&__pyx_k21p, 0, __pyx_k21, sizeof(__pyx_k21)},
  {&__pyx_k22p, 0, __pyx_k22, sizeof(__pyx_k22)},
  {&__pyx_k24p, 0, __pyx_k24, sizeof(__pyx_k24)},
  {&__pyx_k28p, 0, __pyx_k28, sizeof(__pyx_k28)},
  {&__pyx_k50p, 0, __pyx_k50, sizeof(__pyx_k50)},
  {&__pyx_k51p, 0, __pyx_k51, sizeof(__pyx_k51)},
  {&__pyx_k60p, 0, __pyx_k60, sizeof(__pyx_k60)},
  {&__pyx_k62p, 0, __pyx_k62, sizeof(__pyx_k62)},
  {&__pyx_k66p, 0, __pyx_k66, sizeof(__pyx_k66)},
  {&__pyx_k68p, 0, __pyx_k68, sizeof(__pyx_k68)},
  {0, 0, 0, 0}
};

static PyObject *__pyx_d1;
static PyObject *__pyx_d2;
static PyObject *__pyx_d3;
static PyObject *__pyx_d4;
static PyObject *__pyx_d5;
static PyObject *__pyx_d6;
static PyObject *__pyx_d7;
static PyObject *__pyx_d8;
static PyObject *__pyx_d9;
static PyObject *__pyx_d10;
static PyObject *__pyx_d11;
static PyObject *__pyx_d12;
static PyObject *__pyx_d13;
static PyObject *__pyx_d14;
static PyObject *__pyx_d15;
static PyObject *__pyx_d16;
static PyObject *__pyx_d17;
static PyObject *__pyx_d18;
static PyObject *__pyx_d19;
static PyObject *__pyx_d20;
static PyObject *__pyx_d21;
static PyObject *__pyx_d22;
static PyObject *__pyx_d23;
static PyObject *__pyx_d24;
static PyObject *__pyx_d25;
static PyObject *__pyx_d26;
static PyObject *__pyx_d27;
static PyObject *__pyx_d28;
static PyObject *__pyx_d29;
static PyObject *__pyx_d30;
static PyObject *__pyx_d31;
static PyObject *__pyx_d32;
static PyObject *__pyx_d33;
static PyObject *__pyx_d34;
static PyObject *__pyx_d35;
static PyObject *__pyx_d36;
static PyObject *__pyx_d37;


/* Implementation of dnet */

static PyObject *__pyx_f_4dnet___memcpy(char *__pyx_v_dst,PyObject *__pyx_v_src,int __pyx_v_n) {
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  char *__pyx_4;
  Py_INCREF(__pyx_v_src);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":44 */
  __pyx_1 = (PyString_Size(__pyx_v_src) != __pyx_v_n);
  if (__pyx_1) {
    __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 45; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 45; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_v_src);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_v_src);
    __pyx_2 = 0;
    __pyx_2 = PyNumber_Remainder(__pyx_k1p, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 45; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __Pyx_Raise(PyExc_ValueError, __pyx_2, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 45; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":46 */
  __pyx_4 = PyString_AsString(__pyx_v_src); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 46; goto __pyx_L1;}
  memcpy(__pyx_v_dst,__pyx_4,__pyx_v_n);

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("dnet.__memcpy");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_src);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet___oserror(void) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_errno); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 49; goto __pyx_L1;}
  __pyx_2 = PyInt_AsLong(__pyx_1); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 49; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  __pyx_1 = PyString_FromString(strerror(__pyx_2)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 49; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.__oserror");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet___iter_append(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_4dnet___iter_append(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_entry = 0;
  PyObject *__pyx_v_l = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"entry","l",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_entry, &__pyx_v_l)) return 0;
  Py_INCREF(__pyx_v_entry);
  Py_INCREF(__pyx_v_l);
  __pyx_1 = PyObject_GetAttr(__pyx_v_l, __pyx_n_append); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 52; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 52; goto __pyx_L1;}
  Py_INCREF(__pyx_v_entry);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_entry);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 52; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("dnet.__iter_append");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_entry);
  Py_DECREF(__pyx_v_l);
  return __pyx_r;
}

static int __pyx_f_4dnet_3eth___init__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static int __pyx_f_4dnet_3eth___init__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_device = 0;
  int __pyx_r;
  char *__pyx_1;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"device",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_device)) return -1;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_device);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":109 */
  __pyx_1 = PyString_AsString(__pyx_v_device); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 109; goto __pyx_L1;}
  ((struct __pyx_obj_4dnet_eth *)__pyx_v_self)->eth = eth_open(__pyx_1);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":110 */
  __pyx_2 = (!(((struct __pyx_obj_4dnet_eth *)__pyx_v_self)->eth != 0));
  if (__pyx_2) {
    __pyx_3 = __pyx_f_4dnet___oserror(); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 111; goto __pyx_L1;}
    __Pyx_Raise(PyExc_OSError, __pyx_3, 0);
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 111; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("dnet.eth.__init__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_device);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_3eth_get(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_3eth_get[] = "Return the MAC address associated with the device as a\n        binary string.";
static PyObject *__pyx_f_4dnet_3eth_get(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  eth_addr_t __pyx_v_ea;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":117 */
  __pyx_1 = (eth_get(((struct __pyx_obj_4dnet_eth *)__pyx_v_self)->eth,(&__pyx_v_ea)) < 0);
  if (__pyx_1) {
    __pyx_2 = __pyx_f_4dnet___oserror(); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 118; goto __pyx_L1;}
    __Pyx_Raise(PyExc_OSError, __pyx_2, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 118; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":119 */
  __pyx_2 = PyString_FromStringAndSize(__pyx_v_ea.data,6); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 119; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.eth.get");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_3eth_set(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_3eth_set[] = "Set the MAC address for the device, returning 0 on success,\n        -1 on failure.\n        \n        Arguments:\n        eth_addr -- 6-byte binary string (e.g. \'\\x00\\xde\\xad\\xbe\\xef\\x00\')\n        ";
static PyObject *__pyx_f_4dnet_3eth_set(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_value = 0;
  eth_addr_t __pyx_v_ea;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  static char *__pyx_argnames[] = {"value",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_value)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_value);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":129 */
  __pyx_1 = __pyx_f_4dnet___memcpy(__pyx_v_ea.data,__pyx_v_value,6); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 129; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":130 */
  __pyx_2 = (eth_set(((struct __pyx_obj_4dnet_eth *)__pyx_v_self)->eth,(&__pyx_v_ea)) < 0);
  if (__pyx_2) {
    __pyx_1 = __pyx_f_4dnet___oserror(); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 131; goto __pyx_L1;}
    __Pyx_Raise(PyExc_OSError, __pyx_1, 0);
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 131; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.eth.set");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_value);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_3eth_send(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_3eth_send[] = "Send an Ethernet frame, returning the number of bytes sent\n        or -1 on failure.\n        \n        Arguments:\n        frame -- binary string representing an Ethernet frame\n        ";
static PyObject *__pyx_f_4dnet_3eth_send(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_frame = 0;
  PyObject *__pyx_r;
  char *__pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {"frame",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_frame)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_frame);
  __pyx_1 = PyString_AsString(__pyx_v_frame); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 140; goto __pyx_L1;}
  __pyx_2 = PyInt_FromLong(eth_send(((struct __pyx_obj_4dnet_eth *)__pyx_v_self)->eth,__pyx_1,PyString_Size(__pyx_v_frame))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 140; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.eth.send");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_frame);
  return __pyx_r;
}

static void __pyx_f_4dnet_3eth___dealloc__(PyObject *__pyx_v_self); /*proto*/
static void __pyx_f_4dnet_3eth___dealloc__(PyObject *__pyx_v_self) {
  int __pyx_1;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = (((struct __pyx_obj_4dnet_eth *)__pyx_v_self)->eth != 0);
  if (__pyx_1) {
    eth_close(((struct __pyx_obj_4dnet_eth *)__pyx_v_self)->eth);
    goto __pyx_L2;
  }
  __pyx_L2:;

  Py_DECREF(__pyx_v_self);
}

static PyObject *__pyx_f_4dnet_eth_ntoa(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_eth_ntoa[] = "Convert an Ethernet MAC address from 6-byte packed binary string to\n    a printable string (\'00:de:ad:be:ef:00\').";
static PyObject *__pyx_f_4dnet_eth_ntoa(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_buf = 0;
  eth_addr_t __pyx_v_ea;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"buf",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_buf)) return 0;
  Py_INCREF(__pyx_v_buf);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":150 */
  __pyx_1 = __pyx_f_4dnet___memcpy(__pyx_v_ea.data,__pyx_v_buf,6); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 150; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":151 */
  __pyx_1 = PyString_FromString(eth_ntoa((&__pyx_v_ea))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 151; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.eth_ntoa");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_buf);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_eth_aton(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_eth_aton[] = "Convert an Ethernet MAC address from a printable string to a\n    packed binary string (\'\\x00\\xde\\xad\\xbe\\xef\\x00\').";
static PyObject *__pyx_f_4dnet_eth_aton(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_buf = 0;
  eth_addr_t __pyx_v_ea;
  PyObject *__pyx_r;
  char *__pyx_1;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"buf",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_buf)) return 0;
  Py_INCREF(__pyx_v_buf);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":157 */
  __pyx_1 = PyString_AsString(__pyx_v_buf); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 157; goto __pyx_L1;}
  __pyx_2 = (eth_aton(__pyx_1,(&__pyx_v_ea)) < 0);
  if (__pyx_2) {
    __Pyx_Raise(PyExc_ValueError, __pyx_k4p, 0);
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 158; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":159 */
  __pyx_3 = PyString_FromStringAndSize(__pyx_v_ea.data,6); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 159; goto __pyx_L1;}
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("dnet.eth_aton");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_buf);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_eth_pack_hdr(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_eth_pack_hdr[] = "Return a packed binary string representing an Ethernet header.\n	\n    Keyword arguments:\n    dst  -- destination address			(6-byte binary string)\n    src  -- source address			(6-byte binary string)\n    type -- Ethernet payload type (ETH_TYPE_*)	(16-bit integer)\n    ";
static PyObject *__pyx_f_4dnet_eth_pack_hdr(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_dst = 0;
  PyObject *__pyx_v_src = 0;
  PyObject *__pyx_v_ptype = 0;
  char __pyx_v_hdr[14];
  eth_addr_t __pyx_v_s;
  eth_addr_t __pyx_v_d;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  static char *__pyx_argnames[] = {"dst","src","ptype",0};
  __pyx_v_dst = __pyx_d1;
  __pyx_v_src = __pyx_d2;
  __pyx_v_ptype = __pyx_d3;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|OOO", __pyx_argnames, &__pyx_v_dst, &__pyx_v_src, &__pyx_v_ptype)) return 0;
  Py_INCREF(__pyx_v_dst);
  Py_INCREF(__pyx_v_src);
  Py_INCREF(__pyx_v_ptype);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":172 */
  __pyx_1 = __pyx_f_4dnet___memcpy(__pyx_v_s.data,__pyx_v_src,6); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 172; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":173 */
  __pyx_1 = __pyx_f_4dnet___memcpy(__pyx_v_d.data,__pyx_v_dst,6); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 173; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":174 */
  __pyx_2 = PyInt_AsLong(__pyx_v_ptype); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 174; goto __pyx_L1;}
  eth_pack_hdr(__pyx_v_hdr,__pyx_v_d,__pyx_v_s,__pyx_2);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":175 */
  __pyx_1 = PyString_FromStringAndSize(__pyx_v_hdr,14); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 175; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.eth_pack_hdr");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_dst);
  Py_DECREF(__pyx_v_src);
  Py_DECREF(__pyx_v_ptype);
  return __pyx_r;
}

static int __pyx_f_4dnet_2ip___init__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static int __pyx_f_4dnet_2ip___init__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return -1;
  Py_INCREF(__pyx_v_self);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":247 */
  ((struct __pyx_obj_4dnet_ip *)__pyx_v_self)->ip = ip_open();

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":248 */
  __pyx_1 = (!(((struct __pyx_obj_4dnet_ip *)__pyx_v_self)->ip != 0));
  if (__pyx_1) {
    __pyx_2 = __pyx_f_4dnet___oserror(); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 249; goto __pyx_L1;}
    __Pyx_Raise(PyExc_OSError, __pyx_2, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 249; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.ip.__init__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_2ip_send(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_2ip_send[] = "Send an IP packet, returning the number of bytes sent\n        or -1 on failure.\n\n        Arguments:\n        pkt -- binary string representing an IP packet\n        ";
static PyObject *__pyx_f_4dnet_2ip_send(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_pkt = 0;
  PyObject *__pyx_r;
  char *__pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {"pkt",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_pkt)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_pkt);
  __pyx_1 = PyString_AsString(__pyx_v_pkt); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 258; goto __pyx_L1;}
  __pyx_2 = PyInt_FromLong(ip_send(((struct __pyx_obj_4dnet_ip *)__pyx_v_self)->ip,__pyx_1,PyString_Size(__pyx_v_pkt))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 258; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.ip.send");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_pkt);
  return __pyx_r;
}

static void __pyx_f_4dnet_2ip___dealloc__(PyObject *__pyx_v_self); /*proto*/
static void __pyx_f_4dnet_2ip___dealloc__(PyObject *__pyx_v_self) {
  int __pyx_1;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = (((struct __pyx_obj_4dnet_ip *)__pyx_v_self)->ip != 0);
  if (__pyx_1) {
    ip_close(((struct __pyx_obj_4dnet_ip *)__pyx_v_self)->ip);
    goto __pyx_L2;
  }
  __pyx_L2:;

  Py_DECREF(__pyx_v_self);
}

static PyObject *__pyx_f_4dnet_ip_ntoa(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_ip_ntoa[] = "Convert an IP address from a 4-byte packed binary string or\n    integer to a printable string (\'10.0.0.1\').";
static PyObject *__pyx_f_4dnet_ip_ntoa(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_buf = 0;
  ip_addr_t __pyx_v_ia;
  unsigned int __pyx_v_i;
  PyObject *__pyx_r;
  int __pyx_1;
  unsigned long __pyx_2;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"buf",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_buf)) return 0;
  Py_INCREF(__pyx_v_buf);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":270 */
  __pyx_1 = PyInt_Check(__pyx_v_buf);
  if (!__pyx_1) {
    __pyx_1 = PyLong_Check(__pyx_v_buf);
  }
  if (__pyx_1) {

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":271 */
    __pyx_2 = PyInt_AsUnsignedLongMask(__pyx_v_buf); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 271; goto __pyx_L1;}
    __pyx_v_i = ntohl(__pyx_2);

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":272 */
    memcpy(((char *)(&__pyx_v_ia)),((char *)(&__pyx_v_i)),4);
    goto __pyx_L2;
  }
  /*else*/ {
    __pyx_3 = __pyx_f_4dnet___memcpy(((char *)(&__pyx_v_ia)),__pyx_v_buf,4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 274; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":275 */
  __pyx_3 = PyString_FromString(ip_ntoa((&__pyx_v_ia))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 275; goto __pyx_L1;}
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("dnet.ip_ntoa");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_buf);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_ip_aton(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_ip_aton[] = "Convert an IP address from a printable string to a\n    packed binary string (\'\\x0a\\x00\\x00\\x01\').";
static PyObject *__pyx_f_4dnet_ip_aton(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_buf = 0;
  ip_addr_t __pyx_v_ia;
  PyObject *__pyx_r;
  char *__pyx_1;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"buf",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_buf)) return 0;
  Py_INCREF(__pyx_v_buf);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":281 */
  __pyx_1 = PyString_AsString(__pyx_v_buf); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 281; goto __pyx_L1;}
  __pyx_2 = (ip_aton(__pyx_1,(&__pyx_v_ia)) < 0);
  if (__pyx_2) {
    __Pyx_Raise(PyExc_ValueError, __pyx_k5p, 0);
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 282; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":283 */
  __pyx_3 = PyString_FromStringAndSize(((char *)(&__pyx_v_ia)),4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 283; goto __pyx_L1;}
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("dnet.ip_aton");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_buf);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_ip_checksum(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_ip_checksum[] = "Return packed binary string representing an IP packet \n    with the IP and transport-layer checksums set.\n    \n    Arguments:\n    pkt -- binary string representing an IP packet\n    ";
static PyObject *__pyx_f_4dnet_ip_checksum(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_pkt = 0;
  char __pyx_v_buf[2048];
  char *__pyx_v_p;
  int __pyx_v_n;
  PyObject *__pyx_v_s;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  char *__pyx_3;
  static char *__pyx_argnames[] = {"pkt",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_pkt)) return 0;
  Py_INCREF(__pyx_v_pkt);
  __pyx_v_s = Py_None; Py_INCREF(Py_None);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":295 */
  __pyx_1 = (PyObject_AsReadBuffer(__pyx_v_pkt,(&__pyx_v_p),(&__pyx_v_n)) == 0);
  if (__pyx_1) {

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":296 */
    __pyx_1 = (__pyx_v_n < 2048);
    if (__pyx_1) {

      /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":297 */
      memcpy(__pyx_v_buf,__pyx_v_p,__pyx_v_n);

      /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":298 */
      ip_checksum(__pyx_v_buf,__pyx_v_n);

      /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":299 */
      __pyx_2 = PyString_FromStringAndSize(__pyx_v_buf,__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 299; goto __pyx_L1;}
      __pyx_r = __pyx_2;
      __pyx_2 = 0;
      goto __pyx_L0;
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":300 */
    __pyx_v_p = malloc(__pyx_v_n);

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":301 */
    __pyx_3 = PyString_AsString(__pyx_v_pkt); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 301; goto __pyx_L1;}
    memcpy(__pyx_v_p,__pyx_3,__pyx_v_n);

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":302 */
    ip_checksum(__pyx_v_p,__pyx_v_n);

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":303 */
    __pyx_2 = PyString_FromStringAndSize(__pyx_v_p,__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 303; goto __pyx_L1;}
    Py_DECREF(__pyx_v_s);
    __pyx_v_s = __pyx_2;
    __pyx_2 = 0;

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":304 */
    free(__pyx_v_p);

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":305 */
    Py_INCREF(__pyx_v_s);
    __pyx_r = __pyx_v_s;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":306 */
  __Pyx_Raise(PyExc_TypeError, 0, 0);
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 306; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.ip_checksum");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_s);
  Py_DECREF(__pyx_v_pkt);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_ip_cksum_add(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_4dnet_ip_cksum_add(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_buf = 0;
  int __pyx_v_sum;
  char *__pyx_v_p;
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {"buf","sum",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "Oi", __pyx_argnames, &__pyx_v_buf, &__pyx_v_sum)) return 0;
  Py_INCREF(__pyx_v_buf);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":311 */
  __pyx_1 = (PyObject_AsReadBuffer(__pyx_v_buf,(&__pyx_v_p),(&__pyx_v_n)) == 0);
  if (__pyx_1) {
    __pyx_2 = PyInt_FromLong(ip_cksum_add(__pyx_v_p,__pyx_v_n,__pyx_v_sum)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 312; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  /*else*/ {
    __Pyx_Raise(PyExc_TypeError, 0, 0);
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 314; goto __pyx_L1;}
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.ip_cksum_add");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_buf);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_ip_cksum_carry(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_4dnet_ip_cksum_carry(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_sum;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"sum",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "i", __pyx_argnames, &__pyx_v_sum)) return 0;
  __pyx_1 = PyInt_FromLong(ip_cksum_carry(__pyx_v_sum)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 317; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.ip_cksum_carry");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_ip_pack_hdr(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_ip_pack_hdr[] = "Return a packed binary string representing an IP header.\n    \n    Keyword arguments:\n    tos  -- type of service			(8-bit integer)\n    len -- length (IP_HDR_LEN + payload)	(16-bit integer)\n    id   -- packet ID				(16-bit integer)\n    off  -- fragmentation offset		(16-bit integer)\n    ttl  -- time-to-live			(8-bit integer)\n    p    -- protocol (IP_PROTO_*)		(8-bit integer)\n    src  -- source address			(4-byte binary string)\n    dst  -- destination address			(4-byte binary string)\n    ";
static PyObject *__pyx_f_4dnet_ip_pack_hdr(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_tos = 0;
  PyObject *__pyx_v_len = 0;
  PyObject *__pyx_v_id = 0;
  PyObject *__pyx_v_off = 0;
  PyObject *__pyx_v_ttl = 0;
  PyObject *__pyx_v_p = 0;
  PyObject *__pyx_v_src = 0;
  PyObject *__pyx_v_dst = 0;
  char __pyx_v_hdr[20];
  ip_addr_t __pyx_v_s;
  ip_addr_t __pyx_v_d;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  int __pyx_3;
  int __pyx_4;
  int __pyx_5;
  int __pyx_6;
  int __pyx_7;
  static char *__pyx_argnames[] = {"tos","len","id","off","ttl","p","src","dst",0};
  __pyx_v_tos = __pyx_d4;
  __pyx_v_len = __pyx_d5;
  __pyx_v_id = __pyx_d6;
  __pyx_v_off = __pyx_d7;
  __pyx_v_ttl = __pyx_d8;
  __pyx_v_p = __pyx_d9;
  __pyx_v_src = __pyx_d10;
  __pyx_v_dst = __pyx_d11;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|OOOOOOOO", __pyx_argnames, &__pyx_v_tos, &__pyx_v_len, &__pyx_v_id, &__pyx_v_off, &__pyx_v_ttl, &__pyx_v_p, &__pyx_v_src, &__pyx_v_dst)) return 0;
  Py_INCREF(__pyx_v_tos);
  Py_INCREF(__pyx_v_len);
  Py_INCREF(__pyx_v_id);
  Py_INCREF(__pyx_v_off);
  Py_INCREF(__pyx_v_ttl);
  Py_INCREF(__pyx_v_p);
  Py_INCREF(__pyx_v_src);
  Py_INCREF(__pyx_v_dst);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":336 */
  __pyx_1 = __pyx_f_4dnet___memcpy(((char *)(&__pyx_v_s)),__pyx_v_src,4); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 336; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":337 */
  __pyx_1 = __pyx_f_4dnet___memcpy(((char *)(&__pyx_v_d)),__pyx_v_dst,4); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 337; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":338 */
  __pyx_2 = PyInt_AsLong(__pyx_v_tos); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 338; goto __pyx_L1;}
  __pyx_3 = PyInt_AsLong(__pyx_v_len); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 338; goto __pyx_L1;}
  __pyx_4 = PyInt_AsLong(__pyx_v_id); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 338; goto __pyx_L1;}
  __pyx_5 = PyInt_AsLong(__pyx_v_off); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 338; goto __pyx_L1;}
  __pyx_6 = PyInt_AsLong(__pyx_v_ttl); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 338; goto __pyx_L1;}
  __pyx_7 = PyInt_AsLong(__pyx_v_p); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 338; goto __pyx_L1;}
  ip_pack_hdr(__pyx_v_hdr,__pyx_2,__pyx_3,__pyx_4,__pyx_5,__pyx_6,__pyx_7,__pyx_v_s,__pyx_v_d);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":339 */
  __pyx_1 = PyString_FromStringAndSize(__pyx_v_hdr,20); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 339; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.ip_pack_hdr");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_tos);
  Py_DECREF(__pyx_v_len);
  Py_DECREF(__pyx_v_id);
  Py_DECREF(__pyx_v_off);
  Py_DECREF(__pyx_v_ttl);
  Py_DECREF(__pyx_v_p);
  Py_DECREF(__pyx_v_src);
  Py_DECREF(__pyx_v_dst);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_ip6_ntoa(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_ip6_ntoa[] = "Convert an IPv6 address from a 16-byte packed binary string to a\n    printable string (\'10.0.0.1\').";
static PyObject *__pyx_f_4dnet_ip6_ntoa(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_buf = 0;
  ip6_addr_t __pyx_v_ia;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"buf",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_buf)) return 0;
  Py_INCREF(__pyx_v_buf);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":373 */
  __pyx_1 = __pyx_f_4dnet___memcpy(((char *)(&__pyx_v_ia)),__pyx_v_buf,16); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 373; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":374 */
  __pyx_1 = PyString_FromString(ip6_ntoa((&__pyx_v_ia))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 374; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.ip6_ntoa");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_buf);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_ip6_aton(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_ip6_aton[] = "Convert an IPv6 address from a printable string to a\n    packed binary string (\'\\x0a\\x00\\x00\\x01\').";
static PyObject *__pyx_f_4dnet_ip6_aton(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_buf = 0;
  ip6_addr_t __pyx_v_ia;
  PyObject *__pyx_r;
  char *__pyx_1;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"buf",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_buf)) return 0;
  Py_INCREF(__pyx_v_buf);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":380 */
  __pyx_1 = PyString_AsString(__pyx_v_buf); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 380; goto __pyx_L1;}
  __pyx_2 = (ip6_aton(__pyx_1,(&__pyx_v_ia)) < 0);
  if (__pyx_2) {
    __Pyx_Raise(PyExc_ValueError, __pyx_k6p, 0);
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 381; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":382 */
  __pyx_3 = PyString_FromStringAndSize(((char *)(&__pyx_v_ia)),16); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 382; goto __pyx_L1;}
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("dnet.ip6_aton");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_buf);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_ip6_checksum(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_ip6_checksum[] = "Return a packed binary string representing an IPv6 packet \n    with the IPv6 and transport-layer checksums set.\n\n    Arguments:\n    pkt -- binary string representing an IPv6 packet\n    ";
static PyObject *__pyx_f_4dnet_ip6_checksum(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_buf = 0;
  PyObject *__pyx_r;
  char *__pyx_1;
  static char *__pyx_argnames[] = {"buf",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_buf)) return 0;
  Py_INCREF(__pyx_v_buf);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":391 */
  __pyx_1 = PyString_AsString(__pyx_v_buf); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 391; goto __pyx_L1;}
  ip6_checksum(__pyx_1,PyString_Size(__pyx_v_buf));

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":392 */
  Py_INCREF(__pyx_v_buf);
  __pyx_r = __pyx_v_buf;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("dnet.ip6_checksum");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_buf);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_ip6_pack_hdr(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_ip6_pack_hdr[] = "Return a packed binary string representing an IPv6 header.\n    \n    Keyword arguments:\n    fc   -- flow class			(8-bit integer)\n    fl   -- flow label			(20-bit integer)\n    plen -- payload length		(16-bit integer)\n    nxt  -- next header (IP_PROTO_*)	(8-bit integer)\n    hlim -- hop limit			(8-bit integer)\n    src  -- source address		(16-byte binary string)\n    dst  -- destination address		(16-byte binary string)\n    ";
static PyObject *__pyx_f_4dnet_ip6_pack_hdr(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_fc = 0;
  PyObject *__pyx_v_fl = 0;
  PyObject *__pyx_v_plen = 0;
  PyObject *__pyx_v_nxt = 0;
  PyObject *__pyx_v_hlim = 0;
  PyObject *__pyx_v_src = 0;
  PyObject *__pyx_v_dst = 0;
  char __pyx_v_hdr[40];
  ip6_addr_t __pyx_v_s;
  ip6_addr_t __pyx_v_d;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  int __pyx_3;
  int __pyx_4;
  int __pyx_5;
  int __pyx_6;
  static char *__pyx_argnames[] = {"fc","fl","plen","nxt","hlim","src","dst",0};
  __pyx_v_fc = __pyx_d12;
  __pyx_v_fl = __pyx_d13;
  __pyx_v_plen = __pyx_d14;
  __pyx_v_nxt = __pyx_d15;
  __pyx_v_hlim = __pyx_d16;
  __pyx_v_src = __pyx_d17;
  __pyx_v_dst = __pyx_d18;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|OOOOOOO", __pyx_argnames, &__pyx_v_fc, &__pyx_v_fl, &__pyx_v_plen, &__pyx_v_nxt, &__pyx_v_hlim, &__pyx_v_src, &__pyx_v_dst)) return 0;
  Py_INCREF(__pyx_v_fc);
  Py_INCREF(__pyx_v_fl);
  Py_INCREF(__pyx_v_plen);
  Py_INCREF(__pyx_v_nxt);
  Py_INCREF(__pyx_v_hlim);
  Py_INCREF(__pyx_v_src);
  Py_INCREF(__pyx_v_dst);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":409 */
  __pyx_1 = __pyx_f_4dnet___memcpy(((char *)(&__pyx_v_s)),__pyx_v_src,16); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 409; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":410 */
  __pyx_1 = __pyx_f_4dnet___memcpy(((char *)(&__pyx_v_d)),__pyx_v_dst,16); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 410; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":411 */
  __pyx_2 = PyInt_AsLong(__pyx_v_fc); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 411; goto __pyx_L1;}
  __pyx_3 = PyInt_AsLong(__pyx_v_fl); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 411; goto __pyx_L1;}
  __pyx_4 = PyInt_AsLong(__pyx_v_plen); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 411; goto __pyx_L1;}
  __pyx_5 = PyInt_AsLong(__pyx_v_nxt); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 411; goto __pyx_L1;}
  __pyx_6 = PyInt_AsLong(__pyx_v_hlim); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 411; goto __pyx_L1;}
  ip6_pack_hdr(__pyx_v_hdr,__pyx_2,__pyx_3,__pyx_4,__pyx_5,__pyx_6,__pyx_v_s,__pyx_v_d);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":412 */
  __pyx_1 = PyString_FromStringAndSize(__pyx_v_hdr,40); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 412; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.ip6_pack_hdr");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_fc);
  Py_DECREF(__pyx_v_fl);
  Py_DECREF(__pyx_v_plen);
  Py_DECREF(__pyx_v_nxt);
  Py_DECREF(__pyx_v_hlim);
  Py_DECREF(__pyx_v_src);
  Py_DECREF(__pyx_v_dst);
  return __pyx_r;
}

static int __pyx_f_4dnet_4addr___init__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static int __pyx_f_4dnet_4addr___init__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_addrtxt = 0;
  PyObject *__pyx_v_ptype = 0;
  int __pyx_r;
  int __pyx_1;
  char *__pyx_2;
  PyObject *__pyx_3 = 0;
  unsigned short __pyx_4;
  static char *__pyx_argnames[] = {"addrtxt","ptype",0};
  __pyx_v_addrtxt = __pyx_d19;
  __pyx_v_ptype = __pyx_d20;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|OO", __pyx_argnames, &__pyx_v_addrtxt, &__pyx_v_ptype)) return -1;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_addrtxt);
  Py_INCREF(__pyx_v_ptype);
  if (PyObject_Cmp(__pyx_v_addrtxt, Py_None, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 444; goto __pyx_L1;}
  __pyx_1 = __pyx_1 != 0;
  if (__pyx_1) {
    __pyx_2 = PyString_AsString(__pyx_v_addrtxt); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 444; goto __pyx_L1;}
    __pyx_1 = (addr_aton(__pyx_2,(&((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr)) < 0);
  }
  if (__pyx_1) {
    __pyx_1 = (PyString_Size(__pyx_v_addrtxt) == 4);
    if (__pyx_1) {

      /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":446 */
      __pyx_3 = __Pyx_GetName(__pyx_m, __pyx_n_ADDR_TYPE_IP); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 446; goto __pyx_L1;}
      __pyx_4 = PyInt_AsLong(__pyx_3); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 446; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      ((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_type = __pyx_4;

      /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":447 */
      __pyx_3 = __Pyx_GetName(__pyx_m, __pyx_n_IP_ADDR_BITS); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 447; goto __pyx_L1;}
      __pyx_4 = PyInt_AsLong(__pyx_3); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 447; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      ((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_bits = __pyx_4;

      /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":448 */
      if (PyObject_SetAttr(__pyx_v_self, __pyx_n_ip, __pyx_v_addrtxt) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 448; goto __pyx_L1;}
      goto __pyx_L3;
    }
    /*else*/ {
      __Pyx_Raise(PyExc_ValueError, __pyx_k10p, 0);
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 450; goto __pyx_L1;}
    }
    __pyx_L3:;
    goto __pyx_L2;
  }
  __pyx_L2:;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("dnet.addr.__init__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_addrtxt);
  Py_DECREF(__pyx_v_ptype);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4addr_4type___get__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_4dnet_4addr_4type___get__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = PyInt_FromLong(((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_type); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 455; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.addr.type.__get__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static int __pyx_f_4dnet_4addr_4type___set__(PyObject *__pyx_v_self, PyObject *__pyx_arg_value); /*proto*/
static int __pyx_f_4dnet_4addr_4type___set__(PyObject *__pyx_v_self, PyObject *__pyx_arg_value) {
  unsigned int __pyx_v_value;
  int __pyx_r;
  int __pyx_1;
  Py_INCREF(__pyx_v_self);
  __pyx_v_value = PyInt_AsUnsignedLongMask(__pyx_arg_value); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 456; goto __pyx_L1;}

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":457 */
  __pyx_1 = (__pyx_v_value > 0xffff);
  if (__pyx_1) {
    __Pyx_Raise(PyExc_OverflowError, 0, 0);
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 457; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":458 */
  ((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_type = __pyx_v_value;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("dnet.addr.type.__set__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4addr_4bits___get__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_4dnet_4addr_4bits___get__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = PyInt_FromLong(((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_bits); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 463; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.addr.bits.__get__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static int __pyx_f_4dnet_4addr_4bits___set__(PyObject *__pyx_v_self, PyObject *__pyx_arg_value); /*proto*/
static int __pyx_f_4dnet_4addr_4bits___set__(PyObject *__pyx_v_self, PyObject *__pyx_arg_value) {
  unsigned int __pyx_v_value;
  int __pyx_r;
  int __pyx_1;
  Py_INCREF(__pyx_v_self);
  __pyx_v_value = PyInt_AsUnsignedLongMask(__pyx_arg_value); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 464; goto __pyx_L1;}

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":465 */
  __pyx_1 = (__pyx_v_value > 0xffff);
  if (__pyx_1) {
    __Pyx_Raise(PyExc_OverflowError, 0, 0);
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 465; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":466 */
  ((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_bits = __pyx_v_value;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("dnet.addr.bits.__set__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4addr_4data___get__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_4dnet_4addr_4data___get__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  int __pyx_3;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = PyInt_FromLong(((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_type); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 471; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_ADDR_TYPE_ETH); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 471; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_1, __pyx_2, &__pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 471; goto __pyx_L1;}
  __pyx_3 = __pyx_3 == 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (__pyx_3) {
    __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_eth); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 472; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_2 = PyInt_FromLong(((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_type); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 473; goto __pyx_L1;}
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_ADDR_TYPE_IP); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 473; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_2, __pyx_1, &__pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 473; goto __pyx_L1;}
  __pyx_3 = __pyx_3 == 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_3) {
    __pyx_2 = PyObject_GetAttr(__pyx_v_self, __pyx_n_ip); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 474; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_1 = PyInt_FromLong(((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_type); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 475; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_ADDR_TYPE_IP6); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 475; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_1, __pyx_2, &__pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 475; goto __pyx_L1;}
  __pyx_3 = __pyx_3 == 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (__pyx_3) {
    __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_ip6); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 476; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  /*else*/ {
    __Pyx_Raise(PyExc_ValueError, __pyx_k10p, 0);
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 478; goto __pyx_L1;}
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.addr.data.__get__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4addr_3eth___get__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_4dnet_4addr_3eth___get__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  int __pyx_3;
  Py_INCREF(__pyx_v_self);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":483 */
  __pyx_1 = PyInt_FromLong(((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_type); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 483; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_ADDR_TYPE_ETH); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 483; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_1, __pyx_2, &__pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 483; goto __pyx_L1;}
  __pyx_3 = __pyx_3 != 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (__pyx_3) {
    __Pyx_Raise(PyExc_ValueError, __pyx_k15p, 0);
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 484; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":485 */
  __pyx_1 = PyString_FromStringAndSize(((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_data8,6); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 485; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.addr.eth.__get__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static int __pyx_f_4dnet_4addr_3eth___set__(PyObject *__pyx_v_self, PyObject *__pyx_v_value); /*proto*/
static int __pyx_f_4dnet_4addr_3eth___set__(PyObject *__pyx_v_self, PyObject *__pyx_v_value) {
  int __pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  int __pyx_3;
  unsigned short __pyx_4;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_value);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":488 */
  __pyx_1 = PyInt_FromLong(PyString_Size(__pyx_v_value)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 488; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_ETH_ADDR_LEN); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 488; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_1, __pyx_2, &__pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 488; goto __pyx_L1;}
  __pyx_3 = __pyx_3 != 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (__pyx_3) {
    __Pyx_Raise(PyExc_ValueError, __pyx_k17p, 0);
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 489; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":490 */
  __pyx_1 = __pyx_f_4dnet___memcpy(((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_data8,__pyx_v_value,6); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 490; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":491 */
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_ADDR_TYPE_ETH); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 491; goto __pyx_L1;}
  __pyx_4 = PyInt_AsLong(__pyx_2); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 491; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  ((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_type = __pyx_4;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":492 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_ETH_ADDR_BITS); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 492; goto __pyx_L1;}
  __pyx_4 = PyInt_AsLong(__pyx_1); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 492; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  ((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_bits = __pyx_4;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.addr.eth.__set__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_value);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4addr_2ip___get__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_4dnet_4addr_2ip___get__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  int __pyx_3;
  Py_INCREF(__pyx_v_self);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":497 */
  __pyx_1 = PyInt_FromLong(((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_type); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 497; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_ADDR_TYPE_IP); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 497; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_1, __pyx_2, &__pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 497; goto __pyx_L1;}
  __pyx_3 = __pyx_3 != 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (__pyx_3) {
    __Pyx_Raise(PyExc_ValueError, __pyx_k19p, 0);
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 498; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":499 */
  __pyx_1 = PyString_FromStringAndSize(((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_data8,4); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 499; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.addr.ip.__get__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static int __pyx_f_4dnet_4addr_2ip___set__(PyObject *__pyx_v_self, PyObject *__pyx_v_value); /*proto*/
static int __pyx_f_4dnet_4addr_2ip___set__(PyObject *__pyx_v_self, PyObject *__pyx_v_value) {
  int __pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  unsigned short __pyx_4;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_value);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":503 */
  __pyx_1 = PyInt_Check(__pyx_v_value);
  if (__pyx_1) {
    ((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_ip = htonl(PyInt_AsLong(__pyx_v_value));
    goto __pyx_L2;
  }
  __pyx_1 = PyLong_Check(__pyx_v_value);
  if (__pyx_1) {
    ((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_ip = htonl(PyLong_AsUnsignedLong(__pyx_v_value));
    goto __pyx_L2;
  }
  __pyx_2 = PyInt_FromLong(PyString_Size(__pyx_v_value)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 507; goto __pyx_L1;}
  __pyx_3 = __Pyx_GetName(__pyx_m, __pyx_n_IP_ADDR_LEN); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 507; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_2, __pyx_3, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 507; goto __pyx_L1;}
  __pyx_1 = __pyx_1 != 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  if (__pyx_1) {
    __Pyx_Raise(PyExc_ValueError, __pyx_k21p, 0);
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 508; goto __pyx_L1;}
    goto __pyx_L2;
  }
  /*else*/ {
    __pyx_2 = __pyx_f_4dnet___memcpy(((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_data8,__pyx_v_value,4); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 510; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":511 */
  __pyx_3 = __Pyx_GetName(__pyx_m, __pyx_n_ADDR_TYPE_IP); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 511; goto __pyx_L1;}
  __pyx_4 = PyInt_AsLong(__pyx_3); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 511; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  ((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_type = __pyx_4;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":512 */
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_IP_ADDR_BITS); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 512; goto __pyx_L1;}
  __pyx_4 = PyInt_AsLong(__pyx_2); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 512; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  ((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_bits = __pyx_4;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("dnet.addr.ip.__set__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_value);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4addr_3ip6___get__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_4dnet_4addr_3ip6___get__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  int __pyx_3;
  Py_INCREF(__pyx_v_self);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":517 */
  __pyx_1 = PyInt_FromLong(((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_type); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 517; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_ADDR_TYPE_IP6); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 517; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_1, __pyx_2, &__pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 517; goto __pyx_L1;}
  __pyx_3 = __pyx_3 != 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (__pyx_3) {
    __Pyx_Raise(PyExc_ValueError, __pyx_k22p, 0);
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 518; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":519 */
  __pyx_1 = PyString_FromStringAndSize(((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_data8,16); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 519; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.addr.ip6.__get__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static int __pyx_f_4dnet_4addr_3ip6___set__(PyObject *__pyx_v_self, PyObject *__pyx_v_value); /*proto*/
static int __pyx_f_4dnet_4addr_3ip6___set__(PyObject *__pyx_v_self, PyObject *__pyx_v_value) {
  int __pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  int __pyx_3;
  unsigned short __pyx_4;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_value);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":522 */
  __pyx_1 = PyInt_FromLong(PyString_Size(__pyx_v_value)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 522; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_IP6_ADDR_LEN); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 522; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_1, __pyx_2, &__pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 522; goto __pyx_L1;}
  __pyx_3 = __pyx_3 != 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (__pyx_3) {
    __Pyx_Raise(PyExc_ValueError, __pyx_k24p, 0);
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 523; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":524 */
  __pyx_1 = __pyx_f_4dnet___memcpy(((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_data8,__pyx_v_value,16); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 524; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":525 */
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_ADDR_TYPE_IP6); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 525; goto __pyx_L1;}
  __pyx_4 = PyInt_AsLong(__pyx_2); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 525; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  ((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_type = __pyx_4;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":526 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_IP6_ADDR_BITS); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 526; goto __pyx_L1;}
  __pyx_4 = PyInt_AsLong(__pyx_1); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 526; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  ((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_bits = __pyx_4;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.addr.ip6.__set__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_value);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4addr_bcast(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_4addr_bcast[] = "Return an addr object for our broadcast address.";
static PyObject *__pyx_f_4dnet_4addr_bcast(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_bcast;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_bcast = Py_None; Py_INCREF(Py_None);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":530 */
  __pyx_1 = PyObject_CallObject(((PyObject *)__pyx_ptype_4dnet_addr), 0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 530; goto __pyx_L1;}
  Py_DECREF(__pyx_v_bcast);
  __pyx_v_bcast = __pyx_1;
  __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":531 */
  addr_bcast((&((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr),(&((struct __pyx_obj_4dnet_addr *)__pyx_v_bcast)->_addr));

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":532 */
  Py_INCREF(__pyx_v_bcast);
  __pyx_r = __pyx_v_bcast;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.addr.bcast");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_bcast);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4addr_net(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_4addr_net[] = "Return an addr object for our network address.";
static PyObject *__pyx_f_4dnet_4addr_net(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_net;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_net = Py_None; Py_INCREF(Py_None);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":536 */
  __pyx_1 = PyObject_CallObject(((PyObject *)__pyx_ptype_4dnet_addr), 0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 536; goto __pyx_L1;}
  Py_DECREF(__pyx_v_net);
  __pyx_v_net = __pyx_1;
  __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":537 */
  addr_net((&((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr),(&((struct __pyx_obj_4dnet_addr *)__pyx_v_net)->_addr));

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":538 */
  Py_INCREF(__pyx_v_net);
  __pyx_r = __pyx_v_net;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.addr.net");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_net);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4addr___add__(PyObject *__pyx_v_self, PyObject *__pyx_v_other); /*proto*/
static PyObject *__pyx_f_4dnet_4addr___add__(PyObject *__pyx_v_self, PyObject *__pyx_v_other) {
  PyObject *__pyx_v_x;
  PyObject *__pyx_v_y;
  PyObject *__pyx_v_z;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  unsigned long __pyx_4;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);
  __pyx_v_x = Py_None; Py_INCREF(Py_None);
  __pyx_v_y = Py_None; Py_INCREF(Py_None);
  __pyx_v_z = Py_None; Py_INCREF(Py_None);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":542 */
  __pyx_1 = PyInt_Check(__pyx_v_self);
  if (__pyx_1) {
    __pyx_2 = __pyx_v_other;
    Py_INCREF(__pyx_2);
    __pyx_3 = __pyx_v_self;
    Py_INCREF(__pyx_3);
    Py_DECREF(__pyx_v_x);
    __pyx_v_x = __pyx_2;
    __pyx_2 = 0;
    Py_DECREF(__pyx_v_y);
    __pyx_v_y = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_1 = PyInt_Check(__pyx_v_other);
  if (__pyx_1) {
    __pyx_2 = __pyx_v_self;
    Py_INCREF(__pyx_2);
    __pyx_3 = __pyx_v_other;
    Py_INCREF(__pyx_3);
    Py_DECREF(__pyx_v_x);
    __pyx_v_x = __pyx_2;
    __pyx_2 = 0;
    Py_DECREF(__pyx_v_y);
    __pyx_v_y = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L2;
  }
  /*else*/ {
    __Pyx_Raise(PyExc_NotImplementedError, 0, 0);
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 547; goto __pyx_L1;}
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":548 */
  __pyx_2 = PyObject_GetAttr(__pyx_v_x, __pyx_n___copy__); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 548; goto __pyx_L1;}
  __pyx_3 = PyObject_CallObject(__pyx_2, 0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 548; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_z);
  __pyx_v_z = __pyx_3;
  __pyx_3 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":549 */
  __pyx_2 = PyLong_FromUnsignedLong(ntohl(((struct __pyx_obj_4dnet_addr *)__pyx_v_x)->_addr.addr_ip)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 549; goto __pyx_L1;}
  __pyx_3 = PyNumber_Add(__pyx_2, __pyx_v_y); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 549; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_4 = PyInt_AsUnsignedLongMask(__pyx_3); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 549; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  ((struct __pyx_obj_4dnet_addr *)__pyx_v_z)->_addr.addr_ip = htonl(__pyx_4);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":550 */
  Py_INCREF(__pyx_v_z);
  __pyx_r = __pyx_v_z;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("dnet.addr.__add__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  Py_DECREF(__pyx_v_z);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4addr___copy__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_4dnet_4addr___copy__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_a;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_a = Py_None; Py_INCREF(Py_None);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":553 */
  __pyx_1 = PyObject_CallObject(((PyObject *)__pyx_ptype_4dnet_addr), 0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 553; goto __pyx_L1;}
  Py_DECREF(__pyx_v_a);
  __pyx_v_a = __pyx_1;
  __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":554 */
  ((struct __pyx_obj_4dnet_addr *)__pyx_v_a)->_addr = ((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":555 */
  Py_INCREF(__pyx_v_a);
  __pyx_r = __pyx_v_a;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.addr.__copy__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_a);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static int __pyx_f_4dnet_4addr___cmp__(PyObject *__pyx_v_x, PyObject *__pyx_v_y); /*proto*/
static int __pyx_f_4dnet_4addr___cmp__(PyObject *__pyx_v_x, PyObject *__pyx_v_y) {
  int __pyx_v_i;
  int __pyx_r;
  int __pyx_1;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_y), __pyx_ptype_4dnet_addr, 1, "y")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 557; goto __pyx_L1;}

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":559 */
  __pyx_v_i = addr_cmp((&((struct __pyx_obj_4dnet_addr *)__pyx_v_x)->_addr),(&((struct __pyx_obj_4dnet_addr *)__pyx_v_y)->_addr));

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":560 */
  __pyx_1 = (__pyx_v_i < 0);
  if (__pyx_1) {
    __pyx_r = (-1);
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":562 */
  __pyx_1 = (__pyx_v_i > 0);
  if (__pyx_1) {
    __pyx_r = 1;
    goto __pyx_L0;
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":564 */
  __pyx_r = 0;
  goto __pyx_L0;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("dnet.addr.__cmp__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static int __pyx_f_4dnet_4addr___contains__(PyObject *__pyx_v_self, PyObject *__pyx_v_other); /*proto*/
static int __pyx_f_4dnet_4addr___contains__(PyObject *__pyx_v_self, PyObject *__pyx_v_other) {
  struct addr __pyx_v_s1;
  struct addr __pyx_v_s2;
  struct addr __pyx_v_o1;
  struct addr __pyx_v_o2;
  int __pyx_r;
  int __pyx_1;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_other), __pyx_ptype_4dnet_addr, 1, "other")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 566; goto __pyx_L1;}

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":568 */
  __pyx_1 = (addr_net((&((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr),(&__pyx_v_s1)) != 0);
  if (!__pyx_1) {
    __pyx_1 = (addr_bcast((&((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr),(&__pyx_v_s2)) != 0);
    if (!__pyx_1) {
      __pyx_1 = (addr_net((&((struct __pyx_obj_4dnet_addr *)__pyx_v_other)->_addr),(&__pyx_v_o1)) != 0);
      if (!__pyx_1) {
        __pyx_1 = (addr_bcast((&((struct __pyx_obj_4dnet_addr *)__pyx_v_other)->_addr),(&__pyx_v_o2)) != 0);
      }
    }
  }
  if (__pyx_1) {
    __pyx_r = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":573 */
  __pyx_1 = (addr_cmp((&__pyx_v_o1),(&__pyx_v_s1)) >= 0);
  if (__pyx_1) {
    __pyx_1 = (addr_cmp((&__pyx_v_o2),(&__pyx_v_s2)) <= 0);
  }
  __pyx_r = __pyx_1;
  goto __pyx_L0;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("dnet.addr.__contains__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static long __pyx_f_4dnet_4addr___hash__(PyObject *__pyx_v_self); /*proto*/
static long __pyx_f_4dnet_4addr___hash__(PyObject *__pyx_v_self) {
  long __pyx_v_x;
  long __pyx_v_y;
  long __pyx_v_size;
  PyObject *__pyx_v_i;
  long __pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  int __pyx_3;
  long __pyx_4;
  Py_ssize_t __pyx_5;
  Py_INCREF(__pyx_v_self);
  __pyx_v_i = Py_None; Py_INCREF(Py_None);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":577 */
  __pyx_1 = PyInt_FromLong(((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_type); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 577; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_ADDR_TYPE_ETH); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 577; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_1, __pyx_2, &__pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 577; goto __pyx_L1;}
  __pyx_3 = __pyx_3 == 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (__pyx_3) {
    __pyx_v_size = 6;
    goto __pyx_L2;
  }
  __pyx_1 = PyInt_FromLong(((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_type); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 578; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_ADDR_TYPE_IP); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 578; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_1, __pyx_2, &__pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 578; goto __pyx_L1;}
  __pyx_3 = __pyx_3 == 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (__pyx_3) {
    __pyx_v_size = 4;
    goto __pyx_L2;
  }
  __pyx_1 = PyInt_FromLong(((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_type); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 579; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_ADDR_TYPE_IP6); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 579; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_1, __pyx_2, &__pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 579; goto __pyx_L1;}
  __pyx_3 = __pyx_3 == 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (__pyx_3) {
    __pyx_v_size = 16;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":580 */
  __pyx_v_x = 0x345678;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":581 */
  __pyx_v_x = (__pyx_v_x ^ ((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_type);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":582 */
  __pyx_v_x = (__pyx_v_x ^ ((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_bits);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":583 */
  __pyx_v_y = ((((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_data8[0]) << 7);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":584 */
  for (__pyx_4 = 0+1; __pyx_4 < __pyx_v_size; ++__pyx_4) {
    __pyx_1 = PyInt_FromLong(__pyx_4); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 584; goto __pyx_L1;}
    Py_DECREF(__pyx_v_i);
    __pyx_v_i = __pyx_1;
    __pyx_1 = 0;
    __pyx_5 = PyInt_AsSsize_t(__pyx_v_i); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 585; goto __pyx_L1;}
    __pyx_v_y = ((1000003 * __pyx_v_y) ^ (((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_data8[__pyx_5]));
  }

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":586 */
  __pyx_v_y = (__pyx_v_y ^ __pyx_v_size);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":587 */
  __pyx_3 = (__pyx_v_y == (-1));
  if (__pyx_3) {
    __pyx_v_y = (-2);
    goto __pyx_L5;
  }
  __pyx_L5:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":588 */
  __pyx_v_x = (__pyx_v_x ^ __pyx_v_y);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":589 */
  __pyx_3 = (__pyx_v_x == (-1));
  if (__pyx_3) {
    __pyx_v_x = (-2);
    goto __pyx_L6;
  }
  __pyx_L6:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":590 */
  __pyx_r = __pyx_v_x;
  goto __pyx_L0;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.addr.__hash__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_i);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4addr___int__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_4dnet_4addr___int__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  int __pyx_3;
  Py_INCREF(__pyx_v_self);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":593 */
  __pyx_1 = PyInt_FromLong(((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_type); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 593; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_ADDR_TYPE_IP); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 593; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_1, __pyx_2, &__pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 593; goto __pyx_L1;}
  __pyx_3 = __pyx_3 != 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (__pyx_3) {
    __Pyx_Raise(PyExc_NotImplementedError, 0, 0);
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 594; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":595 */
  __pyx_1 = PyLong_FromUnsignedLong(ntohl(((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_ip)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 595; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.addr.__int__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4addr___long__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_4dnet_4addr___long__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n___int__); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 598; goto __pyx_L1;}
  __pyx_2 = PyObject_CallObject(__pyx_1, 0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 598; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.addr.__long__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4addr___iter__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_4dnet_4addr___iter__(PyObject *__pyx_v_self) {
  struct addr __pyx_v_a;
  struct addr __pyx_v_b;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  Py_INCREF(__pyx_v_self);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":602 */
  __pyx_2 = PyInt_FromLong(((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr.addr_type); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 602; goto __pyx_L1;}
  __pyx_3 = __Pyx_GetName(__pyx_m, __pyx_n_ADDR_TYPE_IP); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 602; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_2, __pyx_3, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 602; goto __pyx_L1;}
  __pyx_1 = __pyx_1 != 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  if (!__pyx_1) {
    __pyx_1 = (addr_net((&((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr),(&__pyx_v_a)) != 0);
    if (!__pyx_1) {
      __pyx_1 = (addr_bcast((&((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr),(&__pyx_v_b)) != 0);
    }
  }
  if (__pyx_1) {
    __Pyx_Raise(PyExc_ValueError, 0, 0);
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 605; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":614 */
  __pyx_2 = PyLong_FromUnsignedLong(__pyx_v_a.addr_ip); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 614; goto __pyx_L1;}
  __pyx_3 = PyLong_FromUnsignedLong(__pyx_v_b.addr_ip); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 614; goto __pyx_L1;}
  __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 614; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_4, 0, __pyx_2);
  PyTuple_SET_ITEM(__pyx_4, 1, __pyx_3);
  __pyx_2 = 0;
  __pyx_3 = 0;
  __pyx_2 = PyObject_CallObject(((PyObject *)__pyx_ptype_4dnet___addr_ip4_iter), __pyx_4); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 614; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("dnet.addr.__iter__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4addr___repr__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_4dnet_4addr___repr__(PyObject *__pyx_v_self) {
  char *__pyx_v_p;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  Py_INCREF(__pyx_v_self);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":618 */
  __pyx_v_p = addr_ntoa((&((struct __pyx_obj_4dnet_addr *)__pyx_v_self)->_addr));

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":619 */
  __pyx_1 = (!(__pyx_v_p != 0));
  if (__pyx_1) {
    Py_INCREF(__pyx_k28p);
    __pyx_r = __pyx_k28p;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":621 */
  __pyx_2 = PyString_FromString(__pyx_v_p); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 621; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.addr.__repr__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static int __pyx_f_4dnet_15__addr_ip4_iter___init__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static int __pyx_f_4dnet_15__addr_ip4_iter___init__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_cur = 0;
  PyObject *__pyx_v_max = 0;
  int __pyx_r;
  unsigned long __pyx_1;
  static char *__pyx_argnames[] = {"cur","max",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_cur, &__pyx_v_max)) return -1;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_cur);
  Py_INCREF(__pyx_v_max);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":628 */
  __pyx_1 = PyInt_AsUnsignedLongMask(__pyx_v_cur); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 628; goto __pyx_L1;}
  ((struct __pyx_obj_4dnet___addr_ip4_iter *)__pyx_v_self)->cur = ntohl(__pyx_1);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":629 */
  __pyx_1 = PyInt_AsUnsignedLongMask(__pyx_v_max); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 629; goto __pyx_L1;}
  ((struct __pyx_obj_4dnet___addr_ip4_iter *)__pyx_v_self)->max = ntohl(__pyx_1);

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("dnet.__addr_ip4_iter.__init__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_cur);
  Py_DECREF(__pyx_v_max);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_15__addr_ip4_iter___next__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_4dnet_15__addr_ip4_iter___next__(PyObject *__pyx_v_self) {
  struct __pyx_obj_4dnet_addr *__pyx_v_next;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  unsigned short __pyx_3;
  Py_INCREF(__pyx_v_self);
  __pyx_v_next = ((struct __pyx_obj_4dnet_addr *)Py_None); Py_INCREF(Py_None);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":633 */
  __pyx_1 = (((struct __pyx_obj_4dnet___addr_ip4_iter *)__pyx_v_self)->cur <= ((struct __pyx_obj_4dnet___addr_ip4_iter *)__pyx_v_self)->max);
  if (__pyx_1) {

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":634 */
    __pyx_2 = PyObject_CallObject(((PyObject *)__pyx_ptype_4dnet_addr), 0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 634; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v_next));
    __pyx_v_next = ((struct __pyx_obj_4dnet_addr *)__pyx_2);
    __pyx_2 = 0;

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":635 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_ADDR_TYPE_IP); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 635; goto __pyx_L1;}
    __pyx_3 = PyInt_AsLong(__pyx_2); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 635; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_v_next->_addr.addr_type = __pyx_3;

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":636 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_IP_ADDR_BITS); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 636; goto __pyx_L1;}
    __pyx_3 = PyInt_AsLong(__pyx_2); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 636; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_v_next->_addr.addr_bits = __pyx_3;

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":637 */
    __pyx_v_next->_addr.addr_ip = htonl(((struct __pyx_obj_4dnet___addr_ip4_iter *)__pyx_v_self)->cur);

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":638 */
    ((struct __pyx_obj_4dnet___addr_ip4_iter *)__pyx_v_self)->cur = (((struct __pyx_obj_4dnet___addr_ip4_iter *)__pyx_v_self)->cur + 1);

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":639 */
    Py_INCREF(((PyObject *)__pyx_v_next));
    __pyx_r = ((PyObject *)__pyx_v_next);
    goto __pyx_L0;
    goto __pyx_L2;
  }
  /*else*/ {
    __Pyx_Raise(PyExc_StopIteration, 0, 0);
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 641; goto __pyx_L1;}
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.__addr_ip4_iter.__next__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_next);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static int __pyx_f_4dnet___arp_callback(struct arp_entry *__pyx_v_entry,void *__pyx_v_arg) {
  PyObject *__pyx_v_f;
  PyObject *__pyx_v_a;
  PyObject *__pyx_v_pa;
  PyObject *__pyx_v_ha;
  PyObject *__pyx_v_ret;
  int __pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  int __pyx_3;
  int __pyx_4;
  __pyx_v_f = Py_None; Py_INCREF(Py_None);
  __pyx_v_a = Py_None; Py_INCREF(Py_None);
  __pyx_v_pa = Py_None; Py_INCREF(Py_None);
  __pyx_v_ha = Py_None; Py_INCREF(Py_None);
  __pyx_v_ret = Py_None; Py_INCREF(Py_None);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":679 */
  __pyx_1 = PyObject_GetIter(((PyObject *)__pyx_v_arg)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 679; goto __pyx_L1;}
  __pyx_2 = __Pyx_UnpackItem(__pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 679; goto __pyx_L1;}
  Py_DECREF(__pyx_v_f);
  __pyx_v_f = __pyx_2;
  __pyx_2 = 0;
  __pyx_2 = __Pyx_UnpackItem(__pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 679; goto __pyx_L1;}
  Py_DECREF(__pyx_v_a);
  __pyx_v_a = __pyx_2;
  __pyx_2 = 0;
  if (__Pyx_EndUnpack(__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 679; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":680 */
  __pyx_2 = PyObject_CallObject(((PyObject *)__pyx_ptype_4dnet_addr), 0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 680; goto __pyx_L1;}
  __pyx_1 = PyObject_CallObject(((PyObject *)__pyx_ptype_4dnet_addr), 0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 680; goto __pyx_L1;}
  Py_DECREF(__pyx_v_pa);
  __pyx_v_pa = __pyx_2;
  __pyx_2 = 0;
  Py_DECREF(__pyx_v_ha);
  __pyx_v_ha = __pyx_1;
  __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":681 */
  ((struct __pyx_obj_4dnet_addr *)__pyx_v_pa)->_addr = __pyx_v_entry->arp_pa;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":682 */
  ((struct __pyx_obj_4dnet_addr *)__pyx_v_ha)->_addr = __pyx_v_entry->arp_ha;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":683 */
  __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 683; goto __pyx_L1;}
  Py_INCREF(__pyx_v_pa);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_pa);
  Py_INCREF(__pyx_v_ha);
  PyTuple_SET_ITEM(__pyx_2, 1, __pyx_v_ha);
  __pyx_1 = PyTuple_New(2); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 683; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_1, 0, __pyx_2);
  Py_INCREF(__pyx_v_a);
  PyTuple_SET_ITEM(__pyx_1, 1, __pyx_v_a);
  __pyx_2 = 0;
  __pyx_2 = PyObject_CallObject(__pyx_v_f, __pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 683; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_v_ret);
  __pyx_v_ret = __pyx_2;
  __pyx_2 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":684 */
  __pyx_3 = PyObject_IsTrue(__pyx_v_ret); if (__pyx_3 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 684; goto __pyx_L1;}
  __pyx_4 = (!__pyx_3);
  if (__pyx_4) {
    __pyx_1 = PyInt_FromLong(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 685; goto __pyx_L1;}
    Py_DECREF(__pyx_v_ret);
    __pyx_v_ret = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":686 */
  __pyx_3 = PyInt_AsLong(__pyx_v_ret); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 686; goto __pyx_L1;}
  __pyx_r = __pyx_3;
  goto __pyx_L0;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.__arp_callback");
  __pyx_r = (-1);
  __pyx_L0:;
  Py_DECREF(__pyx_v_f);
  Py_DECREF(__pyx_v_a);
  Py_DECREF(__pyx_v_pa);
  Py_DECREF(__pyx_v_ha);
  Py_DECREF(__pyx_v_ret);
  return __pyx_r;
}

static int __pyx_f_4dnet_3arp___init__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static int __pyx_f_4dnet_3arp___init__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return -1;
  Py_INCREF(__pyx_v_self);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":696 */
  ((struct __pyx_obj_4dnet_arp *)__pyx_v_self)->arp = arp_open();

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":697 */
  __pyx_1 = (!(((struct __pyx_obj_4dnet_arp *)__pyx_v_self)->arp != 0));
  if (__pyx_1) {
    __pyx_2 = __pyx_f_4dnet___oserror(); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 698; goto __pyx_L1;}
    __Pyx_Raise(PyExc_OSError, __pyx_2, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 698; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.arp.__init__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_3arp_add(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_3arp_add[] = "Add an entry to the system ARP table.\n\n        Arguments:\n        pa -- ADDR_TYPE_IP network address object\n        ha -- ADDR_TYPE_ETH network address object\n        ";
static PyObject *__pyx_f_4dnet_3arp_add(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_4dnet_addr *__pyx_v_pa = 0;
  struct __pyx_obj_4dnet_addr *__pyx_v_ha = 0;
  struct arp_entry __pyx_v_entry;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {"pa","ha",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_pa, &__pyx_v_ha)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_pa);
  Py_INCREF(__pyx_v_ha);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_pa), __pyx_ptype_4dnet_addr, 1, "pa")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 700; goto __pyx_L1;}
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_ha), __pyx_ptype_4dnet_addr, 1, "ha")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 700; goto __pyx_L1;}

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":708 */
  __pyx_v_entry.arp_pa = __pyx_v_pa->_addr;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":709 */
  __pyx_v_entry.arp_ha = __pyx_v_ha->_addr;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":710 */
  __pyx_1 = (arp_add(((struct __pyx_obj_4dnet_arp *)__pyx_v_self)->arp,(&__pyx_v_entry)) < 0);
  if (__pyx_1) {
    __pyx_2 = __pyx_f_4dnet___oserror(); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 711; goto __pyx_L1;}
    __Pyx_Raise(PyExc_OSError, __pyx_2, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 711; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.arp.add");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_pa);
  Py_DECREF(__pyx_v_ha);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_3arp_delete(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_3arp_delete[] = "Delete an entry from the system ARP table.\n\n        Arguments:\n        pa -- ADDR_TYPE_IP network address object\n        ";
static PyObject *__pyx_f_4dnet_3arp_delete(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_4dnet_addr *__pyx_v_pa = 0;
  struct arp_entry __pyx_v_entry;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {"pa",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_pa)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_pa);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_pa), __pyx_ptype_4dnet_addr, 1, "pa")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 713; goto __pyx_L1;}

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":720 */
  __pyx_v_entry.arp_pa = __pyx_v_pa->_addr;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":721 */
  __pyx_1 = (arp_delete(((struct __pyx_obj_4dnet_arp *)__pyx_v_self)->arp,(&__pyx_v_entry)) < 0);
  if (__pyx_1) {
    __pyx_2 = __pyx_f_4dnet___oserror(); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 722; goto __pyx_L1;}
    __Pyx_Raise(PyExc_OSError, __pyx_2, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 722; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.arp.delete");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_pa);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_3arp_get(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_3arp_get[] = "Return the hardware address for a given protocol address\n        in the system ARP table.\n\n        Arguments:\n        pa -- ADDR_TYPE_IP network address object\n        ";
static PyObject *__pyx_f_4dnet_3arp_get(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_4dnet_addr *__pyx_v_pa = 0;
  struct arp_entry __pyx_v_entry;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"pa",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_pa)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_pa);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_pa), __pyx_ptype_4dnet_addr, 1, "pa")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 724; goto __pyx_L1;}

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":732 */
  __pyx_v_entry.arp_pa = __pyx_v_pa->_addr;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":733 */
  __pyx_1 = (arp_get(((struct __pyx_obj_4dnet_arp *)__pyx_v_self)->arp,(&__pyx_v_entry)) == 0);
  if (__pyx_1) {
    __pyx_2 = PyString_FromString(addr_ntoa((&__pyx_v_entry.arp_ha))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 734; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 734; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(((PyObject *)__pyx_ptype_4dnet_addr), __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 734; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":735 */
  Py_INCREF(Py_None);
  __pyx_r = Py_None;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("dnet.arp.get");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_pa);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_3arp_loop(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_3arp_loop[] = "Iterate over the system ARP table, invoking a user callback\n        with each entry, returning the status of the callback routine.\n\n        Keyword arguments:\n        callback -- callback function with ((pa, ha), arg) prototype.\n                    If this function returns a non-zero value, the loop\n                    will break early.\n        arg      -- optional callback argument\n        ";
static PyObject *__pyx_f_4dnet_3arp_loop(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_callback = 0;
  PyObject *__pyx_v_arg = 0;
  PyObject *__pyx_v__arg;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"callback","arg",0};
  __pyx_v_arg = __pyx_d21;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|O", __pyx_argnames, &__pyx_v_callback, &__pyx_v_arg)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_callback);
  Py_INCREF(__pyx_v_arg);
  __pyx_v__arg = Py_None; Py_INCREF(Py_None);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":747 */
  __pyx_1 = PyTuple_New(2); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 747; goto __pyx_L1;}
  Py_INCREF(__pyx_v_callback);
  PyTuple_SET_ITEM(__pyx_1, 0, __pyx_v_callback);
  Py_INCREF(__pyx_v_arg);
  PyTuple_SET_ITEM(__pyx_1, 1, __pyx_v_arg);
  Py_DECREF(__pyx_v__arg);
  __pyx_v__arg = __pyx_1;
  __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":748 */
  __pyx_1 = PyInt_FromLong(arp_loop(((struct __pyx_obj_4dnet_arp *)__pyx_v_self)->arp,__pyx_f_4dnet___arp_callback,((void *)__pyx_v__arg))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 748; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.arp.loop");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__arg);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_callback);
  Py_DECREF(__pyx_v_arg);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_3arp___iter__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_4dnet_3arp___iter__(PyObject *__pyx_v_self) {
  PyObject *__pyx_v_l;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_l = Py_None; Py_INCREF(Py_None);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":751 */
  __pyx_1 = PyList_New(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 751; goto __pyx_L1;}
  Py_DECREF(__pyx_v_l);
  __pyx_v_l = __pyx_1;
  __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":752 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_loop); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 752; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n___iter_append); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 752; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 752; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
  Py_INCREF(__pyx_v_l);
  PyTuple_SET_ITEM(__pyx_3, 1, __pyx_v_l);
  __pyx_2 = 0;
  __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 752; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":753 */
  __pyx_1 = PyObject_GetIter(__pyx_v_l); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 753; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("dnet.arp.__iter__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_l);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static void __pyx_f_4dnet_3arp___dealloc__(PyObject *__pyx_v_self); /*proto*/
static void __pyx_f_4dnet_3arp___dealloc__(PyObject *__pyx_v_self) {
  int __pyx_1;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = (((struct __pyx_obj_4dnet_arp *)__pyx_v_self)->arp != 0);
  if (__pyx_1) {
    arp_close(((struct __pyx_obj_4dnet_arp *)__pyx_v_self)->arp);
    goto __pyx_L2;
  }
  __pyx_L2:;

  Py_DECREF(__pyx_v_self);
}

static PyObject *__pyx_f_4dnet_arp_pack_hdr_ethip(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_arp_pack_hdr_ethip[] = "Return a packed binary string representing an Ethernet/IP ARP message.\n    \n    Keyword arguments:\n    op  -- operation (ARP_OP_*)			(16-bit integer)\n    sha -- sender Ethernet address		(6-byte binary string)\n    spa -- sender IP address			(4-byte binary string)\n    dha -- destination Ethernet address		(6-byte binary string)\n    dpa -- destination IP address		(4-byte binary string)\n    ";
static PyObject *__pyx_f_4dnet_arp_pack_hdr_ethip(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_op = 0;
  PyObject *__pyx_v_sha = 0;
  PyObject *__pyx_v_spa = 0;
  PyObject *__pyx_v_dha = 0;
  PyObject *__pyx_v_dpa = 0;
  char __pyx_v_buf[28];
  eth_addr_t __pyx_v_sh;
  eth_addr_t __pyx_v_dh;
  ip_addr_t __pyx_v_sp;
  ip_addr_t __pyx_v_dp;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  static char *__pyx_argnames[] = {"op","sha","spa","dha","dpa",0};
  __pyx_v_op = __pyx_d22;
  __pyx_v_sha = __pyx_d23;
  __pyx_v_spa = __pyx_d24;
  __pyx_v_dha = __pyx_d25;
  __pyx_v_dpa = __pyx_d26;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|OOOOO", __pyx_argnames, &__pyx_v_op, &__pyx_v_sha, &__pyx_v_spa, &__pyx_v_dha, &__pyx_v_dpa)) return 0;
  Py_INCREF(__pyx_v_op);
  Py_INCREF(__pyx_v_sha);
  Py_INCREF(__pyx_v_spa);
  Py_INCREF(__pyx_v_dha);
  Py_INCREF(__pyx_v_dpa);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":774 */
  __pyx_1 = __pyx_f_4dnet___memcpy(__pyx_v_sh.data,__pyx_v_sha,6); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 774; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":775 */
  __pyx_1 = __pyx_f_4dnet___memcpy(__pyx_v_dh.data,__pyx_v_dha,6); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 775; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":776 */
  __pyx_1 = __pyx_f_4dnet___memcpy(((char *)(&__pyx_v_sp)),__pyx_v_spa,4); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 776; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":777 */
  __pyx_1 = __pyx_f_4dnet___memcpy(((char *)(&__pyx_v_dp)),__pyx_v_dpa,4); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 777; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":778 */
  __pyx_2 = PyInt_AsLong(__pyx_v_op); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 778; goto __pyx_L1;}
  arp_pack_hdr_ethip(__pyx_v_buf,__pyx_2,__pyx_v_sh,__pyx_v_sp,__pyx_v_dh,__pyx_v_dp);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":779 */
  __pyx_1 = PyString_FromStringAndSize(__pyx_v_buf,28); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 779; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.arp_pack_hdr_ethip");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_op);
  Py_DECREF(__pyx_v_sha);
  Py_DECREF(__pyx_v_spa);
  Py_DECREF(__pyx_v_dha);
  Py_DECREF(__pyx_v_dpa);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_icmp_pack_hdr(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_icmp_pack_hdr[] = "Return a packed binary string representing an ICMP header.\n\n    Keyword arguments:\n    type -- ICMP type		(8-bit integer)\n    code -- ICMP code		(8-bit integer)\n    ";
static PyObject *__pyx_f_4dnet_icmp_pack_hdr(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_ptype = 0;
  PyObject *__pyx_v_code = 0;
  char __pyx_v_buf[4];
  PyObject *__pyx_r;
  int __pyx_1;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"ptype","code",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_ptype, &__pyx_v_code)) return 0;
  Py_INCREF(__pyx_v_ptype);
  Py_INCREF(__pyx_v_code);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":795 */
  __pyx_1 = PyInt_AsLong(__pyx_v_ptype); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 795; goto __pyx_L1;}
  __pyx_2 = PyInt_AsLong(__pyx_v_code); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 795; goto __pyx_L1;}
  icmp_pack_hdr(__pyx_v_buf,__pyx_1,__pyx_2);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":796 */
  __pyx_3 = PyString_FromStringAndSize(__pyx_v_buf,(sizeof(__pyx_v_buf))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 796; goto __pyx_L1;}
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("dnet.icmp_pack_hdr");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_ptype);
  Py_DECREF(__pyx_v_code);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_tcp_pack_hdr(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_tcp_pack_hdr[] = "Return a packed binary string representing a TCP header.\n\n    Keyword arguments:\n    sport -- source port		(16-bit integer)\n    dport -- destination port		(16-bit integer)\n    seq   -- sequence number		(32-bit integer)\n    ack   -- acknowledgment number	(32-bit integer)\n    flags -- control flags (TH_*)	(8-bit integer bitmask)\n    win   -- window size		(16-bit integer)\n    urp   -- urgent pointer		(16-bit integer)\n    ";
static PyObject *__pyx_f_4dnet_tcp_pack_hdr(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_sport = 0;
  PyObject *__pyx_v_dport = 0;
  PyObject *__pyx_v_seq = 0;
  PyObject *__pyx_v_ack = 0;
  PyObject *__pyx_v_flags = 0;
  PyObject *__pyx_v_win = 0;
  PyObject *__pyx_v_urp = 0;
  char __pyx_v_buf[20];
  PyObject *__pyx_r;
  int __pyx_1;
  int __pyx_2;
  unsigned long __pyx_3;
  unsigned long __pyx_4;
  int __pyx_5;
  int __pyx_6;
  int __pyx_7;
  PyObject *__pyx_8 = 0;
  static char *__pyx_argnames[] = {"sport","dport","seq","ack","flags","win","urp",0};
  __pyx_v_seq = __pyx_d27;
  __pyx_v_ack = __pyx_d28;
  __pyx_v_flags = __pyx_d29;
  __pyx_v_win = __pyx_d30;
  __pyx_v_urp = __pyx_d31;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO|OOOOO", __pyx_argnames, &__pyx_v_sport, &__pyx_v_dport, &__pyx_v_seq, &__pyx_v_ack, &__pyx_v_flags, &__pyx_v_win, &__pyx_v_urp)) return 0;
  Py_INCREF(__pyx_v_sport);
  Py_INCREF(__pyx_v_dport);
  Py_INCREF(__pyx_v_seq);
  Py_INCREF(__pyx_v_ack);
  Py_INCREF(__pyx_v_flags);
  Py_INCREF(__pyx_v_win);
  Py_INCREF(__pyx_v_urp);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":861 */
  __pyx_1 = PyInt_AsLong(__pyx_v_sport); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 861; goto __pyx_L1;}
  __pyx_2 = PyInt_AsLong(__pyx_v_dport); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 861; goto __pyx_L1;}
  __pyx_3 = PyInt_AsUnsignedLongMask(__pyx_v_seq); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 861; goto __pyx_L1;}
  __pyx_4 = PyInt_AsUnsignedLongMask(__pyx_v_ack); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 861; goto __pyx_L1;}
  __pyx_5 = PyInt_AsLong(__pyx_v_flags); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 861; goto __pyx_L1;}
  __pyx_6 = PyInt_AsLong(__pyx_v_win); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 861; goto __pyx_L1;}
  __pyx_7 = PyInt_AsLong(__pyx_v_urp); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 861; goto __pyx_L1;}
  tcp_pack_hdr(__pyx_v_buf,__pyx_1,__pyx_2,__pyx_3,__pyx_4,__pyx_5,__pyx_6,__pyx_7);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":862 */
  __pyx_8 = PyString_FromStringAndSize(__pyx_v_buf,(sizeof(__pyx_v_buf))); if (!__pyx_8) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 862; goto __pyx_L1;}
  __pyx_r = __pyx_8;
  __pyx_8 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_8);
  __Pyx_AddTraceback("dnet.tcp_pack_hdr");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_sport);
  Py_DECREF(__pyx_v_dport);
  Py_DECREF(__pyx_v_seq);
  Py_DECREF(__pyx_v_ack);
  Py_DECREF(__pyx_v_flags);
  Py_DECREF(__pyx_v_win);
  Py_DECREF(__pyx_v_urp);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_udp_pack_hdr(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_udp_pack_hdr[] = "Return a packed binary string representing a UDP header.\n\n    Keyword arguments:\n    sport -- source port		(16-bit integer)\n    dport -- destination port		(16-bit integer)\n    ulen  -- UDP header + data length	(16-bit integer)\n    ";
static PyObject *__pyx_f_4dnet_udp_pack_hdr(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_sport = 0;
  PyObject *__pyx_v_dport = 0;
  PyObject *__pyx_v_ulen = 0;
  char __pyx_v_buf[8];
  PyObject *__pyx_r;
  int __pyx_1;
  int __pyx_2;
  int __pyx_3;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"sport","dport","ulen",0};
  __pyx_v_ulen = __pyx_d32;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO|O", __pyx_argnames, &__pyx_v_sport, &__pyx_v_dport, &__pyx_v_ulen)) return 0;
  Py_INCREF(__pyx_v_sport);
  Py_INCREF(__pyx_v_dport);
  Py_INCREF(__pyx_v_ulen);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":882 */
  __pyx_1 = PyInt_AsLong(__pyx_v_sport); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 882; goto __pyx_L1;}
  __pyx_2 = PyInt_AsLong(__pyx_v_dport); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 882; goto __pyx_L1;}
  __pyx_3 = PyInt_AsLong(__pyx_v_ulen); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 882; goto __pyx_L1;}
  udp_pack_hdr(__pyx_v_buf,__pyx_1,__pyx_2,__pyx_3);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":883 */
  __pyx_4 = PyString_FromStringAndSize(__pyx_v_buf,(sizeof(__pyx_v_buf))); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 883; goto __pyx_L1;}
  __pyx_r = __pyx_4;
  __pyx_4 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("dnet.udp_pack_hdr");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_sport);
  Py_DECREF(__pyx_v_dport);
  Py_DECREF(__pyx_v_ulen);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_ifent_to_dict(struct intf_entry *__pyx_v_entry) {
  PyObject *__pyx_v_d;
  PyObject *__pyx_v_l;
  PyObject *__pyx_v_i;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  int __pyx_3;
  long __pyx_4;
  unsigned int __pyx_5;
  Py_ssize_t __pyx_6;
  PyObject *__pyx_7 = 0;
  __pyx_v_d = Py_None; Py_INCREF(Py_None);
  __pyx_v_l = Py_None; Py_INCREF(Py_None);
  __pyx_v_i = Py_None; Py_INCREF(Py_None);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":925 */
  __pyx_1 = PyDict_New(); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 925; goto __pyx_L1;}
  Py_DECREF(__pyx_v_d);
  __pyx_v_d = __pyx_1;
  __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":926 */
  __pyx_1 = PyString_FromString(__pyx_v_entry->intf_name); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 926; goto __pyx_L1;}
  if (PyObject_SetItem(__pyx_v_d, __pyx_n_name, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 926; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":927 */
  __pyx_1 = PyInt_FromLong(__pyx_v_entry->intf_type); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 927; goto __pyx_L1;}
  if (PyObject_SetItem(__pyx_v_d, __pyx_n_type, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 927; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":928 */
  __pyx_1 = PyInt_FromLong(__pyx_v_entry->intf_flags); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 928; goto __pyx_L1;}
  if (PyObject_SetItem(__pyx_v_d, __pyx_n_flags, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 928; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":929 */
  __pyx_1 = PyLong_FromUnsignedLong(__pyx_v_entry->intf_mtu); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 929; goto __pyx_L1;}
  if (PyObject_SetItem(__pyx_v_d, __pyx_n_mtu, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 929; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":930 */
  __pyx_1 = PyInt_FromLong(__pyx_v_entry->intf_addr.addr_type); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 930; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_ADDR_TYPE_NONE); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 930; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_1, __pyx_2, &__pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 930; goto __pyx_L1;}
  __pyx_3 = __pyx_3 != 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (__pyx_3) {
    __pyx_1 = PyString_FromString(addr_ntoa((&__pyx_v_entry->intf_addr))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 931; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 931; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_1);
    __pyx_1 = 0;
    __pyx_1 = PyObject_CallObject(((PyObject *)__pyx_ptype_4dnet_addr), __pyx_2); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 931; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (PyObject_SetItem(__pyx_v_d, __pyx_n_addr, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 931; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":932 */
  __pyx_2 = PyInt_FromLong(__pyx_v_entry->intf_dst_addr.addr_type); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 932; goto __pyx_L1;}
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_ADDR_TYPE_NONE); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 932; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_2, __pyx_1, &__pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 932; goto __pyx_L1;}
  __pyx_3 = __pyx_3 != 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_3) {
    __pyx_2 = PyString_FromString(addr_ntoa((&__pyx_v_entry->intf_dst_addr))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 933; goto __pyx_L1;}
    __pyx_1 = PyTuple_New(1); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 933; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_1, 0, __pyx_2);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(((PyObject *)__pyx_ptype_4dnet_addr), __pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 933; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    if (PyObject_SetItem(__pyx_v_d, __pyx_n_dst_addr, __pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 933; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":934 */
  __pyx_1 = PyInt_FromLong(__pyx_v_entry->intf_link_addr.addr_type); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 934; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_ADDR_TYPE_NONE); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 934; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_1, __pyx_2, &__pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 934; goto __pyx_L1;}
  __pyx_3 = __pyx_3 != 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (__pyx_3) {
    __pyx_1 = PyString_FromString(addr_ntoa((&__pyx_v_entry->intf_link_addr))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 935; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 935; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_1);
    __pyx_1 = 0;
    __pyx_1 = PyObject_CallObject(((PyObject *)__pyx_ptype_4dnet_addr), __pyx_2); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 935; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (PyObject_SetItem(__pyx_v_d, __pyx_n_link_addr, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 935; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    goto __pyx_L4;
  }
  __pyx_L4:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":936 */
  __pyx_3 = (__pyx_v_entry->intf_alias_num > 0);
  if (__pyx_3) {

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":937 */
    __pyx_2 = PyList_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 937; goto __pyx_L1;}
    Py_DECREF(__pyx_v_l);
    __pyx_v_l = __pyx_2;
    __pyx_2 = 0;

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":938 */
    __pyx_5 = __pyx_v_entry->intf_alias_num;
    for (__pyx_4 = 0; __pyx_4 < __pyx_5; ++__pyx_4) {
      __pyx_1 = PyInt_FromLong(__pyx_4); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 938; goto __pyx_L1;}
      Py_DECREF(__pyx_v_i);
      __pyx_v_i = __pyx_1;
      __pyx_1 = 0;
      __pyx_2 = PyObject_GetAttr(__pyx_v_l, __pyx_n_append); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 939; goto __pyx_L1;}
      __pyx_6 = PyInt_AsSsize_t(__pyx_v_i); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 939; goto __pyx_L1;}
      __pyx_1 = PyString_FromString(addr_ntoa((&(__pyx_v_entry->intf_alias_addrs[__pyx_6])))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 939; goto __pyx_L1;}
      __pyx_7 = PyTuple_New(1); if (!__pyx_7) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 939; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_7, 0, __pyx_1);
      __pyx_1 = 0;
      __pyx_1 = PyObject_CallObject(((PyObject *)__pyx_ptype_4dnet_addr), __pyx_7); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 939; goto __pyx_L1;}
      Py_DECREF(__pyx_7); __pyx_7 = 0;
      __pyx_7 = PyTuple_New(1); if (!__pyx_7) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 939; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_7, 0, __pyx_1);
      __pyx_1 = 0;
      __pyx_1 = PyObject_CallObject(__pyx_2, __pyx_7); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 939; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_7); __pyx_7 = 0;
      Py_DECREF(__pyx_1); __pyx_1 = 0;
    }

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":940 */
    if (PyObject_SetItem(__pyx_v_d, __pyx_n_alias_addrs, __pyx_v_l) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 940; goto __pyx_L1;}
    goto __pyx_L5;
  }
  __pyx_L5:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":941 */
  Py_INCREF(__pyx_v_d);
  __pyx_r = __pyx_v_d;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_7);
  __Pyx_AddTraceback("dnet.ifent_to_dict");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_d);
  Py_DECREF(__pyx_v_l);
  Py_DECREF(__pyx_v_i);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_dict_to_ifent(PyObject *__pyx_v_d,struct intf_entry *__pyx_v_entry) {
  PyObject *__pyx_v_s;
  PyObject *__pyx_v_i;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  char *__pyx_2;
  int __pyx_3;
  unsigned short __pyx_4;
  unsigned int __pyx_5;
  Py_ssize_t __pyx_6;
  long __pyx_7;
  PyObject *__pyx_8 = 0;
  Py_INCREF(__pyx_v_d);
  __pyx_v_s = Py_None; Py_INCREF(Py_None);
  __pyx_v_i = Py_None; Py_INCREF(Py_None);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":944 */
  __pyx_1 = PyObject_GetItem(__pyx_v_d, __pyx_n_name); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 944; goto __pyx_L1;}
  Py_DECREF(__pyx_v_s);
  __pyx_v_s = __pyx_1;
  __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":945 */
  __pyx_2 = PyString_AsString(__pyx_v_s); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 945; goto __pyx_L1;}
  strlcpy(__pyx_v_entry->intf_name,__pyx_2,16);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":946 */
  __pyx_3 = PySequence_Contains(__pyx_v_d, __pyx_n_flags); if (__pyx_3 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 946; goto __pyx_L1;}
  if (__pyx_3) {
    __pyx_1 = PyObject_GetItem(__pyx_v_d, __pyx_n_flags); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 947; goto __pyx_L1;}
    __pyx_4 = PyInt_AsLong(__pyx_1); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 947; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    __pyx_v_entry->intf_flags = __pyx_4;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":948 */
  __pyx_3 = PySequence_Contains(__pyx_v_d, __pyx_n_mtu); if (__pyx_3 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 948; goto __pyx_L1;}
  if (__pyx_3) {
    __pyx_1 = PyObject_GetItem(__pyx_v_d, __pyx_n_mtu); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 949; goto __pyx_L1;}
    __pyx_5 = PyInt_AsUnsignedLongMask(__pyx_1); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 949; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    __pyx_v_entry->intf_mtu = __pyx_5;
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":950 */
  __pyx_3 = PySequence_Contains(__pyx_v_d, __pyx_n_addr); if (__pyx_3 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 950; goto __pyx_L1;}
  if (__pyx_3) {
    __pyx_1 = PyObject_GetItem(__pyx_v_d, __pyx_n_addr); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 951; goto __pyx_L1;}
    __pyx_v_entry->intf_addr = ((struct __pyx_obj_4dnet_addr *)__pyx_1)->_addr;
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    goto __pyx_L4;
  }
  __pyx_L4:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":952 */
  __pyx_3 = PySequence_Contains(__pyx_v_d, __pyx_n_dst_addr); if (__pyx_3 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 952; goto __pyx_L1;}
  if (__pyx_3) {
    __pyx_1 = PyObject_GetItem(__pyx_v_d, __pyx_n_dst_addr); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 953; goto __pyx_L1;}
    __pyx_v_entry->intf_dst_addr = ((struct __pyx_obj_4dnet_addr *)__pyx_1)->_addr;
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    goto __pyx_L5;
  }
  __pyx_L5:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":954 */
  __pyx_3 = PySequence_Contains(__pyx_v_d, __pyx_n_link_addr); if (__pyx_3 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 954; goto __pyx_L1;}
  if (__pyx_3) {
    __pyx_1 = PyObject_GetItem(__pyx_v_d, __pyx_n_link_addr); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 955; goto __pyx_L1;}
    __pyx_v_entry->intf_link_addr = ((struct __pyx_obj_4dnet_addr *)__pyx_1)->_addr;
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    goto __pyx_L6;
  }
  __pyx_L6:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":956 */
  __pyx_3 = PySequence_Contains(__pyx_v_d, __pyx_n_alias_addrs); if (__pyx_3 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 956; goto __pyx_L1;}
  if (__pyx_3) {

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":957 */
    __pyx_1 = PyObject_GetItem(__pyx_v_d, __pyx_n_alias_addrs); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 957; goto __pyx_L1;}
    __pyx_6 = PyObject_Length(__pyx_1); if (__pyx_6 == -1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 957; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    __pyx_v_entry->intf_alias_num = __pyx_6;

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":958 */
    __pyx_5 = __pyx_v_entry->intf_alias_num;
    for (__pyx_7 = 0; __pyx_7 < __pyx_5; ++__pyx_7) {
      __pyx_1 = PyInt_FromLong(__pyx_7); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 958; goto __pyx_L1;}
      Py_DECREF(__pyx_v_i);
      __pyx_v_i = __pyx_1;
      __pyx_1 = 0;
      __pyx_1 = PyObject_GetItem(__pyx_v_d, __pyx_n_alias_addrs); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 959; goto __pyx_L1;}
      __pyx_8 = PyObject_GetItem(__pyx_1, __pyx_v_i); if (!__pyx_8) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 959; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      __pyx_6 = PyInt_AsSsize_t(__pyx_v_i); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 959; goto __pyx_L1;}
      (__pyx_v_entry->intf_alias_addrs[__pyx_6]) = ((struct __pyx_obj_4dnet_addr *)__pyx_8)->_addr;
      Py_DECREF(__pyx_8); __pyx_8 = 0;
    }
    goto __pyx_L7;
  }
  __pyx_L7:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_8);
  __Pyx_AddTraceback("dnet.dict_to_ifent");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_s);
  Py_DECREF(__pyx_v_i);
  Py_DECREF(__pyx_v_d);
  return __pyx_r;
}

static int __pyx_f_4dnet___intf_callback(struct intf_entry *__pyx_v_entry,void *__pyx_v_arg) {
  PyObject *__pyx_v_f;
  PyObject *__pyx_v_a;
  PyObject *__pyx_v_ret;
  int __pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  int __pyx_3;
  int __pyx_4;
  __pyx_v_f = Py_None; Py_INCREF(Py_None);
  __pyx_v_a = Py_None; Py_INCREF(Py_None);
  __pyx_v_ret = Py_None; Py_INCREF(Py_None);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":962 */
  __pyx_1 = PyObject_GetIter(((PyObject *)__pyx_v_arg)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 962; goto __pyx_L1;}
  __pyx_2 = __Pyx_UnpackItem(__pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 962; goto __pyx_L1;}
  Py_DECREF(__pyx_v_f);
  __pyx_v_f = __pyx_2;
  __pyx_2 = 0;
  __pyx_2 = __Pyx_UnpackItem(__pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 962; goto __pyx_L1;}
  Py_DECREF(__pyx_v_a);
  __pyx_v_a = __pyx_2;
  __pyx_2 = 0;
  if (__Pyx_EndUnpack(__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 962; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":963 */
  __pyx_2 = __pyx_f_4dnet_ifent_to_dict(__pyx_v_entry); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 963; goto __pyx_L1;}
  __pyx_1 = PyTuple_New(2); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 963; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_1, 0, __pyx_2);
  Py_INCREF(__pyx_v_a);
  PyTuple_SET_ITEM(__pyx_1, 1, __pyx_v_a);
  __pyx_2 = 0;
  __pyx_2 = PyObject_CallObject(__pyx_v_f, __pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 963; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_v_ret);
  __pyx_v_ret = __pyx_2;
  __pyx_2 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":964 */
  __pyx_3 = PyObject_IsTrue(__pyx_v_ret); if (__pyx_3 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 964; goto __pyx_L1;}
  __pyx_4 = (!__pyx_3);
  if (__pyx_4) {
    __pyx_1 = PyInt_FromLong(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 965; goto __pyx_L1;}
    Py_DECREF(__pyx_v_ret);
    __pyx_v_ret = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":966 */
  __pyx_3 = PyInt_AsLong(__pyx_v_ret); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 966; goto __pyx_L1;}
  __pyx_r = __pyx_3;
  goto __pyx_L0;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.__intf_callback");
  __pyx_r = (-1);
  __pyx_L0:;
  Py_DECREF(__pyx_v_f);
  Py_DECREF(__pyx_v_a);
  Py_DECREF(__pyx_v_ret);
  return __pyx_r;
}

static int __pyx_f_4dnet_4intf___init__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static int __pyx_f_4dnet_4intf___init__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return -1;
  Py_INCREF(__pyx_v_self);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":976 */
  ((struct __pyx_obj_4dnet_intf *)__pyx_v_self)->intf = intf_open();

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":977 */
  __pyx_1 = (!(((struct __pyx_obj_4dnet_intf *)__pyx_v_self)->intf != 0));
  if (__pyx_1) {
    __pyx_2 = __pyx_f_4dnet___oserror(); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 978; goto __pyx_L1;}
    __Pyx_Raise(PyExc_OSError, __pyx_2, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 978; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.intf.__init__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4intf_get(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_4intf_get[] = "Return the configuration for a network interface as a dict.\n        ";
static PyObject *__pyx_f_4dnet_4intf_get(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_name = 0;
  struct intf_entry *__pyx_v_ifent;
  char __pyx_v_buf[1024];
  PyObject *__pyx_r;
  char *__pyx_1;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"name",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_name)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_name);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":985 */
  __pyx_v_ifent = ((struct intf_entry *)__pyx_v_buf);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":986 */
  __pyx_v_ifent->intf_len = 1024;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":987 */
  __pyx_1 = PyString_AsString(__pyx_v_name); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 987; goto __pyx_L1;}
  strlcpy(__pyx_v_ifent->intf_name,__pyx_1,16);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":988 */
  __pyx_2 = (intf_get(((struct __pyx_obj_4dnet_intf *)__pyx_v_self)->intf,__pyx_v_ifent) < 0);
  if (__pyx_2) {
    __pyx_3 = __pyx_f_4dnet___oserror(); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 989; goto __pyx_L1;}
    __Pyx_Raise(PyExc_OSError, __pyx_3, 0);
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 989; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":990 */
  __pyx_3 = __pyx_f_4dnet_ifent_to_dict(__pyx_v_ifent); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 990; goto __pyx_L1;}
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("dnet.intf.get");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_name);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4intf_get_src(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_4intf_get_src[] = "Return the configuration for the interface whose primary address\n        matches the specified source address.\n        ";
static PyObject *__pyx_f_4dnet_4intf_get_src(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_4dnet_addr *__pyx_v_src = 0;
  struct intf_entry *__pyx_v_ifent;
  char __pyx_v_buf[1024];
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {"src",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_src)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_src);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_src), __pyx_ptype_4dnet_addr, 1, "src")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 992; goto __pyx_L1;}

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":998 */
  __pyx_v_ifent = ((struct intf_entry *)__pyx_v_buf);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":999 */
  __pyx_v_ifent->intf_len = 1024;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1000 */
  __pyx_1 = (intf_get_src(((struct __pyx_obj_4dnet_intf *)__pyx_v_self)->intf,__pyx_v_ifent,(&__pyx_v_src->_addr)) < 0);
  if (__pyx_1) {
    __pyx_2 = __pyx_f_4dnet___oserror(); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1001; goto __pyx_L1;}
    __Pyx_Raise(PyExc_OSError, __pyx_2, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1001; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1002 */
  __pyx_2 = __pyx_f_4dnet_ifent_to_dict(__pyx_v_ifent); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1002; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.intf.get_src");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_src);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4intf_get_dst(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_4intf_get_dst[] = "Return the configuration for the best interface with which to\n        reach the specified dst address.\n        ";
static PyObject *__pyx_f_4dnet_4intf_get_dst(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_4dnet_addr *__pyx_v_dst = 0;
  struct intf_entry *__pyx_v_ifent;
  char __pyx_v_buf[1024];
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {"dst",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_dst)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_dst);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_dst), __pyx_ptype_4dnet_addr, 1, "dst")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1004; goto __pyx_L1;}

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1010 */
  __pyx_v_ifent = ((struct intf_entry *)__pyx_v_buf);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1011 */
  __pyx_v_ifent->intf_len = 1024;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1012 */
  __pyx_1 = (intf_get_dst(((struct __pyx_obj_4dnet_intf *)__pyx_v_self)->intf,__pyx_v_ifent,(&__pyx_v_dst->_addr)) < 0);
  if (__pyx_1) {
    __pyx_2 = __pyx_f_4dnet___oserror(); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1013; goto __pyx_L1;}
    __Pyx_Raise(PyExc_OSError, __pyx_2, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1013; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1014 */
  __pyx_2 = __pyx_f_4dnet_ifent_to_dict(__pyx_v_ifent); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1014; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.intf.get_dst");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_dst);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4intf_set(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_4intf_set[] = "Set the configuration for an interface from a dict.\n\n        Dict values:\n        name        -- name of interface to set		(string)\n        flags       -- interface flags (INTF_FLAG_*)	(integer bitmask)\n        mtu         -- interface MTU			(integer)\n        addr        -- primary network address		(addr object)\n        dst_addr    -- point-to-point dst address	(addr object)\n        link_addr   -- link-layer address		(addr object)\n        alias_addrs -- additional network addresses	(list of addr objects)\n        ";
static PyObject *__pyx_f_4dnet_4intf_set(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_d = 0;
  struct intf_entry *__pyx_v_ifent;
  char __pyx_v_buf[1024];
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  static char *__pyx_argnames[] = {"d",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_d)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_d);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1030 */
  memset(__pyx_v_buf,0,(sizeof(__pyx_v_buf)));

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1031 */
  __pyx_v_ifent = ((struct intf_entry *)__pyx_v_buf);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1032 */
  __pyx_v_ifent->intf_len = 1024;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1033 */
  __pyx_1 = __pyx_f_4dnet_dict_to_ifent(__pyx_v_d,__pyx_v_ifent); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1033; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1034 */
  __pyx_2 = (intf_set(((struct __pyx_obj_4dnet_intf *)__pyx_v_self)->intf,__pyx_v_ifent) < 0);
  if (__pyx_2) {
    __pyx_1 = __pyx_f_4dnet___oserror(); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1035; goto __pyx_L1;}
    __Pyx_Raise(PyExc_OSError, __pyx_1, 0);
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1035; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.intf.set");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_d);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4intf_loop(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_4intf_loop[] = "Iterate over the system interface table, invoking a user callback\n        with each entry, returning the status of the callback routine.\n\n        Keyword arguments:\n        callback -- callback function with (dict, arg) prototype.\n                    If this function returns a non-zero value, the loop\n                    will break early.\n        arg      -- optional callback argument\n        ";
static PyObject *__pyx_f_4dnet_4intf_loop(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_callback = 0;
  PyObject *__pyx_v_arg = 0;
  PyObject *__pyx_v__arg;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"callback","arg",0};
  __pyx_v_arg = __pyx_d33;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|O", __pyx_argnames, &__pyx_v_callback, &__pyx_v_arg)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_callback);
  Py_INCREF(__pyx_v_arg);
  __pyx_v__arg = Py_None; Py_INCREF(Py_None);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1047 */
  __pyx_1 = PyTuple_New(2); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1047; goto __pyx_L1;}
  Py_INCREF(__pyx_v_callback);
  PyTuple_SET_ITEM(__pyx_1, 0, __pyx_v_callback);
  Py_INCREF(__pyx_v_arg);
  PyTuple_SET_ITEM(__pyx_1, 1, __pyx_v_arg);
  Py_DECREF(__pyx_v__arg);
  __pyx_v__arg = __pyx_1;
  __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1048 */
  __pyx_1 = PyInt_FromLong(intf_loop(((struct __pyx_obj_4dnet_intf *)__pyx_v_self)->intf,__pyx_f_4dnet___intf_callback,((void *)__pyx_v__arg))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1048; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.intf.loop");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__arg);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_callback);
  Py_DECREF(__pyx_v_arg);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4intf___iter__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_4dnet_4intf___iter__(PyObject *__pyx_v_self) {
  PyObject *__pyx_v_l;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_l = Py_None; Py_INCREF(Py_None);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1051 */
  __pyx_1 = PyList_New(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1051; goto __pyx_L1;}
  Py_DECREF(__pyx_v_l);
  __pyx_v_l = __pyx_1;
  __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1052 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_loop); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1052; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n___iter_append); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1052; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1052; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
  Py_INCREF(__pyx_v_l);
  PyTuple_SET_ITEM(__pyx_3, 1, __pyx_v_l);
  __pyx_2 = 0;
  __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1052; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1053 */
  __pyx_1 = PyObject_GetIter(__pyx_v_l); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1053; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("dnet.intf.__iter__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_l);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static void __pyx_f_4dnet_4intf___dealloc__(PyObject *__pyx_v_self); /*proto*/
static void __pyx_f_4dnet_4intf___dealloc__(PyObject *__pyx_v_self) {
  int __pyx_1;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = (((struct __pyx_obj_4dnet_intf *)__pyx_v_self)->intf != 0);
  if (__pyx_1) {
    intf_close(((struct __pyx_obj_4dnet_intf *)__pyx_v_self)->intf);
    goto __pyx_L2;
  }
  __pyx_L2:;

  Py_DECREF(__pyx_v_self);
}

static int __pyx_f_4dnet___route_callback(struct route_entry *__pyx_v_entry,void *__pyx_v_arg) {
  PyObject *__pyx_v_f;
  PyObject *__pyx_v_a;
  PyObject *__pyx_v_dst;
  PyObject *__pyx_v_gw;
  PyObject *__pyx_v_ret;
  int __pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  int __pyx_3;
  int __pyx_4;
  __pyx_v_f = Py_None; Py_INCREF(Py_None);
  __pyx_v_a = Py_None; Py_INCREF(Py_None);
  __pyx_v_dst = Py_None; Py_INCREF(Py_None);
  __pyx_v_gw = Py_None; Py_INCREF(Py_None);
  __pyx_v_ret = Py_None; Py_INCREF(Py_None);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1078 */
  __pyx_1 = PyObject_GetIter(((PyObject *)__pyx_v_arg)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1078; goto __pyx_L1;}
  __pyx_2 = __Pyx_UnpackItem(__pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1078; goto __pyx_L1;}
  Py_DECREF(__pyx_v_f);
  __pyx_v_f = __pyx_2;
  __pyx_2 = 0;
  __pyx_2 = __Pyx_UnpackItem(__pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1078; goto __pyx_L1;}
  Py_DECREF(__pyx_v_a);
  __pyx_v_a = __pyx_2;
  __pyx_2 = 0;
  if (__Pyx_EndUnpack(__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1078; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1079 */
  __pyx_2 = PyObject_CallObject(((PyObject *)__pyx_ptype_4dnet_addr), 0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1079; goto __pyx_L1;}
  __pyx_1 = PyObject_CallObject(((PyObject *)__pyx_ptype_4dnet_addr), 0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1079; goto __pyx_L1;}
  Py_DECREF(__pyx_v_dst);
  __pyx_v_dst = __pyx_2;
  __pyx_2 = 0;
  Py_DECREF(__pyx_v_gw);
  __pyx_v_gw = __pyx_1;
  __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1080 */
  ((struct __pyx_obj_4dnet_addr *)__pyx_v_dst)->_addr = __pyx_v_entry->route_dst;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1081 */
  ((struct __pyx_obj_4dnet_addr *)__pyx_v_gw)->_addr = __pyx_v_entry->route_gw;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1082 */
  __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1082; goto __pyx_L1;}
  Py_INCREF(__pyx_v_dst);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_dst);
  Py_INCREF(__pyx_v_gw);
  PyTuple_SET_ITEM(__pyx_2, 1, __pyx_v_gw);
  __pyx_1 = PyTuple_New(2); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1082; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_1, 0, __pyx_2);
  Py_INCREF(__pyx_v_a);
  PyTuple_SET_ITEM(__pyx_1, 1, __pyx_v_a);
  __pyx_2 = 0;
  __pyx_2 = PyObject_CallObject(__pyx_v_f, __pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1082; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_v_ret);
  __pyx_v_ret = __pyx_2;
  __pyx_2 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1083 */
  __pyx_3 = PyObject_IsTrue(__pyx_v_ret); if (__pyx_3 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1083; goto __pyx_L1;}
  __pyx_4 = (!__pyx_3);
  if (__pyx_4) {
    __pyx_1 = PyInt_FromLong(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1084; goto __pyx_L1;}
    Py_DECREF(__pyx_v_ret);
    __pyx_v_ret = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1085 */
  __pyx_3 = PyInt_AsLong(__pyx_v_ret); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1085; goto __pyx_L1;}
  __pyx_r = __pyx_3;
  goto __pyx_L0;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.__route_callback");
  __pyx_r = (-1);
  __pyx_L0:;
  Py_DECREF(__pyx_v_f);
  Py_DECREF(__pyx_v_a);
  Py_DECREF(__pyx_v_dst);
  Py_DECREF(__pyx_v_gw);
  Py_DECREF(__pyx_v_ret);
  return __pyx_r;
}

static int __pyx_f_4dnet_5route___init__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static int __pyx_f_4dnet_5route___init__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return -1;
  Py_INCREF(__pyx_v_self);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1095 */
  ((struct __pyx_obj_4dnet_route *)__pyx_v_self)->route = route_open();

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1096 */
  __pyx_1 = (!(((struct __pyx_obj_4dnet_route *)__pyx_v_self)->route != 0));
  if (__pyx_1) {
    __pyx_2 = __pyx_f_4dnet___oserror(); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1097; goto __pyx_L1;}
    __Pyx_Raise(PyExc_OSError, __pyx_2, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1097; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.route.__init__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_5route_add(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_5route_add[] = "Add an entry to the system routing table.\n\n        Arguments:\n        dst -- ADDR_TYPE_IP network address object\n        gw -- ADDR_TYPE_IP network address object\n        ";
static PyObject *__pyx_f_4dnet_5route_add(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_4dnet_addr *__pyx_v_dst = 0;
  struct __pyx_obj_4dnet_addr *__pyx_v_gw = 0;
  struct route_entry __pyx_v_entry;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {"dst","gw",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_dst, &__pyx_v_gw)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_dst);
  Py_INCREF(__pyx_v_gw);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_dst), __pyx_ptype_4dnet_addr, 1, "dst")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1099; goto __pyx_L1;}
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_gw), __pyx_ptype_4dnet_addr, 1, "gw")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1099; goto __pyx_L1;}

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1107 */
  __pyx_v_entry.route_dst = __pyx_v_dst->_addr;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1108 */
  __pyx_v_entry.route_gw = __pyx_v_gw->_addr;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1109 */
  __pyx_1 = (route_add(((struct __pyx_obj_4dnet_route *)__pyx_v_self)->route,(&__pyx_v_entry)) < 0);
  if (__pyx_1) {
    __pyx_2 = __pyx_f_4dnet___oserror(); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1110; goto __pyx_L1;}
    __Pyx_Raise(PyExc_OSError, __pyx_2, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1110; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.route.add");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_dst);
  Py_DECREF(__pyx_v_gw);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_5route_delete(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_5route_delete[] = "Delete an entry from the system routing table.\n\n        Arguments:\n        dst -- ADDR_TYPE_IP network address object\n        ";
static PyObject *__pyx_f_4dnet_5route_delete(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_4dnet_addr *__pyx_v_dst = 0;
  struct route_entry __pyx_v_entry;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {"dst",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_dst)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_dst);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_dst), __pyx_ptype_4dnet_addr, 1, "dst")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1112; goto __pyx_L1;}

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1119 */
  __pyx_v_entry.route_dst = __pyx_v_dst->_addr;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1120 */
  __pyx_1 = (route_delete(((struct __pyx_obj_4dnet_route *)__pyx_v_self)->route,(&__pyx_v_entry)) < 0);
  if (__pyx_1) {
    __pyx_2 = __pyx_f_4dnet___oserror(); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1121; goto __pyx_L1;}
    __Pyx_Raise(PyExc_OSError, __pyx_2, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1121; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.route.delete");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_dst);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_5route_get(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_5route_get[] = "Return the hardware address for a given protocol address\n        in the system routing table.\n\n        Arguments:\n        dst -- ADDR_TYPE_IP network address object\n        ";
static PyObject *__pyx_f_4dnet_5route_get(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_4dnet_addr *__pyx_v_dst = 0;
  struct route_entry __pyx_v_entry;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"dst",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_dst)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_dst);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_dst), __pyx_ptype_4dnet_addr, 1, "dst")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1123; goto __pyx_L1;}

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1131 */
  __pyx_v_entry.route_dst = __pyx_v_dst->_addr;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1132 */
  __pyx_1 = (route_get(((struct __pyx_obj_4dnet_route *)__pyx_v_self)->route,(&__pyx_v_entry)) == 0);
  if (__pyx_1) {
    __pyx_2 = PyString_FromString(addr_ntoa((&__pyx_v_entry.route_gw))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1133; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1133; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(((PyObject *)__pyx_ptype_4dnet_addr), __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1133; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1134 */
  Py_INCREF(Py_None);
  __pyx_r = Py_None;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("dnet.route.get");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_dst);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_5route_loop(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_5route_loop[] = "Iterate over the system routing table, invoking a user callback\n        with each entry, returning the status of the callback routine.\n\n        Keyword arguments:\n        callback -- callback function with ((dst, gw), arg) prototype.\n                    If this function returns a non-zero value, the loop\n                    will break early.\n        arg      -- optional callback argument\n        ";
static PyObject *__pyx_f_4dnet_5route_loop(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_callback = 0;
  PyObject *__pyx_v_arg = 0;
  PyObject *__pyx_v__arg;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"callback","arg",0};
  __pyx_v_arg = __pyx_d34;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|O", __pyx_argnames, &__pyx_v_callback, &__pyx_v_arg)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_callback);
  Py_INCREF(__pyx_v_arg);
  __pyx_v__arg = Py_None; Py_INCREF(Py_None);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1146 */
  __pyx_1 = PyTuple_New(2); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1146; goto __pyx_L1;}
  Py_INCREF(__pyx_v_callback);
  PyTuple_SET_ITEM(__pyx_1, 0, __pyx_v_callback);
  Py_INCREF(__pyx_v_arg);
  PyTuple_SET_ITEM(__pyx_1, 1, __pyx_v_arg);
  Py_DECREF(__pyx_v__arg);
  __pyx_v__arg = __pyx_1;
  __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1147 */
  __pyx_1 = PyInt_FromLong(route_loop(((struct __pyx_obj_4dnet_route *)__pyx_v_self)->route,__pyx_f_4dnet___route_callback,((void *)__pyx_v__arg))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1147; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.route.loop");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__arg);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_callback);
  Py_DECREF(__pyx_v_arg);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_5route___iter__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_4dnet_5route___iter__(PyObject *__pyx_v_self) {
  PyObject *__pyx_v_l;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_l = Py_None; Py_INCREF(Py_None);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1150 */
  __pyx_1 = PyList_New(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1150; goto __pyx_L1;}
  Py_DECREF(__pyx_v_l);
  __pyx_v_l = __pyx_1;
  __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1151 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_loop); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1151; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n___iter_append); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1151; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1151; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
  Py_INCREF(__pyx_v_l);
  PyTuple_SET_ITEM(__pyx_3, 1, __pyx_v_l);
  __pyx_2 = 0;
  __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1151; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1152 */
  __pyx_1 = PyObject_GetIter(__pyx_v_l); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1152; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("dnet.route.__iter__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_l);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static void __pyx_f_4dnet_5route___dealloc__(PyObject *__pyx_v_self); /*proto*/
static void __pyx_f_4dnet_5route___dealloc__(PyObject *__pyx_v_self) {
  int __pyx_1;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = (((struct __pyx_obj_4dnet_route *)__pyx_v_self)->route != 0);
  if (__pyx_1) {
    route_close(((struct __pyx_obj_4dnet_route *)__pyx_v_self)->route);
    goto __pyx_L2;
  }
  __pyx_L2:;

  Py_DECREF(__pyx_v_self);
}

static PyObject *__pyx_f_4dnet_rule_to_dict(struct fw_rule *__pyx_v_rule) {
  PyObject *__pyx_v_d;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  PyObject *__pyx_5 = 0;
  __pyx_v_d = Py_None; Py_INCREF(Py_None);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1189 */
  __pyx_1 = PyDict_New(); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1189; goto __pyx_L1;}
  Py_DECREF(__pyx_v_d);
  __pyx_v_d = __pyx_1;
  __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1190 */
  __pyx_1 = PyString_FromString(__pyx_v_rule->fw_device); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1190; goto __pyx_L1;}
  if (PyObject_SetItem(__pyx_v_d, __pyx_n_device, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1190; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1191 */
  __pyx_1 = PyInt_FromLong(__pyx_v_rule->fw_op); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1191; goto __pyx_L1;}
  if (PyObject_SetItem(__pyx_v_d, __pyx_n_op, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1191; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1192 */
  __pyx_1 = PyInt_FromLong(__pyx_v_rule->fw_dir); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1192; goto __pyx_L1;}
  if (PyObject_SetItem(__pyx_v_d, __pyx_n_dir, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1192; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1193 */
  __pyx_2 = (__pyx_v_rule->fw_proto != 0);
  if (__pyx_2) {
    __pyx_1 = PyInt_FromLong(__pyx_v_rule->fw_proto); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1194; goto __pyx_L1;}
    if (PyObject_SetItem(__pyx_v_d, __pyx_n_proto, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1194; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1195 */
  __pyx_1 = PyInt_FromLong(__pyx_v_rule->fw_src.addr_type); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1195; goto __pyx_L1;}
  __pyx_3 = __Pyx_GetName(__pyx_m, __pyx_n_ADDR_TYPE_NONE); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1195; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_1, __pyx_3, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1195; goto __pyx_L1;}
  __pyx_2 = __pyx_2 != 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  if (__pyx_2) {
    __pyx_1 = PyString_FromString(addr_ntoa((&__pyx_v_rule->fw_src))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1196; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1196; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_1);
    __pyx_1 = 0;
    __pyx_1 = PyObject_CallObject(((PyObject *)__pyx_ptype_4dnet_addr), __pyx_3); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1196; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    if (PyObject_SetItem(__pyx_v_d, __pyx_n_src, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1196; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1197 */
  __pyx_3 = PyInt_FromLong(__pyx_v_rule->fw_dst.addr_type); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1197; goto __pyx_L1;}
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_ADDR_TYPE_NONE); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1197; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_3, __pyx_1, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1197; goto __pyx_L1;}
  __pyx_2 = __pyx_2 != 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_2) {
    __pyx_3 = PyString_FromString(addr_ntoa((&__pyx_v_rule->fw_dst))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1198; goto __pyx_L1;}
    __pyx_1 = PyTuple_New(1); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1198; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_1, 0, __pyx_3);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(((PyObject *)__pyx_ptype_4dnet_addr), __pyx_1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1198; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    if (PyObject_SetItem(__pyx_v_d, __pyx_n_dst, __pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1198; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L4;
  }
  __pyx_L4:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1199 */
  __pyx_2 = ((__pyx_v_rule->fw_sport[0]) == 0);
  if (__pyx_2) {
    __pyx_2 = ((__pyx_v_rule->fw_sport[1]) == 0);
  }
  __pyx_4 = (!__pyx_2);
  if (__pyx_4) {
    __pyx_1 = PyInt_FromLong((__pyx_v_rule->fw_sport[0])); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1200; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong((__pyx_v_rule->fw_sport[1])); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1200; goto __pyx_L1;}
    __pyx_5 = PyList_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1200; goto __pyx_L1;}
    PyList_SET_ITEM(__pyx_5, 0, __pyx_1);
    PyList_SET_ITEM(__pyx_5, 1, __pyx_3);
    __pyx_1 = 0;
    __pyx_3 = 0;
    if (PyObject_SetItem(__pyx_v_d, __pyx_n_sport, __pyx_5) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1200; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    goto __pyx_L5;
  }
  __pyx_L5:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1201 */
  __pyx_2 = ((__pyx_v_rule->fw_dport[0]) == 0);
  if (__pyx_2) {
    __pyx_2 = ((__pyx_v_rule->fw_dport[1]) == 0);
  }
  __pyx_4 = (!__pyx_2);
  if (__pyx_4) {
    __pyx_1 = PyInt_FromLong((__pyx_v_rule->fw_dport[0])); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1202; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong((__pyx_v_rule->fw_dport[1])); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1202; goto __pyx_L1;}
    __pyx_5 = PyList_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1202; goto __pyx_L1;}
    PyList_SET_ITEM(__pyx_5, 0, __pyx_1);
    PyList_SET_ITEM(__pyx_5, 1, __pyx_3);
    __pyx_1 = 0;
    __pyx_3 = 0;
    if (PyObject_SetItem(__pyx_v_d, __pyx_n_dport, __pyx_5) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1202; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    goto __pyx_L6;
  }
  __pyx_L6:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1203 */
  Py_INCREF(__pyx_v_d);
  __pyx_r = __pyx_v_d;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("dnet.rule_to_dict");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_d);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_dict_to_rule(PyObject *__pyx_v_d,struct fw_rule *__pyx_v_rule) {
  PyObject *__pyx_v_s;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  char *__pyx_2;
  int __pyx_3;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  Py_INCREF(__pyx_v_d);
  __pyx_v_s = Py_None; Py_INCREF(Py_None);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1206 */
  __pyx_1 = PyObject_GetItem(__pyx_v_d, __pyx_n_device); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1206; goto __pyx_L1;}
  Py_DECREF(__pyx_v_s);
  __pyx_v_s = __pyx_1;
  __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1207 */
  __pyx_2 = PyString_AsString(__pyx_v_s); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1207; goto __pyx_L1;}
  strlcpy(__pyx_v_rule->fw_device,__pyx_2,16);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1208 */
  __pyx_1 = PyObject_GetItem(__pyx_v_d, __pyx_n_op); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1208; goto __pyx_L1;}
  __pyx_3 = PyInt_AsLong(__pyx_1); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1208; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  __pyx_v_rule->fw_op = __pyx_3;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1209 */
  __pyx_1 = PyObject_GetItem(__pyx_v_d, __pyx_n_dir); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1209; goto __pyx_L1;}
  __pyx_3 = PyInt_AsLong(__pyx_1); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1209; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  __pyx_v_rule->fw_dir = __pyx_3;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1210 */
  __pyx_3 = PySequence_Contains(__pyx_v_d, __pyx_n_proto); if (__pyx_3 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1210; goto __pyx_L1;}
  if (__pyx_3) {

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1211 */
    __pyx_1 = PyObject_GetItem(__pyx_v_d, __pyx_n_proto); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1211; goto __pyx_L1;}
    __pyx_3 = PyInt_AsLong(__pyx_1); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1211; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    __pyx_v_rule->fw_proto = __pyx_3;

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1212 */
    __pyx_1 = PyInt_FromLong(__pyx_v_rule->fw_proto); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1212; goto __pyx_L1;}
    __pyx_4 = __Pyx_GetName(__pyx_m, __pyx_n_IP_PROTO_TCP); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1212; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_1, __pyx_4, &__pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1212; goto __pyx_L1;}
    __pyx_3 = __pyx_3 == 0;
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    if (!__pyx_3) {
      __pyx_1 = PyInt_FromLong(__pyx_v_rule->fw_proto); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1212; goto __pyx_L1;}
      __pyx_4 = __Pyx_GetName(__pyx_m, __pyx_n_IP_PROTO_UDP); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1212; goto __pyx_L1;}
      if (PyObject_Cmp(__pyx_1, __pyx_4, &__pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1212; goto __pyx_L1;}
      __pyx_3 = __pyx_3 == 0;
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
    }
    if (__pyx_3) {

      /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1213 */
      (__pyx_v_rule->fw_sport[1]) = 65535;

      /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1214 */
      (__pyx_v_rule->fw_dport[1]) = 65535;
      goto __pyx_L3;
    }
    __pyx_L3:;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1215 */
  __pyx_3 = PySequence_Contains(__pyx_v_d, __pyx_n_src); if (__pyx_3 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1215; goto __pyx_L1;}
  if (__pyx_3) {
    __pyx_1 = PyObject_GetItem(__pyx_v_d, __pyx_n_src); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1216; goto __pyx_L1;}
    __pyx_v_rule->fw_src = ((struct __pyx_obj_4dnet_addr *)__pyx_1)->_addr;
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    goto __pyx_L4;
  }
  __pyx_L4:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1217 */
  __pyx_3 = PySequence_Contains(__pyx_v_d, __pyx_n_dst); if (__pyx_3 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1217; goto __pyx_L1;}
  if (__pyx_3) {
    __pyx_4 = PyObject_GetItem(__pyx_v_d, __pyx_n_dst); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1218; goto __pyx_L1;}
    __pyx_v_rule->fw_dst = ((struct __pyx_obj_4dnet_addr *)__pyx_4)->_addr;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    goto __pyx_L5;
  }
  __pyx_L5:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1219 */
  __pyx_3 = PySequence_Contains(__pyx_v_d, __pyx_n_sport); if (__pyx_3 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1219; goto __pyx_L1;}
  if (__pyx_3) {

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1220 */
    __pyx_1 = PyObject_GetItem(__pyx_v_d, __pyx_n_sport); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1220; goto __pyx_L1;}
    __pyx_4 = PyInt_FromLong(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1220; goto __pyx_L1;}
    __pyx_5 = PyObject_GetItem(__pyx_1, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1220; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_3 = PyInt_AsLong(__pyx_5); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1220; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    (__pyx_v_rule->fw_sport[0]) = __pyx_3;

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1221 */
    __pyx_1 = PyObject_GetItem(__pyx_v_d, __pyx_n_sport); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1221; goto __pyx_L1;}
    __pyx_4 = PyInt_FromLong(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1221; goto __pyx_L1;}
    __pyx_5 = PyObject_GetItem(__pyx_1, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1221; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_3 = PyInt_AsLong(__pyx_5); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1221; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    (__pyx_v_rule->fw_sport[1]) = __pyx_3;
    goto __pyx_L6;
  }
  __pyx_L6:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1222 */
  __pyx_3 = PySequence_Contains(__pyx_v_d, __pyx_n_dport); if (__pyx_3 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1222; goto __pyx_L1;}
  if (__pyx_3) {

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1223 */
    __pyx_1 = PyObject_GetItem(__pyx_v_d, __pyx_n_dport); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1223; goto __pyx_L1;}
    __pyx_4 = PyInt_FromLong(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1223; goto __pyx_L1;}
    __pyx_5 = PyObject_GetItem(__pyx_1, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1223; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_3 = PyInt_AsLong(__pyx_5); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1223; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    (__pyx_v_rule->fw_dport[0]) = __pyx_3;

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1224 */
    __pyx_1 = PyObject_GetItem(__pyx_v_d, __pyx_n_dport); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1224; goto __pyx_L1;}
    __pyx_4 = PyInt_FromLong(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1224; goto __pyx_L1;}
    __pyx_5 = PyObject_GetItem(__pyx_1, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1224; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_3 = PyInt_AsLong(__pyx_5); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1224; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    (__pyx_v_rule->fw_dport[1]) = __pyx_3;
    goto __pyx_L7;
  }
  __pyx_L7:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("dnet.dict_to_rule");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_s);
  Py_DECREF(__pyx_v_d);
  return __pyx_r;
}

static int __pyx_f_4dnet___fw_callback(struct fw_rule *__pyx_v_rule,void *__pyx_v_arg) {
  PyObject *__pyx_v_f;
  PyObject *__pyx_v_a;
  PyObject *__pyx_v_ret;
  int __pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  int __pyx_3;
  int __pyx_4;
  __pyx_v_f = Py_None; Py_INCREF(Py_None);
  __pyx_v_a = Py_None; Py_INCREF(Py_None);
  __pyx_v_ret = Py_None; Py_INCREF(Py_None);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1227 */
  __pyx_1 = PyObject_GetIter(((PyObject *)__pyx_v_arg)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1227; goto __pyx_L1;}
  __pyx_2 = __Pyx_UnpackItem(__pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1227; goto __pyx_L1;}
  Py_DECREF(__pyx_v_f);
  __pyx_v_f = __pyx_2;
  __pyx_2 = 0;
  __pyx_2 = __Pyx_UnpackItem(__pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1227; goto __pyx_L1;}
  Py_DECREF(__pyx_v_a);
  __pyx_v_a = __pyx_2;
  __pyx_2 = 0;
  if (__Pyx_EndUnpack(__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1227; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1228 */
  __pyx_2 = __pyx_f_4dnet_rule_to_dict(__pyx_v_rule); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1228; goto __pyx_L1;}
  __pyx_1 = PyTuple_New(2); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1228; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_1, 0, __pyx_2);
  Py_INCREF(__pyx_v_a);
  PyTuple_SET_ITEM(__pyx_1, 1, __pyx_v_a);
  __pyx_2 = 0;
  __pyx_2 = PyObject_CallObject(__pyx_v_f, __pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1228; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_v_ret);
  __pyx_v_ret = __pyx_2;
  __pyx_2 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1229 */
  __pyx_3 = PyObject_IsTrue(__pyx_v_ret); if (__pyx_3 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1229; goto __pyx_L1;}
  __pyx_4 = (!__pyx_3);
  if (__pyx_4) {
    __pyx_1 = PyInt_FromLong(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1230; goto __pyx_L1;}
    Py_DECREF(__pyx_v_ret);
    __pyx_v_ret = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1231 */
  __pyx_3 = PyInt_AsLong(__pyx_v_ret); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1231; goto __pyx_L1;}
  __pyx_r = __pyx_3;
  goto __pyx_L0;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.__fw_callback");
  __pyx_r = (-1);
  __pyx_L0:;
  Py_DECREF(__pyx_v_f);
  Py_DECREF(__pyx_v_a);
  Py_DECREF(__pyx_v_ret);
  return __pyx_r;
}

static int __pyx_f_4dnet_2fw___init__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static int __pyx_f_4dnet_2fw___init__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return -1;
  Py_INCREF(__pyx_v_self);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1241 */
  ((struct __pyx_obj_4dnet_fw *)__pyx_v_self)->fw = fw_open();

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1242 */
  __pyx_1 = (!(((struct __pyx_obj_4dnet_fw *)__pyx_v_self)->fw != 0));
  if (__pyx_1) {
    __pyx_2 = __pyx_f_4dnet___oserror(); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1243; goto __pyx_L1;}
    __Pyx_Raise(PyExc_OSError, __pyx_2, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1243; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.fw.__init__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_2fw_add(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_2fw_add[] = "Add a firewall rule specified as a dict.\n\n        Dict values:\n        device -- interface name			(string)\n        op     -- operation (FW_OP_*)			(integer)\n        dir    -- direction (FW_DIR_*)			(integer)\n        proto  -- IP protocol (IP_PROTO_*)		(integer)\n        src    -- source address / net			(addr object)\n        dst    -- destination address / net		(addr object)\n        sport  -- source port range or ICMP type/mask	(list of 2 integers)\n        dport  -- dest port range or ICMP code/mask	(list of 2 integers)\n        ";
static PyObject *__pyx_f_4dnet_2fw_add(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_d = 0;
  struct fw_rule __pyx_v_rule;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  static char *__pyx_argnames[] = {"d",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_d)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_d);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1259 */
  memset(((char *)(&__pyx_v_rule)),0,(sizeof(__pyx_v_rule)));

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1260 */
  __pyx_1 = __pyx_f_4dnet_dict_to_rule(__pyx_v_d,(&__pyx_v_rule)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1260; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1261 */
  __pyx_2 = (fw_add(((struct __pyx_obj_4dnet_fw *)__pyx_v_self)->fw,(&__pyx_v_rule)) < 0);
  if (__pyx_2) {
    __pyx_1 = __pyx_f_4dnet___oserror(); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1262; goto __pyx_L1;}
    __Pyx_Raise(PyExc_OSError, __pyx_1, 0);
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1262; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.fw.add");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_d);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_2fw_delete(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_2fw_delete[] = "Delete a firewall rule specified as a dict.";
static PyObject *__pyx_f_4dnet_2fw_delete(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_d = 0;
  struct fw_rule __pyx_v_rule;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  static char *__pyx_argnames[] = {"d",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_d)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_d);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1267 */
  memset(((char *)(&__pyx_v_rule)),0,(sizeof(__pyx_v_rule)));

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1268 */
  __pyx_1 = __pyx_f_4dnet_dict_to_rule(__pyx_v_d,(&__pyx_v_rule)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1268; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1269 */
  __pyx_2 = (fw_delete(((struct __pyx_obj_4dnet_fw *)__pyx_v_self)->fw,(&__pyx_v_rule)) < 0);
  if (__pyx_2) {
    __pyx_1 = __pyx_f_4dnet___oserror(); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1270; goto __pyx_L1;}
    __Pyx_Raise(PyExc_OSError, __pyx_1, 0);
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1270; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.fw.delete");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_d);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_2fw_loop(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_2fw_loop[] = "Iterate over the local firewall ruleset, invoking a user callback\n        with each entry, returning the status of the callback routine.\n\n        Keyword arguments:\n        callback -- callback function with (dict, arg) prototype.\n                    If this function returns a non-zero value, the loop\n                    will break early.\n        arg      -- optional callback argument\n        ";
static PyObject *__pyx_f_4dnet_2fw_loop(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_callback = 0;
  PyObject *__pyx_v_arg = 0;
  PyObject *__pyx_v__arg;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"callback","arg",0};
  __pyx_v_arg = __pyx_d35;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|O", __pyx_argnames, &__pyx_v_callback, &__pyx_v_arg)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_callback);
  Py_INCREF(__pyx_v_arg);
  __pyx_v__arg = Py_None; Py_INCREF(Py_None);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1282 */
  __pyx_1 = PyTuple_New(2); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1282; goto __pyx_L1;}
  Py_INCREF(__pyx_v_callback);
  PyTuple_SET_ITEM(__pyx_1, 0, __pyx_v_callback);
  Py_INCREF(__pyx_v_arg);
  PyTuple_SET_ITEM(__pyx_1, 1, __pyx_v_arg);
  Py_DECREF(__pyx_v__arg);
  __pyx_v__arg = __pyx_1;
  __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1283 */
  __pyx_1 = PyInt_FromLong(fw_loop(((struct __pyx_obj_4dnet_fw *)__pyx_v_self)->fw,__pyx_f_4dnet___fw_callback,((void *)__pyx_v__arg))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1283; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.fw.loop");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__arg);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_callback);
  Py_DECREF(__pyx_v_arg);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_2fw___iter__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_4dnet_2fw___iter__(PyObject *__pyx_v_self) {
  PyObject *__pyx_v_l;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_l = Py_None; Py_INCREF(Py_None);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1286 */
  __pyx_1 = PyList_New(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1286; goto __pyx_L1;}
  Py_DECREF(__pyx_v_l);
  __pyx_v_l = __pyx_1;
  __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1287 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_loop); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1287; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n___iter_append); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1287; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1287; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
  Py_INCREF(__pyx_v_l);
  PyTuple_SET_ITEM(__pyx_3, 1, __pyx_v_l);
  __pyx_2 = 0;
  __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1287; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1288 */
  __pyx_1 = PyObject_GetIter(__pyx_v_l); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1288; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("dnet.fw.__iter__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_l);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static void __pyx_f_4dnet_2fw___dealloc__(PyObject *__pyx_v_self); /*proto*/
static void __pyx_f_4dnet_2fw___dealloc__(PyObject *__pyx_v_self) {
  int __pyx_1;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = (((struct __pyx_obj_4dnet_fw *)__pyx_v_self)->fw != 0);
  if (__pyx_1) {
    fw_close(((struct __pyx_obj_4dnet_fw *)__pyx_v_self)->fw);
    goto __pyx_L2;
  }
  __pyx_L2:;

  Py_DECREF(__pyx_v_self);
}

static int __pyx_f_4dnet_4rand___init__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static int __pyx_f_4dnet_4rand___init__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return -1;
  Py_INCREF(__pyx_v_self);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1321 */
  ((struct __pyx_obj_4dnet_rand *)__pyx_v_self)->rand = rand_open();

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1322 */
  __pyx_1 = (!(((struct __pyx_obj_4dnet_rand *)__pyx_v_self)->rand != 0));
  if (__pyx_1) {
    __pyx_2 = __pyx_f_4dnet___oserror(); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1323; goto __pyx_L1;}
    __Pyx_Raise(PyExc_OSError, __pyx_2, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1323; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.rand.__init__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4rand_get(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_4rand_get[] = "Return a string of random bytes.\n        \n        Arguments:\n        len -- number of random bytes to generate\n        ";
static PyObject *__pyx_f_4dnet_4rand_get(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_len = 0;
  char __pyx_v_buf[1024];
  char *__pyx_v_p;
  PyObject *__pyx_v_s;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  static char *__pyx_argnames[] = {"len",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_len)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_len);
  __pyx_v_s = Py_None; Py_INCREF(Py_None);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1333 */
  __pyx_1 = PyInt_FromLong(1024); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1333; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_v_len, __pyx_1, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1333; goto __pyx_L1;}
  __pyx_2 = __pyx_2 <= 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_2) {

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1334 */
    __pyx_2 = PyInt_AsLong(__pyx_v_len); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1334; goto __pyx_L1;}
    rand_get(((struct __pyx_obj_4dnet_rand *)__pyx_v_self)->rand,__pyx_v_buf,__pyx_2);

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1335 */
    __pyx_2 = PyInt_AsLong(__pyx_v_len); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1335; goto __pyx_L1;}
    __pyx_1 = PyString_FromStringAndSize(__pyx_v_buf,__pyx_2); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1335; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1336 */
  __pyx_2 = PyInt_AsLong(__pyx_v_len); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1336; goto __pyx_L1;}
  __pyx_v_p = malloc(__pyx_2);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1337 */
  __pyx_2 = PyInt_AsLong(__pyx_v_len); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1337; goto __pyx_L1;}
  rand_get(((struct __pyx_obj_4dnet_rand *)__pyx_v_self)->rand,__pyx_v_p,__pyx_2);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1338 */
  __pyx_2 = PyInt_AsLong(__pyx_v_len); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1338; goto __pyx_L1;}
  __pyx_1 = PyString_FromStringAndSize(__pyx_v_p,__pyx_2); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1338; goto __pyx_L1;}
  Py_DECREF(__pyx_v_s);
  __pyx_v_s = __pyx_1;
  __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1339 */
  free(__pyx_v_p);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1340 */
  Py_INCREF(__pyx_v_s);
  __pyx_r = __pyx_v_s;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.rand.get");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_s);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_len);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4rand_set(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_4rand_set[] = "Initialize the PRNG from a known seed.\n        \n        Arguments:\n        string -- binary string seed value\n        ";
static PyObject *__pyx_f_4dnet_4rand_set(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_buf = 0;
  PyObject *__pyx_r;
  char *__pyx_1;
  static char *__pyx_argnames[] = {"buf",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_buf)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_buf);
  __pyx_1 = PyString_AsString(__pyx_v_buf); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1348; goto __pyx_L1;}
  rand_set(((struct __pyx_obj_4dnet_rand *)__pyx_v_self)->rand,__pyx_1,PyString_Size(__pyx_v_buf));

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("dnet.rand.set");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_buf);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4rand_add(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_4rand_add[] = "Add additional entropy into the PRNG mix.\n\n        Arguments:\n        string -- binary string\n        ";
static PyObject *__pyx_f_4dnet_4rand_add(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_buf = 0;
  PyObject *__pyx_r;
  char *__pyx_1;
  static char *__pyx_argnames[] = {"buf",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_buf)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_buf);
  __pyx_1 = PyString_AsString(__pyx_v_buf); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1356; goto __pyx_L1;}
  rand_add(((struct __pyx_obj_4dnet_rand *)__pyx_v_self)->rand,__pyx_1,PyString_Size(__pyx_v_buf));

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("dnet.rand.add");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_buf);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4rand_uint8(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_4rand_uint8[] = "Return a random 8-bit integer.";
static PyObject *__pyx_f_4dnet_4rand_uint8(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = PyLong_FromUnsignedLong(rand_uint8(((struct __pyx_obj_4dnet_rand *)__pyx_v_self)->rand)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1360; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.rand.uint8");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4rand_uint16(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_4rand_uint16[] = "Return a random 16-bit integer.";
static PyObject *__pyx_f_4dnet_4rand_uint16(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = PyLong_FromUnsignedLong(rand_uint16(((struct __pyx_obj_4dnet_rand *)__pyx_v_self)->rand)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1364; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.rand.uint16");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4rand_uint32(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_4rand_uint32[] = "Return a random 32-bit integer.";
static PyObject *__pyx_f_4dnet_4rand_uint32(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = PyLong_FromUnsignedLong(rand_uint32(((struct __pyx_obj_4dnet_rand *)__pyx_v_self)->rand)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1368; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.rand.uint32");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_4rand_xrange(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_4rand_xrange[] = "xrange([start,] stop) -> xrange object\n\n        Return a random permutation iterator to walk an unsigned integer range,\n        like xrange().\n        ";
static PyObject *__pyx_f_4dnet_4rand_xrange(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_start = 0;
  PyObject *__pyx_v_stop = 0;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"start","stop",0};
  __pyx_v_stop = __pyx_d36;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|O", __pyx_argnames, &__pyx_v_start, &__pyx_v_stop)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_start);
  Py_INCREF(__pyx_v_stop);
  if (PyObject_Cmp(__pyx_v_stop, Py_None, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1376; goto __pyx_L1;}
  __pyx_1 = __pyx_1 == 0;
  if (__pyx_1) {
    __pyx_2 = PyInt_FromLong(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1377; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(3); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1377; goto __pyx_L1;}
    Py_INCREF(__pyx_v_self);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_self);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_2);
    Py_INCREF(__pyx_v_start);
    PyTuple_SET_ITEM(__pyx_3, 2, __pyx_v_start);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(((PyObject *)__pyx_ptype_4dnet___rand_xrange), __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1377; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  /*else*/ {
    __pyx_3 = PyTuple_New(3); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1379; goto __pyx_L1;}
    Py_INCREF(__pyx_v_self);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_self);
    Py_INCREF(__pyx_v_start);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_v_start);
    Py_INCREF(__pyx_v_stop);
    PyTuple_SET_ITEM(__pyx_3, 2, __pyx_v_stop);
    __pyx_2 = PyObject_CallObject(((PyObject *)__pyx_ptype_4dnet___rand_xrange), __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1379; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("dnet.rand.xrange");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_start);
  Py_DECREF(__pyx_v_stop);
  return __pyx_r;
}

static void __pyx_f_4dnet_4rand___dealloc__(PyObject *__pyx_v_self); /*proto*/
static void __pyx_f_4dnet_4rand___dealloc__(PyObject *__pyx_v_self) {
  int __pyx_1;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = (((struct __pyx_obj_4dnet_rand *)__pyx_v_self)->rand != 0);
  if (__pyx_1) {
    rand_close(((struct __pyx_obj_4dnet_rand *)__pyx_v_self)->rand);
    goto __pyx_L2;
  }
  __pyx_L2:;

  Py_DECREF(__pyx_v_self);
}

static int __pyx_f_4dnet_13__rand_xrange___init__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static int __pyx_f_4dnet_13__rand_xrange___init__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_r = 0;
  PyObject *__pyx_v_start = 0;
  PyObject *__pyx_v_stop = 0;
  unsigned int __pyx_v_bits;
  int __pyx_r;
  int __pyx_1;
  static char *__pyx_argnames[] = {"r","start","stop",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OOO", __pyx_argnames, &__pyx_v_r, &__pyx_v_start, &__pyx_v_stop)) return -1;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_r);
  Py_INCREF(__pyx_v_start);
  Py_INCREF(__pyx_v_stop);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1401 */
  ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->rand = ((struct __pyx_obj_4dnet_rand *)__pyx_v_r)->rand;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1402 */
  __pyx_1 = PyInt_Check(__pyx_v_start);
  if (__pyx_1) {
    ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->start = PyInt_AsLong(__pyx_v_start);
    goto __pyx_L2;
  }
  __pyx_1 = PyLong_Check(__pyx_v_start);
  if (__pyx_1) {
    ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->start = PyLong_AsUnsignedLong(__pyx_v_start);
    goto __pyx_L2;
  }
  /*else*/ {
    __Pyx_Raise(PyExc_TypeError, __pyx_k50p, 0);
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1407; goto __pyx_L1;}
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1409 */
  __pyx_1 = PyInt_Check(__pyx_v_start);
  if (__pyx_1) {
    ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->max = (PyInt_AsLong(__pyx_v_stop) - ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->start);
    goto __pyx_L3;
  }
  __pyx_1 = PyLong_Check(__pyx_v_start);
  if (__pyx_1) {
    ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->max = (PyLong_AsUnsignedLong(__pyx_v_stop) - ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->start);
    goto __pyx_L3;
  }
  /*else*/ {
    __Pyx_Raise(PyExc_TypeError, __pyx_k51p, 0);
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1414; goto __pyx_L1;}
  }
  __pyx_L3:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1417 */
  rand_get(((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->rand,((char *)((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->sbox),(sizeof(((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->sbox)));

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1419 */
  __pyx_v_bits = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1420 */
  while (1) {
    __pyx_1 = (((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->max > (1 << __pyx_v_bits));
    if (!__pyx_1) break;
    __pyx_v_bits = (__pyx_v_bits + 1);
  }

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1423 */
  ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->left = (__pyx_v_bits / 2);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1424 */
  ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->right = (__pyx_v_bits - ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->left);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1425 */
  ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->mask = ((1 << __pyx_v_bits) - 1);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1427 */
  __pyx_1 = (__pyx_e_4dnet_TEASBOXSIZE < (1 << ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->left));
  if (__pyx_1) {

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1428 */
    ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->sboxmask = (__pyx_e_4dnet_TEASBOXSIZE - 1);

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1429 */
    ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->kshift = __pyx_e_4dnet_TEASBOXSHIFT;
    goto __pyx_L6;
  }
  /*else*/ {

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1431 */
    ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->sboxmask = ((1 << ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->left) - 1);

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1432 */
    ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->kshift = ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->left;
  }
  __pyx_L6:;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("dnet.__rand_xrange.__init__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_r);
  Py_DECREF(__pyx_v_start);
  Py_DECREF(__pyx_v_stop);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_13__rand_xrange___iter__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_4dnet_13__rand_xrange___iter__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  Py_INCREF(__pyx_v_self);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1435 */
  ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->cur = 0;
  ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->enc = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1437 */
  Py_INCREF(__pyx_v_self);
  __pyx_r = __pyx_v_self;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static Py_ssize_t __pyx_f_4dnet_13__rand_xrange___len__(PyObject *__pyx_v_self); /*proto*/
static Py_ssize_t __pyx_f_4dnet_13__rand_xrange___len__(PyObject *__pyx_v_self) {
  Py_ssize_t __pyx_r;
  Py_INCREF(__pyx_v_self);
  __pyx_r = ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->max;
  goto __pyx_L0;

  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_13__rand_xrange___next__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_4dnet_13__rand_xrange___next__(PyObject *__pyx_v_self) {
  unsigned long __pyx_v_c;
  unsigned long __pyx_v_sum;
  PyObject *__pyx_v_i;
  PyObject *__pyx_r;
  int __pyx_1;
  long __pyx_2;
  PyObject *__pyx_3 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_i = Py_None; Py_INCREF(Py_None);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1445 */
  __pyx_1 = (((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->cur == ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->max);
  if (__pyx_1) {
    __Pyx_Raise(PyExc_StopIteration, 0, 0);
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1446; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1447 */
  ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->cur = (((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->cur + 1);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1448 */
  while (1) {
    __pyx_2 = 1;
    if (!__pyx_2) break;

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1449 */
    __pyx_v_c = ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->enc;

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1450 */
    ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->enc = (((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->enc + 1);

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1451 */
    __pyx_v_sum = 0;

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1452 */
    for (__pyx_2 = 0+1; __pyx_2 < __pyx_e_4dnet_TEAROUNDS; ++__pyx_2) {
      __pyx_3 = PyInt_FromLong(__pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1452; goto __pyx_L1;}
      Py_DECREF(__pyx_v_i);
      __pyx_v_i = __pyx_3;
      __pyx_3 = 0;

      /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1453 */
      __pyx_v_sum = (__pyx_v_sum + __pyx_e_4dnet_TEADELTA);

      /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1454 */
      __pyx_v_c = (__pyx_v_c ^ ((((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->sbox[((__pyx_v_c ^ __pyx_v_sum) & ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->sboxmask)]) << ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->kshift));

      /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1455 */
      __pyx_v_c = (__pyx_v_c + __pyx_v_sum);

      /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1456 */
      __pyx_v_c = (__pyx_v_c & ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->mask);

      /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1457 */
      __pyx_v_c = (((__pyx_v_c << ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->left) | (__pyx_v_c >> ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->right)) & ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->mask);
    }

    /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1458 */
    __pyx_1 = (__pyx_v_c < ((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->max);
    if (__pyx_1) {
      goto __pyx_L4;
      goto __pyx_L7;
    }
    __pyx_L7:;
  }
  __pyx_L4:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1460 */
  __pyx_3 = PyLong_FromUnsignedLong((((struct __pyx_obj_4dnet___rand_xrange *)__pyx_v_self)->start + __pyx_v_c)); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1460; goto __pyx_L1;}
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("dnet.__rand_xrange.__next__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_i);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static int __pyx_f_4dnet_3tun___init__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static int __pyx_f_4dnet_3tun___init__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_4dnet_addr *__pyx_v_src = 0;
  struct __pyx_obj_4dnet_addr *__pyx_v_dst = 0;
  PyObject *__pyx_v_mtu = 0;
  int __pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {"src","dst","mtu",0};
  __pyx_v_mtu = __pyx_d37;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO|O", __pyx_argnames, &__pyx_v_src, &__pyx_v_dst, &__pyx_v_mtu)) return -1;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_src);
  Py_INCREF(__pyx_v_dst);
  Py_INCREF(__pyx_v_mtu);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_src), __pyx_ptype_4dnet_addr, 1, "src")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1489; goto __pyx_L1;}
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_dst), __pyx_ptype_4dnet_addr, 1, "dst")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1489; goto __pyx_L1;}

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1490 */
  __pyx_1 = PyInt_AsLong(__pyx_v_mtu); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1490; goto __pyx_L1;}
  ((struct __pyx_obj_4dnet_tun *)__pyx_v_self)->tun = tun_open((&__pyx_v_src->_addr),(&__pyx_v_dst->_addr),__pyx_1);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1491 */
  __pyx_1 = PyInt_AsLong(__pyx_v_mtu); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1491; goto __pyx_L1;}
  ((struct __pyx_obj_4dnet_tun *)__pyx_v_self)->mtu = __pyx_1;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1492 */
  __pyx_1 = (!(((struct __pyx_obj_4dnet_tun *)__pyx_v_self)->tun != 0));
  if (__pyx_1) {
    __pyx_2 = __pyx_f_4dnet___oserror(); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1493; goto __pyx_L1;}
    __Pyx_Raise(PyExc_OSError, __pyx_2, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1493; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1494 */
  __pyx_1 = PyInt_AsLong(__pyx_v_mtu); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1494; goto __pyx_L1;}
  ((struct __pyx_obj_4dnet_tun *)__pyx_v_self)->buf = malloc(__pyx_1);

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.tun.__init__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_src);
  Py_DECREF(__pyx_v_dst);
  Py_DECREF(__pyx_v_mtu);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_3tun_4name___get__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_4dnet_3tun_4name___get__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = PyString_FromString(tun_name(((struct __pyx_obj_4dnet_tun *)__pyx_v_self)->tun)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1499; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.tun.name.__get__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_3tun_2fd___get__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_4dnet_3tun_2fd___get__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = PyInt_FromLong(tun_fileno(((struct __pyx_obj_4dnet_tun *)__pyx_v_self)->tun)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1504; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.tun.fd.__get__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_3tun_fileno(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_3tun_fileno[] = "Return file descriptor for tunnel handle.";
static PyObject *__pyx_f_4dnet_3tun_fileno(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = PyInt_FromLong(tun_fileno(((struct __pyx_obj_4dnet_tun *)__pyx_v_self)->tun)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1508; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("dnet.tun.fileno");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_3tun_send(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_3tun_send[] = "Send an IP packet, returning the number of bytes sent\n        or -1 on failure.\n\n        Arguments:\n        pkt -- binary string representing an IP packet\n        ";
static PyObject *__pyx_f_4dnet_3tun_send(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_pkt = 0;
  PyObject *__pyx_r;
  char *__pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {"pkt",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_pkt)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_pkt);
  __pyx_1 = PyString_AsString(__pyx_v_pkt); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1517; goto __pyx_L1;}
  __pyx_2 = PyInt_FromLong(tun_send(((struct __pyx_obj_4dnet_tun *)__pyx_v_self)->tun,__pyx_1,PyString_Size(__pyx_v_pkt))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1517; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.tun.send");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_pkt);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_3tun_recv(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4dnet_3tun_recv[] = "Return the next packet delivered to the tunnel interface.";
static PyObject *__pyx_f_4dnet_3tun_recv(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1522 */
  __pyx_v_n = tun_recv(((struct __pyx_obj_4dnet_tun *)__pyx_v_self)->tun,((struct __pyx_obj_4dnet_tun *)__pyx_v_self)->buf,((struct __pyx_obj_4dnet_tun *)__pyx_v_self)->mtu);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1523 */
  __pyx_1 = (__pyx_v_n < 0);
  if (__pyx_1) {
    __pyx_2 = __pyx_f_4dnet___oserror(); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1524; goto __pyx_L1;}
    __Pyx_Raise(PyExc_OSError, __pyx_2, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1524; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1525 */
  __pyx_2 = PyString_FromStringAndSize(((struct __pyx_obj_4dnet_tun *)__pyx_v_self)->buf,__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1525; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("dnet.tun.recv");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_4dnet_3tun_close(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_4dnet_3tun_close(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);
  ((struct __pyx_obj_4dnet_tun *)__pyx_v_self)->tun = tun_close(((struct __pyx_obj_4dnet_tun *)__pyx_v_self)->tun);

  __pyx_r = Py_None; Py_INCREF(Py_None);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static void __pyx_f_4dnet_3tun___dealloc__(PyObject *__pyx_v_self); /*proto*/
static void __pyx_f_4dnet_3tun___dealloc__(PyObject *__pyx_v_self) {
  int __pyx_1;
  Py_INCREF(__pyx_v_self);

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1531 */
  __pyx_1 = (((struct __pyx_obj_4dnet_tun *)__pyx_v_self)->buf != 0);
  if (__pyx_1) {
    free(((struct __pyx_obj_4dnet_tun *)__pyx_v_self)->buf);
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1533 */
  __pyx_1 = (((struct __pyx_obj_4dnet_tun *)__pyx_v_self)->tun != 0);
  if (__pyx_1) {
    tun_close(((struct __pyx_obj_4dnet_tun *)__pyx_v_self)->tun);
    goto __pyx_L3;
  }
  __pyx_L3:;

  Py_DECREF(__pyx_v_self);
}

static PyObject *__pyx_tp_new_4dnet_eth(PyTypeObject *t, PyObject *a, PyObject *k) {
  PyObject *o = (*t->tp_alloc)(t, 0);
  if (!o) return 0;
  return o;
}

static void __pyx_tp_dealloc_4dnet_eth(PyObject *o) {
  {
    PyObject *etype, *eval, *etb;
    PyErr_Fetch(&etype, &eval, &etb);
    ++o->ob_refcnt;
    __pyx_f_4dnet_3eth___dealloc__(o);
    if (PyErr_Occurred()) PyErr_WriteUnraisable(o);
    --o->ob_refcnt;
    PyErr_Restore(etype, eval, etb);
  }
  (*o->ob_type->tp_free)(o);
}

static struct PyMethodDef __pyx_methods_4dnet_eth[] = {
  {"get", (PyCFunction)__pyx_f_4dnet_3eth_get, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_3eth_get},
  {"set", (PyCFunction)__pyx_f_4dnet_3eth_set, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_3eth_set},
  {"send", (PyCFunction)__pyx_f_4dnet_3eth_send, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_3eth_send},
  {0, 0, 0, 0}
};

static PyNumberMethods __pyx_tp_as_number_eth = {
  0, /*nb_add*/
  0, /*nb_subtract*/
  0, /*nb_multiply*/
  0, /*nb_divide*/
  0, /*nb_remainder*/
  0, /*nb_divmod*/
  0, /*nb_power*/
  0, /*nb_negative*/
  0, /*nb_positive*/
  0, /*nb_absolute*/
  0, /*nb_nonzero*/
  0, /*nb_invert*/
  0, /*nb_lshift*/
  0, /*nb_rshift*/
  0, /*nb_and*/
  0, /*nb_xor*/
  0, /*nb_or*/
  0, /*nb_coerce*/
  0, /*nb_int*/
  0, /*nb_long*/
  0, /*nb_float*/
  0, /*nb_oct*/
  0, /*nb_hex*/
  0, /*nb_inplace_add*/
  0, /*nb_inplace_subtract*/
  0, /*nb_inplace_multiply*/
  0, /*nb_inplace_divide*/
  0, /*nb_inplace_remainder*/
  0, /*nb_inplace_power*/
  0, /*nb_inplace_lshift*/
  0, /*nb_inplace_rshift*/
  0, /*nb_inplace_and*/
  0, /*nb_inplace_xor*/
  0, /*nb_inplace_or*/
  0, /*nb_floor_divide*/
  0, /*nb_true_divide*/
  0, /*nb_inplace_floor_divide*/
  0, /*nb_inplace_true_divide*/
  #if Py_TPFLAGS_DEFAULT & Py_TPFLAGS_HAVE_INDEX
  0, /*nb_index*/
  #endif
};

static PySequenceMethods __pyx_tp_as_sequence_eth = {
  0, /*sq_length*/
  0, /*sq_concat*/
  0, /*sq_repeat*/
  0, /*sq_item*/
  0, /*sq_slice*/
  0, /*sq_ass_item*/
  0, /*sq_ass_slice*/
  0, /*sq_contains*/
  0, /*sq_inplace_concat*/
  0, /*sq_inplace_repeat*/
};

static PyMappingMethods __pyx_tp_as_mapping_eth = {
  0, /*mp_length*/
  0, /*mp_subscript*/
  0, /*mp_ass_subscript*/
};

static PyBufferProcs __pyx_tp_as_buffer_eth = {
  0, /*bf_getreadbuffer*/
  0, /*bf_getwritebuffer*/
  0, /*bf_getsegcount*/
  0, /*bf_getcharbuffer*/
};

PyTypeObject __pyx_type_4dnet_eth = {
  PyObject_HEAD_INIT(0)
  0, /*ob_size*/
  "dnet.eth", /*tp_name*/
  sizeof(struct __pyx_obj_4dnet_eth), /*tp_basicsize*/
  0, /*tp_itemsize*/
  __pyx_tp_dealloc_4dnet_eth, /*tp_dealloc*/
  0, /*tp_print*/
  0, /*tp_getattr*/
  0, /*tp_setattr*/
  0, /*tp_compare*/
  0, /*tp_repr*/
  &__pyx_tp_as_number_eth, /*tp_as_number*/
  &__pyx_tp_as_sequence_eth, /*tp_as_sequence*/
  &__pyx_tp_as_mapping_eth, /*tp_as_mapping*/
  0, /*tp_hash*/
  0, /*tp_call*/
  0, /*tp_str*/
  0, /*tp_getattro*/
  0, /*tp_setattro*/
  &__pyx_tp_as_buffer_eth, /*tp_as_buffer*/
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_BASETYPE, /*tp_flags*/
  "eth(device) -> Ethernet device object\n\n    Open the specified Ethernet device for sending.\n    ", /*tp_doc*/
  0, /*tp_traverse*/
  0, /*tp_clear*/
  0, /*tp_richcompare*/
  0, /*tp_weaklistoffset*/
  0, /*tp_iter*/
  0, /*tp_iternext*/
  __pyx_methods_4dnet_eth, /*tp_methods*/
  0, /*tp_members*/
  0, /*tp_getset*/
  0, /*tp_base*/
  0, /*tp_dict*/
  0, /*tp_descr_get*/
  0, /*tp_descr_set*/
  0, /*tp_dictoffset*/
  __pyx_f_4dnet_3eth___init__, /*tp_init*/
  0, /*tp_alloc*/
  __pyx_tp_new_4dnet_eth, /*tp_new*/
  0, /*tp_free*/
  0, /*tp_is_gc*/
  0, /*tp_bases*/
  0, /*tp_mro*/
  0, /*tp_cache*/
  0, /*tp_subclasses*/
  0, /*tp_weaklist*/
};

static PyObject *__pyx_tp_new_4dnet_ip(PyTypeObject *t, PyObject *a, PyObject *k) {
  PyObject *o = (*t->tp_alloc)(t, 0);
  if (!o) return 0;
  return o;
}

static void __pyx_tp_dealloc_4dnet_ip(PyObject *o) {
  {
    PyObject *etype, *eval, *etb;
    PyErr_Fetch(&etype, &eval, &etb);
    ++o->ob_refcnt;
    __pyx_f_4dnet_2ip___dealloc__(o);
    if (PyErr_Occurred()) PyErr_WriteUnraisable(o);
    --o->ob_refcnt;
    PyErr_Restore(etype, eval, etb);
  }
  (*o->ob_type->tp_free)(o);
}

static struct PyMethodDef __pyx_methods_4dnet_ip[] = {
  {"send", (PyCFunction)__pyx_f_4dnet_2ip_send, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_2ip_send},
  {0, 0, 0, 0}
};

static PyNumberMethods __pyx_tp_as_number_ip = {
  0, /*nb_add*/
  0, /*nb_subtract*/
  0, /*nb_multiply*/
  0, /*nb_divide*/
  0, /*nb_remainder*/
  0, /*nb_divmod*/
  0, /*nb_power*/
  0, /*nb_negative*/
  0, /*nb_positive*/
  0, /*nb_absolute*/
  0, /*nb_nonzero*/
  0, /*nb_invert*/
  0, /*nb_lshift*/
  0, /*nb_rshift*/
  0, /*nb_and*/
  0, /*nb_xor*/
  0, /*nb_or*/
  0, /*nb_coerce*/
  0, /*nb_int*/
  0, /*nb_long*/
  0, /*nb_float*/
  0, /*nb_oct*/
  0, /*nb_hex*/
  0, /*nb_inplace_add*/
  0, /*nb_inplace_subtract*/
  0, /*nb_inplace_multiply*/
  0, /*nb_inplace_divide*/
  0, /*nb_inplace_remainder*/
  0, /*nb_inplace_power*/
  0, /*nb_inplace_lshift*/
  0, /*nb_inplace_rshift*/
  0, /*nb_inplace_and*/
  0, /*nb_inplace_xor*/
  0, /*nb_inplace_or*/
  0, /*nb_floor_divide*/
  0, /*nb_true_divide*/
  0, /*nb_inplace_floor_divide*/
  0, /*nb_inplace_true_divide*/
  #if Py_TPFLAGS_DEFAULT & Py_TPFLAGS_HAVE_INDEX
  0, /*nb_index*/
  #endif
};

static PySequenceMethods __pyx_tp_as_sequence_ip = {
  0, /*sq_length*/
  0, /*sq_concat*/
  0, /*sq_repeat*/
  0, /*sq_item*/
  0, /*sq_slice*/
  0, /*sq_ass_item*/
  0, /*sq_ass_slice*/
  0, /*sq_contains*/
  0, /*sq_inplace_concat*/
  0, /*sq_inplace_repeat*/
};

static PyMappingMethods __pyx_tp_as_mapping_ip = {
  0, /*mp_length*/
  0, /*mp_subscript*/
  0, /*mp_ass_subscript*/
};

static PyBufferProcs __pyx_tp_as_buffer_ip = {
  0, /*bf_getreadbuffer*/
  0, /*bf_getwritebuffer*/
  0, /*bf_getsegcount*/
  0, /*bf_getcharbuffer*/
};

PyTypeObject __pyx_type_4dnet_ip = {
  PyObject_HEAD_INIT(0)
  0, /*ob_size*/
  "dnet.ip", /*tp_name*/
  sizeof(struct __pyx_obj_4dnet_ip), /*tp_basicsize*/
  0, /*tp_itemsize*/
  __pyx_tp_dealloc_4dnet_ip, /*tp_dealloc*/
  0, /*tp_print*/
  0, /*tp_getattr*/
  0, /*tp_setattr*/
  0, /*tp_compare*/
  0, /*tp_repr*/
  &__pyx_tp_as_number_ip, /*tp_as_number*/
  &__pyx_tp_as_sequence_ip, /*tp_as_sequence*/
  &__pyx_tp_as_mapping_ip, /*tp_as_mapping*/
  0, /*tp_hash*/
  0, /*tp_call*/
  0, /*tp_str*/
  0, /*tp_getattro*/
  0, /*tp_setattro*/
  &__pyx_tp_as_buffer_ip, /*tp_as_buffer*/
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_BASETYPE, /*tp_flags*/
  "ip() -> Raw IP object\n\n    Open a raw IP socket for sending.\n    ", /*tp_doc*/
  0, /*tp_traverse*/
  0, /*tp_clear*/
  0, /*tp_richcompare*/
  0, /*tp_weaklistoffset*/
  0, /*tp_iter*/
  0, /*tp_iternext*/
  __pyx_methods_4dnet_ip, /*tp_methods*/
  0, /*tp_members*/
  0, /*tp_getset*/
  0, /*tp_base*/
  0, /*tp_dict*/
  0, /*tp_descr_get*/
  0, /*tp_descr_set*/
  0, /*tp_dictoffset*/
  __pyx_f_4dnet_2ip___init__, /*tp_init*/
  0, /*tp_alloc*/
  __pyx_tp_new_4dnet_ip, /*tp_new*/
  0, /*tp_free*/
  0, /*tp_is_gc*/
  0, /*tp_bases*/
  0, /*tp_mro*/
  0, /*tp_cache*/
  0, /*tp_subclasses*/
  0, /*tp_weaklist*/
};

static PyObject *__pyx_tp_new_4dnet_addr(PyTypeObject *t, PyObject *a, PyObject *k) {
  PyObject *o = (*t->tp_alloc)(t, 0);
  if (!o) return 0;
  return o;
}

static void __pyx_tp_dealloc_4dnet_addr(PyObject *o) {
  (*o->ob_type->tp_free)(o);
}

static PyObject *__pyx_getprop_4dnet_4addr_type(PyObject *o, void *x) {
  return __pyx_f_4dnet_4addr_4type___get__(o);
}

static int __pyx_setprop_4dnet_4addr_type(PyObject *o, PyObject *v, void *x) {
  if (v) {
    return __pyx_f_4dnet_4addr_4type___set__(o, v);
  }
  else {
    PyErr_SetString(PyExc_NotImplementedError, "__del__");
    return -1;
  }
}

static PyObject *__pyx_getprop_4dnet_4addr_bits(PyObject *o, void *x) {
  return __pyx_f_4dnet_4addr_4bits___get__(o);
}

static int __pyx_setprop_4dnet_4addr_bits(PyObject *o, PyObject *v, void *x) {
  if (v) {
    return __pyx_f_4dnet_4addr_4bits___set__(o, v);
  }
  else {
    PyErr_SetString(PyExc_NotImplementedError, "__del__");
    return -1;
  }
}

static PyObject *__pyx_getprop_4dnet_4addr_data(PyObject *o, void *x) {
  return __pyx_f_4dnet_4addr_4data___get__(o);
}

static PyObject *__pyx_getprop_4dnet_4addr_eth(PyObject *o, void *x) {
  return __pyx_f_4dnet_4addr_3eth___get__(o);
}

static int __pyx_setprop_4dnet_4addr_eth(PyObject *o, PyObject *v, void *x) {
  if (v) {
    return __pyx_f_4dnet_4addr_3eth___set__(o, v);
  }
  else {
    PyErr_SetString(PyExc_NotImplementedError, "__del__");
    return -1;
  }
}

static PyObject *__pyx_getprop_4dnet_4addr_ip(PyObject *o, void *x) {
  return __pyx_f_4dnet_4addr_2ip___get__(o);
}

static int __pyx_setprop_4dnet_4addr_ip(PyObject *o, PyObject *v, void *x) {
  if (v) {
    return __pyx_f_4dnet_4addr_2ip___set__(o, v);
  }
  else {
    PyErr_SetString(PyExc_NotImplementedError, "__del__");
    return -1;
  }
}

static PyObject *__pyx_getprop_4dnet_4addr_ip6(PyObject *o, void *x) {
  return __pyx_f_4dnet_4addr_3ip6___get__(o);
}

static int __pyx_setprop_4dnet_4addr_ip6(PyObject *o, PyObject *v, void *x) {
  if (v) {
    return __pyx_f_4dnet_4addr_3ip6___set__(o, v);
  }
  else {
    PyErr_SetString(PyExc_NotImplementedError, "__del__");
    return -1;
  }
}

static struct PyMethodDef __pyx_methods_4dnet_addr[] = {
  {"bcast", (PyCFunction)__pyx_f_4dnet_4addr_bcast, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_4addr_bcast},
  {"net", (PyCFunction)__pyx_f_4dnet_4addr_net, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_4addr_net},
  {"__copy__", (PyCFunction)__pyx_f_4dnet_4addr___copy__, METH_VARARGS|METH_KEYWORDS, 0},
  {0, 0, 0, 0}
};

static struct PyGetSetDef __pyx_getsets_4dnet_addr[] = {
  {"type", __pyx_getprop_4dnet_4addr_type, __pyx_setprop_4dnet_4addr_type, __pyx_k52, 0},
  {"bits", __pyx_getprop_4dnet_4addr_bits, __pyx_setprop_4dnet_4addr_bits, __pyx_k53, 0},
  {"data", __pyx_getprop_4dnet_4addr_data, 0, __pyx_k54, 0},
  {"eth", __pyx_getprop_4dnet_4addr_eth, __pyx_setprop_4dnet_4addr_eth, __pyx_k55, 0},
  {"ip", __pyx_getprop_4dnet_4addr_ip, __pyx_setprop_4dnet_4addr_ip, __pyx_k56, 0},
  {"ip6", __pyx_getprop_4dnet_4addr_ip6, __pyx_setprop_4dnet_4addr_ip6, __pyx_k57, 0},
  {0, 0, 0, 0, 0}
};

static PyNumberMethods __pyx_tp_as_number_addr = {
  __pyx_f_4dnet_4addr___add__, /*nb_add*/
  0, /*nb_subtract*/
  0, /*nb_multiply*/
  0, /*nb_divide*/
  0, /*nb_remainder*/
  0, /*nb_divmod*/
  0, /*nb_power*/
  0, /*nb_negative*/
  0, /*nb_positive*/
  0, /*nb_absolute*/
  0, /*nb_nonzero*/
  0, /*nb_invert*/
  0, /*nb_lshift*/
  0, /*nb_rshift*/
  0, /*nb_and*/
  0, /*nb_xor*/
  0, /*nb_or*/
  0, /*nb_coerce*/
  __pyx_f_4dnet_4addr___int__, /*nb_int*/
  __pyx_f_4dnet_4addr___long__, /*nb_long*/
  0, /*nb_float*/
  0, /*nb_oct*/
  0, /*nb_hex*/
  0, /*nb_inplace_add*/
  0, /*nb_inplace_subtract*/
  0, /*nb_inplace_multiply*/
  0, /*nb_inplace_divide*/
  0, /*nb_inplace_remainder*/
  0, /*nb_inplace_power*/
  0, /*nb_inplace_lshift*/
  0, /*nb_inplace_rshift*/
  0, /*nb_inplace_and*/
  0, /*nb_inplace_xor*/
  0, /*nb_inplace_or*/
  0, /*nb_floor_divide*/
  0, /*nb_true_divide*/
  0, /*nb_inplace_floor_divide*/
  0, /*nb_inplace_true_divide*/
  #if Py_TPFLAGS_DEFAULT & Py_TPFLAGS_HAVE_INDEX
  0, /*nb_index*/
  #endif
};

static PySequenceMethods __pyx_tp_as_sequence_addr = {
  0, /*sq_length*/
  0, /*sq_concat*/
  0, /*sq_repeat*/
  0, /*sq_item*/
  0, /*sq_slice*/
  0, /*sq_ass_item*/
  0, /*sq_ass_slice*/
  __pyx_f_4dnet_4addr___contains__, /*sq_contains*/
  0, /*sq_inplace_concat*/
  0, /*sq_inplace_repeat*/
};

static PyMappingMethods __pyx_tp_as_mapping_addr = {
  0, /*mp_length*/
  0, /*mp_subscript*/
  0, /*mp_ass_subscript*/
};

static PyBufferProcs __pyx_tp_as_buffer_addr = {
  0, /*bf_getreadbuffer*/
  0, /*bf_getwritebuffer*/
  0, /*bf_getsegcount*/
  0, /*bf_getcharbuffer*/
};

PyTypeObject __pyx_type_4dnet_addr = {
  PyObject_HEAD_INIT(0)
  0, /*ob_size*/
  "dnet.addr", /*tp_name*/
  sizeof(struct __pyx_obj_4dnet_addr), /*tp_basicsize*/
  0, /*tp_itemsize*/
  __pyx_tp_dealloc_4dnet_addr, /*tp_dealloc*/
  0, /*tp_print*/
  0, /*tp_getattr*/
  0, /*tp_setattr*/
  __pyx_f_4dnet_4addr___cmp__, /*tp_compare*/
  __pyx_f_4dnet_4addr___repr__, /*tp_repr*/
  &__pyx_tp_as_number_addr, /*tp_as_number*/
  &__pyx_tp_as_sequence_addr, /*tp_as_sequence*/
  &__pyx_tp_as_mapping_addr, /*tp_as_mapping*/
  __pyx_f_4dnet_4addr___hash__, /*tp_hash*/
  0, /*tp_call*/
  0, /*tp_str*/
  0, /*tp_getattro*/
  0, /*tp_setattro*/
  &__pyx_tp_as_buffer_addr, /*tp_as_buffer*/
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_BASETYPE, /*tp_flags*/
  "addr(addrtxt=None, type=ADDR_TYPE_NONE) -> network address object\n\n    Create a network address object, optionally initialized from a\n    human-readable Ethernet, IP, or IPv6 address string.\n    ", /*tp_doc*/
  0, /*tp_traverse*/
  0, /*tp_clear*/
  0, /*tp_richcompare*/
  0, /*tp_weaklistoffset*/
  __pyx_f_4dnet_4addr___iter__, /*tp_iter*/
  0, /*tp_iternext*/
  __pyx_methods_4dnet_addr, /*tp_methods*/
  0, /*tp_members*/
  __pyx_getsets_4dnet_addr, /*tp_getset*/
  0, /*tp_base*/
  0, /*tp_dict*/
  0, /*tp_descr_get*/
  0, /*tp_descr_set*/
  0, /*tp_dictoffset*/
  __pyx_f_4dnet_4addr___init__, /*tp_init*/
  0, /*tp_alloc*/
  __pyx_tp_new_4dnet_addr, /*tp_new*/
  0, /*tp_free*/
  0, /*tp_is_gc*/
  0, /*tp_bases*/
  0, /*tp_mro*/
  0, /*tp_cache*/
  0, /*tp_subclasses*/
  0, /*tp_weaklist*/
};

static PyObject *__pyx_tp_new_4dnet___addr_ip4_iter(PyTypeObject *t, PyObject *a, PyObject *k) {
  PyObject *o = (*t->tp_alloc)(t, 0);
  if (!o) return 0;
  return o;
}

static void __pyx_tp_dealloc_4dnet___addr_ip4_iter(PyObject *o) {
  (*o->ob_type->tp_free)(o);
}

static struct PyMethodDef __pyx_methods_4dnet___addr_ip4_iter[] = {
  {0, 0, 0, 0}
};

static PyNumberMethods __pyx_tp_as_number___addr_ip4_iter = {
  0, /*nb_add*/
  0, /*nb_subtract*/
  0, /*nb_multiply*/
  0, /*nb_divide*/
  0, /*nb_remainder*/
  0, /*nb_divmod*/
  0, /*nb_power*/
  0, /*nb_negative*/
  0, /*nb_positive*/
  0, /*nb_absolute*/
  0, /*nb_nonzero*/
  0, /*nb_invert*/
  0, /*nb_lshift*/
  0, /*nb_rshift*/
  0, /*nb_and*/
  0, /*nb_xor*/
  0, /*nb_or*/
  0, /*nb_coerce*/
  0, /*nb_int*/
  0, /*nb_long*/
  0, /*nb_float*/
  0, /*nb_oct*/
  0, /*nb_hex*/
  0, /*nb_inplace_add*/
  0, /*nb_inplace_subtract*/
  0, /*nb_inplace_multiply*/
  0, /*nb_inplace_divide*/
  0, /*nb_inplace_remainder*/
  0, /*nb_inplace_power*/
  0, /*nb_inplace_lshift*/
  0, /*nb_inplace_rshift*/
  0, /*nb_inplace_and*/
  0, /*nb_inplace_xor*/
  0, /*nb_inplace_or*/
  0, /*nb_floor_divide*/
  0, /*nb_true_divide*/
  0, /*nb_inplace_floor_divide*/
  0, /*nb_inplace_true_divide*/
  #if Py_TPFLAGS_DEFAULT & Py_TPFLAGS_HAVE_INDEX
  0, /*nb_index*/
  #endif
};

static PySequenceMethods __pyx_tp_as_sequence___addr_ip4_iter = {
  0, /*sq_length*/
  0, /*sq_concat*/
  0, /*sq_repeat*/
  0, /*sq_item*/
  0, /*sq_slice*/
  0, /*sq_ass_item*/
  0, /*sq_ass_slice*/
  0, /*sq_contains*/
  0, /*sq_inplace_concat*/
  0, /*sq_inplace_repeat*/
};

static PyMappingMethods __pyx_tp_as_mapping___addr_ip4_iter = {
  0, /*mp_length*/
  0, /*mp_subscript*/
  0, /*mp_ass_subscript*/
};

static PyBufferProcs __pyx_tp_as_buffer___addr_ip4_iter = {
  0, /*bf_getreadbuffer*/
  0, /*bf_getwritebuffer*/
  0, /*bf_getsegcount*/
  0, /*bf_getcharbuffer*/
};

PyTypeObject __pyx_type_4dnet___addr_ip4_iter = {
  PyObject_HEAD_INIT(0)
  0, /*ob_size*/
  "dnet.__addr_ip4_iter", /*tp_name*/
  sizeof(struct __pyx_obj_4dnet___addr_ip4_iter), /*tp_basicsize*/
  0, /*tp_itemsize*/
  __pyx_tp_dealloc_4dnet___addr_ip4_iter, /*tp_dealloc*/
  0, /*tp_print*/
  0, /*tp_getattr*/
  0, /*tp_setattr*/
  0, /*tp_compare*/
  0, /*tp_repr*/
  &__pyx_tp_as_number___addr_ip4_iter, /*tp_as_number*/
  &__pyx_tp_as_sequence___addr_ip4_iter, /*tp_as_sequence*/
  &__pyx_tp_as_mapping___addr_ip4_iter, /*tp_as_mapping*/
  0, /*tp_hash*/
  0, /*tp_call*/
  0, /*tp_str*/
  0, /*tp_getattro*/
  0, /*tp_setattro*/
  &__pyx_tp_as_buffer___addr_ip4_iter, /*tp_as_buffer*/
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_BASETYPE, /*tp_flags*/
  0, /*tp_doc*/
  0, /*tp_traverse*/
  0, /*tp_clear*/
  0, /*tp_richcompare*/
  0, /*tp_weaklistoffset*/
  0, /*tp_iter*/
  __pyx_f_4dnet_15__addr_ip4_iter___next__, /*tp_iternext*/
  __pyx_methods_4dnet___addr_ip4_iter, /*tp_methods*/
  0, /*tp_members*/
  0, /*tp_getset*/
  0, /*tp_base*/
  0, /*tp_dict*/
  0, /*tp_descr_get*/
  0, /*tp_descr_set*/
  0, /*tp_dictoffset*/
  __pyx_f_4dnet_15__addr_ip4_iter___init__, /*tp_init*/
  0, /*tp_alloc*/
  __pyx_tp_new_4dnet___addr_ip4_iter, /*tp_new*/
  0, /*tp_free*/
  0, /*tp_is_gc*/
  0, /*tp_bases*/
  0, /*tp_mro*/
  0, /*tp_cache*/
  0, /*tp_subclasses*/
  0, /*tp_weaklist*/
};

static PyObject *__pyx_tp_new_4dnet_arp(PyTypeObject *t, PyObject *a, PyObject *k) {
  PyObject *o = (*t->tp_alloc)(t, 0);
  if (!o) return 0;
  return o;
}

static void __pyx_tp_dealloc_4dnet_arp(PyObject *o) {
  {
    PyObject *etype, *eval, *etb;
    PyErr_Fetch(&etype, &eval, &etb);
    ++o->ob_refcnt;
    __pyx_f_4dnet_3arp___dealloc__(o);
    if (PyErr_Occurred()) PyErr_WriteUnraisable(o);
    --o->ob_refcnt;
    PyErr_Restore(etype, eval, etb);
  }
  (*o->ob_type->tp_free)(o);
}

static struct PyMethodDef __pyx_methods_4dnet_arp[] = {
  {"add", (PyCFunction)__pyx_f_4dnet_3arp_add, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_3arp_add},
  {"delete", (PyCFunction)__pyx_f_4dnet_3arp_delete, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_3arp_delete},
  {"get", (PyCFunction)__pyx_f_4dnet_3arp_get, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_3arp_get},
  {"loop", (PyCFunction)__pyx_f_4dnet_3arp_loop, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_3arp_loop},
  {0, 0, 0, 0}
};

static PyNumberMethods __pyx_tp_as_number_arp = {
  0, /*nb_add*/
  0, /*nb_subtract*/
  0, /*nb_multiply*/
  0, /*nb_divide*/
  0, /*nb_remainder*/
  0, /*nb_divmod*/
  0, /*nb_power*/
  0, /*nb_negative*/
  0, /*nb_positive*/
  0, /*nb_absolute*/
  0, /*nb_nonzero*/
  0, /*nb_invert*/
  0, /*nb_lshift*/
  0, /*nb_rshift*/
  0, /*nb_and*/
  0, /*nb_xor*/
  0, /*nb_or*/
  0, /*nb_coerce*/
  0, /*nb_int*/
  0, /*nb_long*/
  0, /*nb_float*/
  0, /*nb_oct*/
  0, /*nb_hex*/
  0, /*nb_inplace_add*/
  0, /*nb_inplace_subtract*/
  0, /*nb_inplace_multiply*/
  0, /*nb_inplace_divide*/
  0, /*nb_inplace_remainder*/
  0, /*nb_inplace_power*/
  0, /*nb_inplace_lshift*/
  0, /*nb_inplace_rshift*/
  0, /*nb_inplace_and*/
  0, /*nb_inplace_xor*/
  0, /*nb_inplace_or*/
  0, /*nb_floor_divide*/
  0, /*nb_true_divide*/
  0, /*nb_inplace_floor_divide*/
  0, /*nb_inplace_true_divide*/
  #if Py_TPFLAGS_DEFAULT & Py_TPFLAGS_HAVE_INDEX
  0, /*nb_index*/
  #endif
};

static PySequenceMethods __pyx_tp_as_sequence_arp = {
  0, /*sq_length*/
  0, /*sq_concat*/
  0, /*sq_repeat*/
  0, /*sq_item*/
  0, /*sq_slice*/
  0, /*sq_ass_item*/
  0, /*sq_ass_slice*/
  0, /*sq_contains*/
  0, /*sq_inplace_concat*/
  0, /*sq_inplace_repeat*/
};

static PyMappingMethods __pyx_tp_as_mapping_arp = {
  0, /*mp_length*/
  0, /*mp_subscript*/
  0, /*mp_ass_subscript*/
};

static PyBufferProcs __pyx_tp_as_buffer_arp = {
  0, /*bf_getreadbuffer*/
  0, /*bf_getwritebuffer*/
  0, /*bf_getsegcount*/
  0, /*bf_getcharbuffer*/
};

PyTypeObject __pyx_type_4dnet_arp = {
  PyObject_HEAD_INIT(0)
  0, /*ob_size*/
  "dnet.arp", /*tp_name*/
  sizeof(struct __pyx_obj_4dnet_arp), /*tp_basicsize*/
  0, /*tp_itemsize*/
  __pyx_tp_dealloc_4dnet_arp, /*tp_dealloc*/
  0, /*tp_print*/
  0, /*tp_getattr*/
  0, /*tp_setattr*/
  0, /*tp_compare*/
  0, /*tp_repr*/
  &__pyx_tp_as_number_arp, /*tp_as_number*/
  &__pyx_tp_as_sequence_arp, /*tp_as_sequence*/
  &__pyx_tp_as_mapping_arp, /*tp_as_mapping*/
  0, /*tp_hash*/
  0, /*tp_call*/
  0, /*tp_str*/
  0, /*tp_getattro*/
  0, /*tp_setattro*/
  &__pyx_tp_as_buffer_arp, /*tp_as_buffer*/
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_BASETYPE, /*tp_flags*/
  "arp() -> ARP table object\n\n    Open a handle to the system ARP table.\n    ", /*tp_doc*/
  0, /*tp_traverse*/
  0, /*tp_clear*/
  0, /*tp_richcompare*/
  0, /*tp_weaklistoffset*/
  __pyx_f_4dnet_3arp___iter__, /*tp_iter*/
  0, /*tp_iternext*/
  __pyx_methods_4dnet_arp, /*tp_methods*/
  0, /*tp_members*/
  0, /*tp_getset*/
  0, /*tp_base*/
  0, /*tp_dict*/
  0, /*tp_descr_get*/
  0, /*tp_descr_set*/
  0, /*tp_dictoffset*/
  __pyx_f_4dnet_3arp___init__, /*tp_init*/
  0, /*tp_alloc*/
  __pyx_tp_new_4dnet_arp, /*tp_new*/
  0, /*tp_free*/
  0, /*tp_is_gc*/
  0, /*tp_bases*/
  0, /*tp_mro*/
  0, /*tp_cache*/
  0, /*tp_subclasses*/
  0, /*tp_weaklist*/
};

static PyObject *__pyx_tp_new_4dnet_intf(PyTypeObject *t, PyObject *a, PyObject *k) {
  PyObject *o = (*t->tp_alloc)(t, 0);
  if (!o) return 0;
  return o;
}

static void __pyx_tp_dealloc_4dnet_intf(PyObject *o) {
  {
    PyObject *etype, *eval, *etb;
    PyErr_Fetch(&etype, &eval, &etb);
    ++o->ob_refcnt;
    __pyx_f_4dnet_4intf___dealloc__(o);
    if (PyErr_Occurred()) PyErr_WriteUnraisable(o);
    --o->ob_refcnt;
    PyErr_Restore(etype, eval, etb);
  }
  (*o->ob_type->tp_free)(o);
}

static struct PyMethodDef __pyx_methods_4dnet_intf[] = {
  {"get", (PyCFunction)__pyx_f_4dnet_4intf_get, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_4intf_get},
  {"get_src", (PyCFunction)__pyx_f_4dnet_4intf_get_src, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_4intf_get_src},
  {"get_dst", (PyCFunction)__pyx_f_4dnet_4intf_get_dst, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_4intf_get_dst},
  {"set", (PyCFunction)__pyx_f_4dnet_4intf_set, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_4intf_set},
  {"loop", (PyCFunction)__pyx_f_4dnet_4intf_loop, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_4intf_loop},
  {0, 0, 0, 0}
};

static PyNumberMethods __pyx_tp_as_number_intf = {
  0, /*nb_add*/
  0, /*nb_subtract*/
  0, /*nb_multiply*/
  0, /*nb_divide*/
  0, /*nb_remainder*/
  0, /*nb_divmod*/
  0, /*nb_power*/
  0, /*nb_negative*/
  0, /*nb_positive*/
  0, /*nb_absolute*/
  0, /*nb_nonzero*/
  0, /*nb_invert*/
  0, /*nb_lshift*/
  0, /*nb_rshift*/
  0, /*nb_and*/
  0, /*nb_xor*/
  0, /*nb_or*/
  0, /*nb_coerce*/
  0, /*nb_int*/
  0, /*nb_long*/
  0, /*nb_float*/
  0, /*nb_oct*/
  0, /*nb_hex*/
  0, /*nb_inplace_add*/
  0, /*nb_inplace_subtract*/
  0, /*nb_inplace_multiply*/
  0, /*nb_inplace_divide*/
  0, /*nb_inplace_remainder*/
  0, /*nb_inplace_power*/
  0, /*nb_inplace_lshift*/
  0, /*nb_inplace_rshift*/
  0, /*nb_inplace_and*/
  0, /*nb_inplace_xor*/
  0, /*nb_inplace_or*/
  0, /*nb_floor_divide*/
  0, /*nb_true_divide*/
  0, /*nb_inplace_floor_divide*/
  0, /*nb_inplace_true_divide*/
  #if Py_TPFLAGS_DEFAULT & Py_TPFLAGS_HAVE_INDEX
  0, /*nb_index*/
  #endif
};

static PySequenceMethods __pyx_tp_as_sequence_intf = {
  0, /*sq_length*/
  0, /*sq_concat*/
  0, /*sq_repeat*/
  0, /*sq_item*/
  0, /*sq_slice*/
  0, /*sq_ass_item*/
  0, /*sq_ass_slice*/
  0, /*sq_contains*/
  0, /*sq_inplace_concat*/
  0, /*sq_inplace_repeat*/
};

static PyMappingMethods __pyx_tp_as_mapping_intf = {
  0, /*mp_length*/
  0, /*mp_subscript*/
  0, /*mp_ass_subscript*/
};

static PyBufferProcs __pyx_tp_as_buffer_intf = {
  0, /*bf_getreadbuffer*/
  0, /*bf_getwritebuffer*/
  0, /*bf_getsegcount*/
  0, /*bf_getcharbuffer*/
};

PyTypeObject __pyx_type_4dnet_intf = {
  PyObject_HEAD_INIT(0)
  0, /*ob_size*/
  "dnet.intf", /*tp_name*/
  sizeof(struct __pyx_obj_4dnet_intf), /*tp_basicsize*/
  0, /*tp_itemsize*/
  __pyx_tp_dealloc_4dnet_intf, /*tp_dealloc*/
  0, /*tp_print*/
  0, /*tp_getattr*/
  0, /*tp_setattr*/
  0, /*tp_compare*/
  0, /*tp_repr*/
  &__pyx_tp_as_number_intf, /*tp_as_number*/
  &__pyx_tp_as_sequence_intf, /*tp_as_sequence*/
  &__pyx_tp_as_mapping_intf, /*tp_as_mapping*/
  0, /*tp_hash*/
  0, /*tp_call*/
  0, /*tp_str*/
  0, /*tp_getattro*/
  0, /*tp_setattro*/
  &__pyx_tp_as_buffer_intf, /*tp_as_buffer*/
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_BASETYPE, /*tp_flags*/
  "intf() -> Interface table object\n\n    Open a handle to the system network interface table.\n    ", /*tp_doc*/
  0, /*tp_traverse*/
  0, /*tp_clear*/
  0, /*tp_richcompare*/
  0, /*tp_weaklistoffset*/
  __pyx_f_4dnet_4intf___iter__, /*tp_iter*/
  0, /*tp_iternext*/
  __pyx_methods_4dnet_intf, /*tp_methods*/
  0, /*tp_members*/
  0, /*tp_getset*/
  0, /*tp_base*/
  0, /*tp_dict*/
  0, /*tp_descr_get*/
  0, /*tp_descr_set*/
  0, /*tp_dictoffset*/
  __pyx_f_4dnet_4intf___init__, /*tp_init*/
  0, /*tp_alloc*/
  __pyx_tp_new_4dnet_intf, /*tp_new*/
  0, /*tp_free*/
  0, /*tp_is_gc*/
  0, /*tp_bases*/
  0, /*tp_mro*/
  0, /*tp_cache*/
  0, /*tp_subclasses*/
  0, /*tp_weaklist*/
};

static PyObject *__pyx_tp_new_4dnet_route(PyTypeObject *t, PyObject *a, PyObject *k) {
  PyObject *o = (*t->tp_alloc)(t, 0);
  if (!o) return 0;
  return o;
}

static void __pyx_tp_dealloc_4dnet_route(PyObject *o) {
  {
    PyObject *etype, *eval, *etb;
    PyErr_Fetch(&etype, &eval, &etb);
    ++o->ob_refcnt;
    __pyx_f_4dnet_5route___dealloc__(o);
    if (PyErr_Occurred()) PyErr_WriteUnraisable(o);
    --o->ob_refcnt;
    PyErr_Restore(etype, eval, etb);
  }
  (*o->ob_type->tp_free)(o);
}

static struct PyMethodDef __pyx_methods_4dnet_route[] = {
  {"add", (PyCFunction)__pyx_f_4dnet_5route_add, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_5route_add},
  {"delete", (PyCFunction)__pyx_f_4dnet_5route_delete, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_5route_delete},
  {"get", (PyCFunction)__pyx_f_4dnet_5route_get, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_5route_get},
  {"loop", (PyCFunction)__pyx_f_4dnet_5route_loop, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_5route_loop},
  {0, 0, 0, 0}
};

static PyNumberMethods __pyx_tp_as_number_route = {
  0, /*nb_add*/
  0, /*nb_subtract*/
  0, /*nb_multiply*/
  0, /*nb_divide*/
  0, /*nb_remainder*/
  0, /*nb_divmod*/
  0, /*nb_power*/
  0, /*nb_negative*/
  0, /*nb_positive*/
  0, /*nb_absolute*/
  0, /*nb_nonzero*/
  0, /*nb_invert*/
  0, /*nb_lshift*/
  0, /*nb_rshift*/
  0, /*nb_and*/
  0, /*nb_xor*/
  0, /*nb_or*/
  0, /*nb_coerce*/
  0, /*nb_int*/
  0, /*nb_long*/
  0, /*nb_float*/
  0, /*nb_oct*/
  0, /*nb_hex*/
  0, /*nb_inplace_add*/
  0, /*nb_inplace_subtract*/
  0, /*nb_inplace_multiply*/
  0, /*nb_inplace_divide*/
  0, /*nb_inplace_remainder*/
  0, /*nb_inplace_power*/
  0, /*nb_inplace_lshift*/
  0, /*nb_inplace_rshift*/
  0, /*nb_inplace_and*/
  0, /*nb_inplace_xor*/
  0, /*nb_inplace_or*/
  0, /*nb_floor_divide*/
  0, /*nb_true_divide*/
  0, /*nb_inplace_floor_divide*/
  0, /*nb_inplace_true_divide*/
  #if Py_TPFLAGS_DEFAULT & Py_TPFLAGS_HAVE_INDEX
  0, /*nb_index*/
  #endif
};

static PySequenceMethods __pyx_tp_as_sequence_route = {
  0, /*sq_length*/
  0, /*sq_concat*/
  0, /*sq_repeat*/
  0, /*sq_item*/
  0, /*sq_slice*/
  0, /*sq_ass_item*/
  0, /*sq_ass_slice*/
  0, /*sq_contains*/
  0, /*sq_inplace_concat*/
  0, /*sq_inplace_repeat*/
};

static PyMappingMethods __pyx_tp_as_mapping_route = {
  0, /*mp_length*/
  0, /*mp_subscript*/
  0, /*mp_ass_subscript*/
};

static PyBufferProcs __pyx_tp_as_buffer_route = {
  0, /*bf_getreadbuffer*/
  0, /*bf_getwritebuffer*/
  0, /*bf_getsegcount*/
  0, /*bf_getcharbuffer*/
};

PyTypeObject __pyx_type_4dnet_route = {
  PyObject_HEAD_INIT(0)
  0, /*ob_size*/
  "dnet.route", /*tp_name*/
  sizeof(struct __pyx_obj_4dnet_route), /*tp_basicsize*/
  0, /*tp_itemsize*/
  __pyx_tp_dealloc_4dnet_route, /*tp_dealloc*/
  0, /*tp_print*/
  0, /*tp_getattr*/
  0, /*tp_setattr*/
  0, /*tp_compare*/
  0, /*tp_repr*/
  &__pyx_tp_as_number_route, /*tp_as_number*/
  &__pyx_tp_as_sequence_route, /*tp_as_sequence*/
  &__pyx_tp_as_mapping_route, /*tp_as_mapping*/
  0, /*tp_hash*/
  0, /*tp_call*/
  0, /*tp_str*/
  0, /*tp_getattro*/
  0, /*tp_setattro*/
  &__pyx_tp_as_buffer_route, /*tp_as_buffer*/
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_BASETYPE, /*tp_flags*/
  "route() -> Routing table object\n\n    Open a handle to the system routing table.\n    ", /*tp_doc*/
  0, /*tp_traverse*/
  0, /*tp_clear*/
  0, /*tp_richcompare*/
  0, /*tp_weaklistoffset*/
  __pyx_f_4dnet_5route___iter__, /*tp_iter*/
  0, /*tp_iternext*/
  __pyx_methods_4dnet_route, /*tp_methods*/
  0, /*tp_members*/
  0, /*tp_getset*/
  0, /*tp_base*/
  0, /*tp_dict*/
  0, /*tp_descr_get*/
  0, /*tp_descr_set*/
  0, /*tp_dictoffset*/
  __pyx_f_4dnet_5route___init__, /*tp_init*/
  0, /*tp_alloc*/
  __pyx_tp_new_4dnet_route, /*tp_new*/
  0, /*tp_free*/
  0, /*tp_is_gc*/
  0, /*tp_bases*/
  0, /*tp_mro*/
  0, /*tp_cache*/
  0, /*tp_subclasses*/
  0, /*tp_weaklist*/
};

static PyObject *__pyx_tp_new_4dnet_fw(PyTypeObject *t, PyObject *a, PyObject *k) {
  PyObject *o = (*t->tp_alloc)(t, 0);
  if (!o) return 0;
  return o;
}

static void __pyx_tp_dealloc_4dnet_fw(PyObject *o) {
  {
    PyObject *etype, *eval, *etb;
    PyErr_Fetch(&etype, &eval, &etb);
    ++o->ob_refcnt;
    __pyx_f_4dnet_2fw___dealloc__(o);
    if (PyErr_Occurred()) PyErr_WriteUnraisable(o);
    --o->ob_refcnt;
    PyErr_Restore(etype, eval, etb);
  }
  (*o->ob_type->tp_free)(o);
}

static struct PyMethodDef __pyx_methods_4dnet_fw[] = {
  {"add", (PyCFunction)__pyx_f_4dnet_2fw_add, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_2fw_add},
  {"delete", (PyCFunction)__pyx_f_4dnet_2fw_delete, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_2fw_delete},
  {"loop", (PyCFunction)__pyx_f_4dnet_2fw_loop, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_2fw_loop},
  {0, 0, 0, 0}
};

static PyNumberMethods __pyx_tp_as_number_fw = {
  0, /*nb_add*/
  0, /*nb_subtract*/
  0, /*nb_multiply*/
  0, /*nb_divide*/
  0, /*nb_remainder*/
  0, /*nb_divmod*/
  0, /*nb_power*/
  0, /*nb_negative*/
  0, /*nb_positive*/
  0, /*nb_absolute*/
  0, /*nb_nonzero*/
  0, /*nb_invert*/
  0, /*nb_lshift*/
  0, /*nb_rshift*/
  0, /*nb_and*/
  0, /*nb_xor*/
  0, /*nb_or*/
  0, /*nb_coerce*/
  0, /*nb_int*/
  0, /*nb_long*/
  0, /*nb_float*/
  0, /*nb_oct*/
  0, /*nb_hex*/
  0, /*nb_inplace_add*/
  0, /*nb_inplace_subtract*/
  0, /*nb_inplace_multiply*/
  0, /*nb_inplace_divide*/
  0, /*nb_inplace_remainder*/
  0, /*nb_inplace_power*/
  0, /*nb_inplace_lshift*/
  0, /*nb_inplace_rshift*/
  0, /*nb_inplace_and*/
  0, /*nb_inplace_xor*/
  0, /*nb_inplace_or*/
  0, /*nb_floor_divide*/
  0, /*nb_true_divide*/
  0, /*nb_inplace_floor_divide*/
  0, /*nb_inplace_true_divide*/
  #if Py_TPFLAGS_DEFAULT & Py_TPFLAGS_HAVE_INDEX
  0, /*nb_index*/
  #endif
};

static PySequenceMethods __pyx_tp_as_sequence_fw = {
  0, /*sq_length*/
  0, /*sq_concat*/
  0, /*sq_repeat*/
  0, /*sq_item*/
  0, /*sq_slice*/
  0, /*sq_ass_item*/
  0, /*sq_ass_slice*/
  0, /*sq_contains*/
  0, /*sq_inplace_concat*/
  0, /*sq_inplace_repeat*/
};

static PyMappingMethods __pyx_tp_as_mapping_fw = {
  0, /*mp_length*/
  0, /*mp_subscript*/
  0, /*mp_ass_subscript*/
};

static PyBufferProcs __pyx_tp_as_buffer_fw = {
  0, /*bf_getreadbuffer*/
  0, /*bf_getwritebuffer*/
  0, /*bf_getsegcount*/
  0, /*bf_getcharbuffer*/
};

PyTypeObject __pyx_type_4dnet_fw = {
  PyObject_HEAD_INIT(0)
  0, /*ob_size*/
  "dnet.fw", /*tp_name*/
  sizeof(struct __pyx_obj_4dnet_fw), /*tp_basicsize*/
  0, /*tp_itemsize*/
  __pyx_tp_dealloc_4dnet_fw, /*tp_dealloc*/
  0, /*tp_print*/
  0, /*tp_getattr*/
  0, /*tp_setattr*/
  0, /*tp_compare*/
  0, /*tp_repr*/
  &__pyx_tp_as_number_fw, /*tp_as_number*/
  &__pyx_tp_as_sequence_fw, /*tp_as_sequence*/
  &__pyx_tp_as_mapping_fw, /*tp_as_mapping*/
  0, /*tp_hash*/
  0, /*tp_call*/
  0, /*tp_str*/
  0, /*tp_getattro*/
  0, /*tp_setattro*/
  &__pyx_tp_as_buffer_fw, /*tp_as_buffer*/
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_BASETYPE, /*tp_flags*/
  "fw() -> Firewall ruleset object\n    \n    Open a handle to the local network firewall configuration.\n    ", /*tp_doc*/
  0, /*tp_traverse*/
  0, /*tp_clear*/
  0, /*tp_richcompare*/
  0, /*tp_weaklistoffset*/
  __pyx_f_4dnet_2fw___iter__, /*tp_iter*/
  0, /*tp_iternext*/
  __pyx_methods_4dnet_fw, /*tp_methods*/
  0, /*tp_members*/
  0, /*tp_getset*/
  0, /*tp_base*/
  0, /*tp_dict*/
  0, /*tp_descr_get*/
  0, /*tp_descr_set*/
  0, /*tp_dictoffset*/
  __pyx_f_4dnet_2fw___init__, /*tp_init*/
  0, /*tp_alloc*/
  __pyx_tp_new_4dnet_fw, /*tp_new*/
  0, /*tp_free*/
  0, /*tp_is_gc*/
  0, /*tp_bases*/
  0, /*tp_mro*/
  0, /*tp_cache*/
  0, /*tp_subclasses*/
  0, /*tp_weaklist*/
};

static PyObject *__pyx_tp_new_4dnet_rand(PyTypeObject *t, PyObject *a, PyObject *k) {
  PyObject *o = (*t->tp_alloc)(t, 0);
  if (!o) return 0;
  return o;
}

static void __pyx_tp_dealloc_4dnet_rand(PyObject *o) {
  {
    PyObject *etype, *eval, *etb;
    PyErr_Fetch(&etype, &eval, &etb);
    ++o->ob_refcnt;
    __pyx_f_4dnet_4rand___dealloc__(o);
    if (PyErr_Occurred()) PyErr_WriteUnraisable(o);
    --o->ob_refcnt;
    PyErr_Restore(etype, eval, etb);
  }
  (*o->ob_type->tp_free)(o);
}

static struct PyMethodDef __pyx_methods_4dnet_rand[] = {
  {"get", (PyCFunction)__pyx_f_4dnet_4rand_get, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_4rand_get},
  {"set", (PyCFunction)__pyx_f_4dnet_4rand_set, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_4rand_set},
  {"add", (PyCFunction)__pyx_f_4dnet_4rand_add, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_4rand_add},
  {"uint8", (PyCFunction)__pyx_f_4dnet_4rand_uint8, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_4rand_uint8},
  {"uint16", (PyCFunction)__pyx_f_4dnet_4rand_uint16, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_4rand_uint16},
  {"uint32", (PyCFunction)__pyx_f_4dnet_4rand_uint32, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_4rand_uint32},
  {"xrange", (PyCFunction)__pyx_f_4dnet_4rand_xrange, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_4rand_xrange},
  {0, 0, 0, 0}
};

static PyNumberMethods __pyx_tp_as_number_rand = {
  0, /*nb_add*/
  0, /*nb_subtract*/
  0, /*nb_multiply*/
  0, /*nb_divide*/
  0, /*nb_remainder*/
  0, /*nb_divmod*/
  0, /*nb_power*/
  0, /*nb_negative*/
  0, /*nb_positive*/
  0, /*nb_absolute*/
  0, /*nb_nonzero*/
  0, /*nb_invert*/
  0, /*nb_lshift*/
  0, /*nb_rshift*/
  0, /*nb_and*/
  0, /*nb_xor*/
  0, /*nb_or*/
  0, /*nb_coerce*/
  0, /*nb_int*/
  0, /*nb_long*/
  0, /*nb_float*/
  0, /*nb_oct*/
  0, /*nb_hex*/
  0, /*nb_inplace_add*/
  0, /*nb_inplace_subtract*/
  0, /*nb_inplace_multiply*/
  0, /*nb_inplace_divide*/
  0, /*nb_inplace_remainder*/
  0, /*nb_inplace_power*/
  0, /*nb_inplace_lshift*/
  0, /*nb_inplace_rshift*/
  0, /*nb_inplace_and*/
  0, /*nb_inplace_xor*/
  0, /*nb_inplace_or*/
  0, /*nb_floor_divide*/
  0, /*nb_true_divide*/
  0, /*nb_inplace_floor_divide*/
  0, /*nb_inplace_true_divide*/
  #if Py_TPFLAGS_DEFAULT & Py_TPFLAGS_HAVE_INDEX
  0, /*nb_index*/
  #endif
};

static PySequenceMethods __pyx_tp_as_sequence_rand = {
  0, /*sq_length*/
  0, /*sq_concat*/
  0, /*sq_repeat*/
  0, /*sq_item*/
  0, /*sq_slice*/
  0, /*sq_ass_item*/
  0, /*sq_ass_slice*/
  0, /*sq_contains*/
  0, /*sq_inplace_concat*/
  0, /*sq_inplace_repeat*/
};

static PyMappingMethods __pyx_tp_as_mapping_rand = {
  0, /*mp_length*/
  0, /*mp_subscript*/
  0, /*mp_ass_subscript*/
};

static PyBufferProcs __pyx_tp_as_buffer_rand = {
  0, /*bf_getreadbuffer*/
  0, /*bf_getwritebuffer*/
  0, /*bf_getsegcount*/
  0, /*bf_getcharbuffer*/
};

PyTypeObject __pyx_type_4dnet_rand = {
  PyObject_HEAD_INIT(0)
  0, /*ob_size*/
  "dnet.rand", /*tp_name*/
  sizeof(struct __pyx_obj_4dnet_rand), /*tp_basicsize*/
  0, /*tp_itemsize*/
  __pyx_tp_dealloc_4dnet_rand, /*tp_dealloc*/
  0, /*tp_print*/
  0, /*tp_getattr*/
  0, /*tp_setattr*/
  0, /*tp_compare*/
  0, /*tp_repr*/
  &__pyx_tp_as_number_rand, /*tp_as_number*/
  &__pyx_tp_as_sequence_rand, /*tp_as_sequence*/
  &__pyx_tp_as_mapping_rand, /*tp_as_mapping*/
  0, /*tp_hash*/
  0, /*tp_call*/
  0, /*tp_str*/
  0, /*tp_getattro*/
  0, /*tp_setattro*/
  &__pyx_tp_as_buffer_rand, /*tp_as_buffer*/
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_BASETYPE, /*tp_flags*/
  "rand() -> Pseudo-random number generator\n\n    Obtain a handle for fast, cryptographically strong pseudo-random\n    number generation. The starting seed is derived from the system\n    random data source device (if one exists), or from the current time\n    and random stack contents.\n    ", /*tp_doc*/
  0, /*tp_traverse*/
  0, /*tp_clear*/
  0, /*tp_richcompare*/
  0, /*tp_weaklistoffset*/
  0, /*tp_iter*/
  0, /*tp_iternext*/
  __pyx_methods_4dnet_rand, /*tp_methods*/
  0, /*tp_members*/
  0, /*tp_getset*/
  0, /*tp_base*/
  0, /*tp_dict*/
  0, /*tp_descr_get*/
  0, /*tp_descr_set*/
  0, /*tp_dictoffset*/
  __pyx_f_4dnet_4rand___init__, /*tp_init*/
  0, /*tp_alloc*/
  __pyx_tp_new_4dnet_rand, /*tp_new*/
  0, /*tp_free*/
  0, /*tp_is_gc*/
  0, /*tp_bases*/
  0, /*tp_mro*/
  0, /*tp_cache*/
  0, /*tp_subclasses*/
  0, /*tp_weaklist*/
};

static PyObject *__pyx_tp_new_4dnet___rand_xrange(PyTypeObject *t, PyObject *a, PyObject *k) {
  PyObject *o = (*t->tp_alloc)(t, 0);
  if (!o) return 0;
  return o;
}

static void __pyx_tp_dealloc_4dnet___rand_xrange(PyObject *o) {
  (*o->ob_type->tp_free)(o);
}

static struct PyMethodDef __pyx_methods_4dnet___rand_xrange[] = {
  {0, 0, 0, 0}
};

static PyNumberMethods __pyx_tp_as_number___rand_xrange = {
  0, /*nb_add*/
  0, /*nb_subtract*/
  0, /*nb_multiply*/
  0, /*nb_divide*/
  0, /*nb_remainder*/
  0, /*nb_divmod*/
  0, /*nb_power*/
  0, /*nb_negative*/
  0, /*nb_positive*/
  0, /*nb_absolute*/
  0, /*nb_nonzero*/
  0, /*nb_invert*/
  0, /*nb_lshift*/
  0, /*nb_rshift*/
  0, /*nb_and*/
  0, /*nb_xor*/
  0, /*nb_or*/
  0, /*nb_coerce*/
  0, /*nb_int*/
  0, /*nb_long*/
  0, /*nb_float*/
  0, /*nb_oct*/
  0, /*nb_hex*/
  0, /*nb_inplace_add*/
  0, /*nb_inplace_subtract*/
  0, /*nb_inplace_multiply*/
  0, /*nb_inplace_divide*/
  0, /*nb_inplace_remainder*/
  0, /*nb_inplace_power*/
  0, /*nb_inplace_lshift*/
  0, /*nb_inplace_rshift*/
  0, /*nb_inplace_and*/
  0, /*nb_inplace_xor*/
  0, /*nb_inplace_or*/
  0, /*nb_floor_divide*/
  0, /*nb_true_divide*/
  0, /*nb_inplace_floor_divide*/
  0, /*nb_inplace_true_divide*/
  #if Py_TPFLAGS_DEFAULT & Py_TPFLAGS_HAVE_INDEX
  0, /*nb_index*/
  #endif
};

static PySequenceMethods __pyx_tp_as_sequence___rand_xrange = {
  __pyx_f_4dnet_13__rand_xrange___len__, /*sq_length*/
  0, /*sq_concat*/
  0, /*sq_repeat*/
  0, /*sq_item*/
  0, /*sq_slice*/
  0, /*sq_ass_item*/
  0, /*sq_ass_slice*/
  0, /*sq_contains*/
  0, /*sq_inplace_concat*/
  0, /*sq_inplace_repeat*/
};

static PyMappingMethods __pyx_tp_as_mapping___rand_xrange = {
  __pyx_f_4dnet_13__rand_xrange___len__, /*mp_length*/
  0, /*mp_subscript*/
  0, /*mp_ass_subscript*/
};

static PyBufferProcs __pyx_tp_as_buffer___rand_xrange = {
  0, /*bf_getreadbuffer*/
  0, /*bf_getwritebuffer*/
  0, /*bf_getsegcount*/
  0, /*bf_getcharbuffer*/
};

PyTypeObject __pyx_type_4dnet___rand_xrange = {
  PyObject_HEAD_INIT(0)
  0, /*ob_size*/
  "dnet.__rand_xrange", /*tp_name*/
  sizeof(struct __pyx_obj_4dnet___rand_xrange), /*tp_basicsize*/
  0, /*tp_itemsize*/
  __pyx_tp_dealloc_4dnet___rand_xrange, /*tp_dealloc*/
  0, /*tp_print*/
  0, /*tp_getattr*/
  0, /*tp_setattr*/
  0, /*tp_compare*/
  0, /*tp_repr*/
  &__pyx_tp_as_number___rand_xrange, /*tp_as_number*/
  &__pyx_tp_as_sequence___rand_xrange, /*tp_as_sequence*/
  &__pyx_tp_as_mapping___rand_xrange, /*tp_as_mapping*/
  0, /*tp_hash*/
  0, /*tp_call*/
  0, /*tp_str*/
  0, /*tp_getattro*/
  0, /*tp_setattro*/
  &__pyx_tp_as_buffer___rand_xrange, /*tp_as_buffer*/
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_BASETYPE, /*tp_flags*/
  0, /*tp_doc*/
  0, /*tp_traverse*/
  0, /*tp_clear*/
  0, /*tp_richcompare*/
  0, /*tp_weaklistoffset*/
  __pyx_f_4dnet_13__rand_xrange___iter__, /*tp_iter*/
  __pyx_f_4dnet_13__rand_xrange___next__, /*tp_iternext*/
  __pyx_methods_4dnet___rand_xrange, /*tp_methods*/
  0, /*tp_members*/
  0, /*tp_getset*/
  0, /*tp_base*/
  0, /*tp_dict*/
  0, /*tp_descr_get*/
  0, /*tp_descr_set*/
  0, /*tp_dictoffset*/
  __pyx_f_4dnet_13__rand_xrange___init__, /*tp_init*/
  0, /*tp_alloc*/
  __pyx_tp_new_4dnet___rand_xrange, /*tp_new*/
  0, /*tp_free*/
  0, /*tp_is_gc*/
  0, /*tp_bases*/
  0, /*tp_mro*/
  0, /*tp_cache*/
  0, /*tp_subclasses*/
  0, /*tp_weaklist*/
};

static PyObject *__pyx_tp_new_4dnet_tun(PyTypeObject *t, PyObject *a, PyObject *k) {
  PyObject *o = (*t->tp_alloc)(t, 0);
  if (!o) return 0;
  return o;
}

static void __pyx_tp_dealloc_4dnet_tun(PyObject *o) {
  {
    PyObject *etype, *eval, *etb;
    PyErr_Fetch(&etype, &eval, &etb);
    ++o->ob_refcnt;
    __pyx_f_4dnet_3tun___dealloc__(o);
    if (PyErr_Occurred()) PyErr_WriteUnraisable(o);
    --o->ob_refcnt;
    PyErr_Restore(etype, eval, etb);
  }
  (*o->ob_type->tp_free)(o);
}

static PyObject *__pyx_getprop_4dnet_3tun_name(PyObject *o, void *x) {
  return __pyx_f_4dnet_3tun_4name___get__(o);
}

static PyObject *__pyx_getprop_4dnet_3tun_fd(PyObject *o, void *x) {
  return __pyx_f_4dnet_3tun_2fd___get__(o);
}

static struct PyMethodDef __pyx_methods_4dnet_tun[] = {
  {"fileno", (PyCFunction)__pyx_f_4dnet_3tun_fileno, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_3tun_fileno},
  {"send", (PyCFunction)__pyx_f_4dnet_3tun_send, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_3tun_send},
  {"recv", (PyCFunction)__pyx_f_4dnet_3tun_recv, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_3tun_recv},
  {"close", (PyCFunction)__pyx_f_4dnet_3tun_close, METH_VARARGS|METH_KEYWORDS, 0},
  {0, 0, 0, 0}
};

static struct PyGetSetDef __pyx_getsets_4dnet_tun[] = {
  {"name", __pyx_getprop_4dnet_3tun_name, 0, __pyx_k58, 0},
  {"fd", __pyx_getprop_4dnet_3tun_fd, 0, __pyx_k59, 0},
  {0, 0, 0, 0, 0}
};

static PyNumberMethods __pyx_tp_as_number_tun = {
  0, /*nb_add*/
  0, /*nb_subtract*/
  0, /*nb_multiply*/
  0, /*nb_divide*/
  0, /*nb_remainder*/
  0, /*nb_divmod*/
  0, /*nb_power*/
  0, /*nb_negative*/
  0, /*nb_positive*/
  0, /*nb_absolute*/
  0, /*nb_nonzero*/
  0, /*nb_invert*/
  0, /*nb_lshift*/
  0, /*nb_rshift*/
  0, /*nb_and*/
  0, /*nb_xor*/
  0, /*nb_or*/
  0, /*nb_coerce*/
  0, /*nb_int*/
  0, /*nb_long*/
  0, /*nb_float*/
  0, /*nb_oct*/
  0, /*nb_hex*/
  0, /*nb_inplace_add*/
  0, /*nb_inplace_subtract*/
  0, /*nb_inplace_multiply*/
  0, /*nb_inplace_divide*/
  0, /*nb_inplace_remainder*/
  0, /*nb_inplace_power*/
  0, /*nb_inplace_lshift*/
  0, /*nb_inplace_rshift*/
  0, /*nb_inplace_and*/
  0, /*nb_inplace_xor*/
  0, /*nb_inplace_or*/
  0, /*nb_floor_divide*/
  0, /*nb_true_divide*/
  0, /*nb_inplace_floor_divide*/
  0, /*nb_inplace_true_divide*/
  #if Py_TPFLAGS_DEFAULT & Py_TPFLAGS_HAVE_INDEX
  0, /*nb_index*/
  #endif
};

static PySequenceMethods __pyx_tp_as_sequence_tun = {
  0, /*sq_length*/
  0, /*sq_concat*/
  0, /*sq_repeat*/
  0, /*sq_item*/
  0, /*sq_slice*/
  0, /*sq_ass_item*/
  0, /*sq_ass_slice*/
  0, /*sq_contains*/
  0, /*sq_inplace_concat*/
  0, /*sq_inplace_repeat*/
};

static PyMappingMethods __pyx_tp_as_mapping_tun = {
  0, /*mp_length*/
  0, /*mp_subscript*/
  0, /*mp_ass_subscript*/
};

static PyBufferProcs __pyx_tp_as_buffer_tun = {
  0, /*bf_getreadbuffer*/
  0, /*bf_getwritebuffer*/
  0, /*bf_getsegcount*/
  0, /*bf_getcharbuffer*/
};

PyTypeObject __pyx_type_4dnet_tun = {
  PyObject_HEAD_INIT(0)
  0, /*ob_size*/
  "dnet.tun", /*tp_name*/
  sizeof(struct __pyx_obj_4dnet_tun), /*tp_basicsize*/
  0, /*tp_itemsize*/
  __pyx_tp_dealloc_4dnet_tun, /*tp_dealloc*/
  0, /*tp_print*/
  0, /*tp_getattr*/
  0, /*tp_setattr*/
  0, /*tp_compare*/
  0, /*tp_repr*/
  &__pyx_tp_as_number_tun, /*tp_as_number*/
  &__pyx_tp_as_sequence_tun, /*tp_as_sequence*/
  &__pyx_tp_as_mapping_tun, /*tp_as_mapping*/
  0, /*tp_hash*/
  0, /*tp_call*/
  0, /*tp_str*/
  0, /*tp_getattro*/
  0, /*tp_setattro*/
  &__pyx_tp_as_buffer_tun, /*tp_as_buffer*/
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_BASETYPE, /*tp_flags*/
  "tun(src, dst[, mtu]) -> Network tunnel interface handle\n    \n    Obtain a handle to a network tunnel interface, to which packets\n    destined for dst are delivered (with source addresses rewritten to\n    src), where they may be read by a userland process and processed\n    as desired. Packets written back to the handle are injected into\n    the kernel networking subsystem.\n    ", /*tp_doc*/
  0, /*tp_traverse*/
  0, /*tp_clear*/
  0, /*tp_richcompare*/
  0, /*tp_weaklistoffset*/
  0, /*tp_iter*/
  0, /*tp_iternext*/
  __pyx_methods_4dnet_tun, /*tp_methods*/
  0, /*tp_members*/
  __pyx_getsets_4dnet_tun, /*tp_getset*/
  0, /*tp_base*/
  0, /*tp_dict*/
  0, /*tp_descr_get*/
  0, /*tp_descr_set*/
  0, /*tp_dictoffset*/
  __pyx_f_4dnet_3tun___init__, /*tp_init*/
  0, /*tp_alloc*/
  __pyx_tp_new_4dnet_tun, /*tp_new*/
  0, /*tp_free*/
  0, /*tp_is_gc*/
  0, /*tp_bases*/
  0, /*tp_mro*/
  0, /*tp_cache*/
  0, /*tp_subclasses*/
  0, /*tp_weaklist*/
};

static struct PyMethodDef __pyx_methods[] = {
  {"__iter_append", (PyCFunction)__pyx_f_4dnet___iter_append, METH_VARARGS|METH_KEYWORDS, 0},
  {"eth_ntoa", (PyCFunction)__pyx_f_4dnet_eth_ntoa, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_eth_ntoa},
  {"eth_aton", (PyCFunction)__pyx_f_4dnet_eth_aton, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_eth_aton},
  {"eth_pack_hdr", (PyCFunction)__pyx_f_4dnet_eth_pack_hdr, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_eth_pack_hdr},
  {"ip_ntoa", (PyCFunction)__pyx_f_4dnet_ip_ntoa, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_ip_ntoa},
  {"ip_aton", (PyCFunction)__pyx_f_4dnet_ip_aton, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_ip_aton},
  {"ip_checksum", (PyCFunction)__pyx_f_4dnet_ip_checksum, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_ip_checksum},
  {"ip_cksum_add", (PyCFunction)__pyx_f_4dnet_ip_cksum_add, METH_VARARGS|METH_KEYWORDS, 0},
  {"ip_cksum_carry", (PyCFunction)__pyx_f_4dnet_ip_cksum_carry, METH_VARARGS|METH_KEYWORDS, 0},
  {"ip_pack_hdr", (PyCFunction)__pyx_f_4dnet_ip_pack_hdr, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_ip_pack_hdr},
  {"ip6_ntoa", (PyCFunction)__pyx_f_4dnet_ip6_ntoa, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_ip6_ntoa},
  {"ip6_aton", (PyCFunction)__pyx_f_4dnet_ip6_aton, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_ip6_aton},
  {"ip6_checksum", (PyCFunction)__pyx_f_4dnet_ip6_checksum, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_ip6_checksum},
  {"ip6_pack_hdr", (PyCFunction)__pyx_f_4dnet_ip6_pack_hdr, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_ip6_pack_hdr},
  {"arp_pack_hdr_ethip", (PyCFunction)__pyx_f_4dnet_arp_pack_hdr_ethip, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_arp_pack_hdr_ethip},
  {"icmp_pack_hdr", (PyCFunction)__pyx_f_4dnet_icmp_pack_hdr, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_icmp_pack_hdr},
  {"tcp_pack_hdr", (PyCFunction)__pyx_f_4dnet_tcp_pack_hdr, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_tcp_pack_hdr},
  {"udp_pack_hdr", (PyCFunction)__pyx_f_4dnet_udp_pack_hdr, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4dnet_udp_pack_hdr},
  {0, 0, 0, 0}
};

static void __pyx_init_filenames(void); /*proto*/

PyMODINIT_FUNC initdnet(void); /*proto*/
PyMODINIT_FUNC initdnet(void) {
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  PyObject *__pyx_6 = 0;
  PyObject *__pyx_7 = 0;
  PyObject *__pyx_8 = 0;
  PyObject *__pyx_9 = 0;
  PyObject *__pyx_10 = 0;
  PyObject *__pyx_11 = 0;
  PyObject *__pyx_12 = 0;
  PyObject *__pyx_13 = 0;
  PyObject *__pyx_14 = 0;
  PyObject *__pyx_15 = 0;
  PyObject *__pyx_16 = 0;
  PyObject *__pyx_17 = 0;
  PyObject *__pyx_18 = 0;
  PyObject *__pyx_19 = 0;
  PyObject *__pyx_20 = 0;
  PyObject *__pyx_21 = 0;
  PyObject *__pyx_22 = 0;
  PyObject *__pyx_23 = 0;
  PyObject *__pyx_24 = 0;
  PyObject *__pyx_25 = 0;
  PyObject *__pyx_26 = 0;
  PyObject *__pyx_27 = 0;
  PyObject *__pyx_28 = 0;
  PyObject *__pyx_29 = 0;
  PyObject *__pyx_30 = 0;
  PyObject *__pyx_31 = 0;
  __pyx_init_filenames();
  __pyx_m = Py_InitModule4("dnet", __pyx_methods, __pyx_mdoc, 0, PYTHON_API_VERSION);
  if (!__pyx_m) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 6; goto __pyx_L1;};
  Py_INCREF(__pyx_m);
  __pyx_b = PyImport_AddModule("__builtin__");
  if (!__pyx_b) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 6; goto __pyx_L1;};
  if (PyObject_SetAttrString(__pyx_m, "__builtins__", __pyx_b) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 6; goto __pyx_L1;};
  if (__Pyx_InitStrings(__pyx_string_tab) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 6; goto __pyx_L1;};
  if (PyType_Ready(&__pyx_type_4dnet_eth) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 101; goto __pyx_L1;}
  if (PyObject_SetAttrString(__pyx_m, "eth", (PyObject *)&__pyx_type_4dnet_eth) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 101; goto __pyx_L1;}
  __pyx_ptype_4dnet_eth = &__pyx_type_4dnet_eth;
  if (PyType_Ready(&__pyx_type_4dnet_ip) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 239; goto __pyx_L1;}
  if (PyObject_SetAttrString(__pyx_m, "ip", (PyObject *)&__pyx_type_4dnet_ip) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 239; goto __pyx_L1;}
  __pyx_ptype_4dnet_ip = &__pyx_type_4dnet_ip;
  if (PyType_Ready(&__pyx_type_4dnet_addr) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 435; goto __pyx_L1;}
  if (PyObject_SetAttrString(__pyx_m, "addr", (PyObject *)&__pyx_type_4dnet_addr) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 435; goto __pyx_L1;}
  __pyx_ptype_4dnet_addr = &__pyx_type_4dnet_addr;
  if (PyType_Ready(&__pyx_type_4dnet___addr_ip4_iter) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 623; goto __pyx_L1;}
  if (PyObject_SetAttrString(__pyx_m, "__addr_ip4_iter", (PyObject *)&__pyx_type_4dnet___addr_ip4_iter) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 623; goto __pyx_L1;}
  __pyx_ptype_4dnet___addr_ip4_iter = &__pyx_type_4dnet___addr_ip4_iter;
  if (PyType_Ready(&__pyx_type_4dnet_arp) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 688; goto __pyx_L1;}
  if (PyObject_SetAttrString(__pyx_m, "arp", (PyObject *)&__pyx_type_4dnet_arp) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 688; goto __pyx_L1;}
  __pyx_ptype_4dnet_arp = &__pyx_type_4dnet_arp;
  if (PyType_Ready(&__pyx_type_4dnet_intf) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 968; goto __pyx_L1;}
  if (PyObject_SetAttrString(__pyx_m, "intf", (PyObject *)&__pyx_type_4dnet_intf) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 968; goto __pyx_L1;}
  __pyx_ptype_4dnet_intf = &__pyx_type_4dnet_intf;
  if (PyType_Ready(&__pyx_type_4dnet_route) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1087; goto __pyx_L1;}
  if (PyObject_SetAttrString(__pyx_m, "route", (PyObject *)&__pyx_type_4dnet_route) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1087; goto __pyx_L1;}
  __pyx_ptype_4dnet_route = &__pyx_type_4dnet_route;
  if (PyType_Ready(&__pyx_type_4dnet_fw) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1233; goto __pyx_L1;}
  if (PyObject_SetAttrString(__pyx_m, "fw", (PyObject *)&__pyx_type_4dnet_fw) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1233; goto __pyx_L1;}
  __pyx_ptype_4dnet_fw = &__pyx_type_4dnet_fw;
  if (PyType_Ready(&__pyx_type_4dnet_rand) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1310; goto __pyx_L1;}
  if (PyObject_SetAttrString(__pyx_m, "rand", (PyObject *)&__pyx_type_4dnet_rand) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1310; goto __pyx_L1;}
  __pyx_ptype_4dnet_rand = &__pyx_type_4dnet_rand;
  if (PyType_Ready(&__pyx_type_4dnet___rand_xrange) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1392; goto __pyx_L1;}
  if (PyObject_SetAttrString(__pyx_m, "__rand_xrange", (PyObject *)&__pyx_type_4dnet___rand_xrange) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1392; goto __pyx_L1;}
  __pyx_ptype_4dnet___rand_xrange = &__pyx_type_4dnet___rand_xrange;
  if (PyType_Ready(&__pyx_type_4dnet_tun) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1476; goto __pyx_L1;}
  if (PyObject_SetAttrString(__pyx_m, "tun", (PyObject *)&__pyx_type_4dnet_tun) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1476; goto __pyx_L1;}
  __pyx_ptype_4dnet_tun = &__pyx_type_4dnet_tun;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":15 */
  if (PyObject_SetAttr(__pyx_m, __pyx_n___author__, __pyx_k60p) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 15; goto __pyx_L1;}

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":16 */
  if (PyObject_SetAttr(__pyx_m, __pyx_n___copyright__, __pyx_k62p) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 16; goto __pyx_L1;}

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":17 */
  if (PyObject_SetAttr(__pyx_m, __pyx_n___license__, __pyx_n_BSD) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 17; goto __pyx_L1;}

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":18 */
  if (PyObject_SetAttr(__pyx_m, __pyx_n___url__, __pyx_k66p) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 18; goto __pyx_L1;}

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":19 */
  if (PyObject_SetAttr(__pyx_m, __pyx_n___version__, __pyx_k68p) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 19; goto __pyx_L1;}

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":74 */
  __pyx_1 = PyInt_FromLong(6); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 74; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ETH_ADDR_LEN, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 74; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":75 */
  __pyx_1 = PyInt_FromLong(48); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 75; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ETH_ADDR_BITS, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 75; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":76 */
  __pyx_1 = PyInt_FromLong(2); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 76; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ETH_TYPE_LEN, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 76; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":77 */
  __pyx_1 = PyInt_FromLong(4); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 77; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ETH_CRC_LEN, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 77; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":78 */
  __pyx_1 = PyInt_FromLong(14); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 78; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ETH_HDR_LEN, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 78; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":80 */
  __pyx_1 = PyInt_FromLong(64); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 80; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ETH_LEN_MIN, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 80; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":81 */
  __pyx_1 = PyInt_FromLong(1518); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 81; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ETH_LEN_MAX, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 81; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":83 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_ETH_LEN_MAX); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 83; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_ETH_HDR_LEN); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 83; goto __pyx_L1;}
  __pyx_3 = PyNumber_Subtract(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 83; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_ETH_CRC_LEN); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 83; goto __pyx_L1;}
  __pyx_2 = PyNumber_Subtract(__pyx_3, __pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 83; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ETH_MTU, __pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 83; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":84 */
  __pyx_3 = __Pyx_GetName(__pyx_m, __pyx_n_ETH_LEN_MIN); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 84; goto __pyx_L1;}
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_ETH_HDR_LEN); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 84; goto __pyx_L1;}
  __pyx_2 = PyNumber_Subtract(__pyx_3, __pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 84; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  __pyx_3 = __Pyx_GetName(__pyx_m, __pyx_n_ETH_CRC_LEN); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 84; goto __pyx_L1;}
  __pyx_1 = PyNumber_Subtract(__pyx_2, __pyx_3); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 84; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ETH_MIN, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 84; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":86 */
  __pyx_2 = PyInt_FromLong(0x0200); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 86; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ETH_TYPE_PUP, __pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 86; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":87 */
  __pyx_3 = PyInt_FromLong(0x0800); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 87; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ETH_TYPE_IP, __pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 87; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":88 */
  __pyx_1 = PyInt_FromLong(0x0806); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 88; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ETH_TYPE_ARP, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 88; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":89 */
  __pyx_2 = PyInt_FromLong(0x8035); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 89; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ETH_TYPE_REVARP, __pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 89; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":90 */
  __pyx_3 = PyInt_FromLong(0x8100); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 90; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ETH_TYPE_8021Q, __pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 90; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":91 */
  __pyx_1 = PyInt_FromLong(0x86DD); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 91; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ETH_TYPE_IPV6, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 91; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":92 */
  __pyx_2 = PyInt_FromLong(0x8847); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 92; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ETH_TYPE_MPLS, __pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 92; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":93 */
  __pyx_3 = PyInt_FromLong(0x8848); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 93; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ETH_TYPE_MPLS_MCAST, __pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 93; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":94 */
  __pyx_1 = PyInt_FromLong(0x8863); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 94; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ETH_TYPE_PPPOEDISC, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 94; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":95 */
  __pyx_2 = PyInt_FromLong(0x8864); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 95; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ETH_TYPE_PPPOE, __pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 95; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":96 */
  __pyx_3 = PyInt_FromLong(0x9000); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 96; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ETH_TYPE_LOOPBACK, __pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 96; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":98 */
  __pyx_1 = PyString_FromStringAndSize(__pyx_k88,6); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 98; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ETH_ADDR_UNSPEC, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 98; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":99 */
  __pyx_2 = PyString_FromStringAndSize(__pyx_k90,6); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 99; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ETH_ADDR_BROADCAST, __pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 99; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":161 */
  __pyx_3 = __Pyx_GetName(__pyx_m, __pyx_n_ETH_ADDR_BROADCAST); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 161; goto __pyx_L1;}
  __pyx_d1 = __pyx_3;
  __pyx_3 = 0;
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_ETH_ADDR_BROADCAST); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 161; goto __pyx_L1;}
  __pyx_d2 = __pyx_1;
  __pyx_1 = 0;
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_ETH_TYPE_IP); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 162; goto __pyx_L1;}
  __pyx_d3 = __pyx_2;
  __pyx_2 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":198 */
  __pyx_4 = PyInt_FromLong(4); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 198; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_ADDR_LEN, __pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 198; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":199 */
  __pyx_4 = PyInt_FromLong(32); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 199; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_ADDR_BITS, __pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 199; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":201 */
  __pyx_4 = PyInt_FromLong(20); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 201; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_HDR_LEN, __pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 201; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":202 */
  __pyx_4 = PyInt_FromLong(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 202; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_OPT_LEN, __pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 202; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":203 */
  __pyx_4 = PyInt_FromLong(40); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 203; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_OPT_LEN_MAX, __pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 203; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":204 */
  __pyx_4 = __Pyx_GetName(__pyx_m, __pyx_n_IP_HDR_LEN); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 204; goto __pyx_L1;}
  __pyx_5 = __Pyx_GetName(__pyx_m, __pyx_n_IP_OPT_LEN_MAX); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 204; goto __pyx_L1;}
  __pyx_6 = PyNumber_Add(__pyx_4, __pyx_5); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 204; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  Py_DECREF(__pyx_5); __pyx_5 = 0;
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_HDR_LEN_MAX, __pyx_6) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 204; goto __pyx_L1;}
  Py_DECREF(__pyx_6); __pyx_6 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":206 */
  __pyx_4 = PyInt_FromLong(65535); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 206; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_LEN_MAX, __pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 206; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":207 */
  __pyx_5 = __Pyx_GetName(__pyx_m, __pyx_n_IP_HDR_LEN); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 207; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_LEN_MIN, __pyx_5) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 207; goto __pyx_L1;}
  Py_DECREF(__pyx_5); __pyx_5 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":209 */
  __pyx_6 = PyInt_FromLong(0x00); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 209; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_TOS_DEFAULT, __pyx_6) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 209; goto __pyx_L1;}
  Py_DECREF(__pyx_6); __pyx_6 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":211 */
  __pyx_4 = PyInt_FromLong(0x8000); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 211; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_RF, __pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 211; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":212 */
  __pyx_5 = PyInt_FromLong(0x4000); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 212; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_DF, __pyx_5) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 212; goto __pyx_L1;}
  Py_DECREF(__pyx_5); __pyx_5 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":213 */
  __pyx_6 = PyInt_FromLong(0x2000); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 213; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_MF, __pyx_6) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 213; goto __pyx_L1;}
  Py_DECREF(__pyx_6); __pyx_6 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":214 */
  __pyx_4 = PyInt_FromLong(0x1fff); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 214; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_OFFMASK, __pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 214; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":216 */
  __pyx_5 = PyInt_FromLong(64); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 216; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_TTL_DEFAULT, __pyx_5) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 216; goto __pyx_L1;}
  Py_DECREF(__pyx_5); __pyx_5 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":217 */
  __pyx_6 = PyInt_FromLong(255); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 217; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_TTL_MAX, __pyx_6) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 217; goto __pyx_L1;}
  Py_DECREF(__pyx_6); __pyx_6 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":219 */
  __pyx_4 = PyInt_FromLong(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 219; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_PROTO_IP, __pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 219; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":220 */
  __pyx_5 = PyInt_FromLong(1); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 220; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_PROTO_ICMP, __pyx_5) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 220; goto __pyx_L1;}
  Py_DECREF(__pyx_5); __pyx_5 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":221 */
  __pyx_6 = PyInt_FromLong(2); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 221; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_PROTO_IGMP, __pyx_6) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 221; goto __pyx_L1;}
  Py_DECREF(__pyx_6); __pyx_6 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":222 */
  __pyx_4 = PyInt_FromLong(6); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 222; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_PROTO_TCP, __pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 222; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":223 */
  __pyx_5 = PyInt_FromLong(17); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 223; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_PROTO_UDP, __pyx_5) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 223; goto __pyx_L1;}
  Py_DECREF(__pyx_5); __pyx_5 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":224 */
  __pyx_6 = PyInt_FromLong(41); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 224; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_PROTO_IPV6, __pyx_6) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 224; goto __pyx_L1;}
  Py_DECREF(__pyx_6); __pyx_6 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":225 */
  __pyx_4 = PyInt_FromLong(47); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 225; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_PROTO_GRE, __pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 225; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":226 */
  __pyx_5 = PyInt_FromLong(50); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 226; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_PROTO_ESP, __pyx_5) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 226; goto __pyx_L1;}
  Py_DECREF(__pyx_5); __pyx_5 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":227 */
  __pyx_6 = PyInt_FromLong(51); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 227; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_PROTO_AH, __pyx_6) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 227; goto __pyx_L1;}
  Py_DECREF(__pyx_6); __pyx_6 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":228 */
  __pyx_4 = PyInt_FromLong(58); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 228; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_PROTO_ICMPV6, __pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 228; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":229 */
  __pyx_5 = PyInt_FromLong(255); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 229; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_PROTO_RAW, __pyx_5) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 229; goto __pyx_L1;}
  Py_DECREF(__pyx_5); __pyx_5 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":230 */
  __pyx_6 = __Pyx_GetName(__pyx_m, __pyx_n_IP_PROTO_RAW); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 230; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_PROTO_RESERVED, __pyx_6) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 230; goto __pyx_L1;}
  Py_DECREF(__pyx_6); __pyx_6 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":231 */
  __pyx_4 = PyInt_FromLong(255); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 231; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_PROTO_MAX, __pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 231; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":233 */
  __pyx_5 = PyString_FromStringAndSize(__pyx_k116,4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 233; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_ADDR_ANY, __pyx_5) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 233; goto __pyx_L1;}
  Py_DECREF(__pyx_5); __pyx_5 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":234 */
  __pyx_6 = PyString_FromStringAndSize(__pyx_k118,4); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 234; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_ADDR_BROADCAST, __pyx_6) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 234; goto __pyx_L1;}
  Py_DECREF(__pyx_6); __pyx_6 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":235 */
  __pyx_4 = PyString_FromStringAndSize(__pyx_k120,4); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 235; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_ADDR_LOOPBACK, __pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 235; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":236 */
  __pyx_5 = PyString_FromStringAndSize(__pyx_k122,4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 236; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_ADDR_MCAST_ALL, __pyx_5) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 236; goto __pyx_L1;}
  Py_DECREF(__pyx_5); __pyx_5 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":237 */
  __pyx_6 = PyString_FromStringAndSize(__pyx_k124,4); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 237; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP_ADDR_MCAST_LOCAL, __pyx_6) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 237; goto __pyx_L1;}
  Py_DECREF(__pyx_6); __pyx_6 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":319 */
  __pyx_4 = __Pyx_GetName(__pyx_m, __pyx_n_IP_TOS_DEFAULT); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 319; goto __pyx_L1;}
  __pyx_d4 = __pyx_4;
  __pyx_4 = 0;
  __pyx_5 = __Pyx_GetName(__pyx_m, __pyx_n_IP_HDR_LEN); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 319; goto __pyx_L1;}
  __pyx_d5 = __pyx_5;
  __pyx_5 = 0;
  __pyx_6 = PyInt_FromLong(0); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 319; goto __pyx_L1;}
  __pyx_d6 = __pyx_6;
  __pyx_6 = 0;
  __pyx_7 = PyInt_FromLong(0); if (!__pyx_7) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 319; goto __pyx_L1;}
  __pyx_d7 = __pyx_7;
  __pyx_7 = 0;
  __pyx_8 = __Pyx_GetName(__pyx_m, __pyx_n_IP_TTL_DEFAULT); if (!__pyx_8) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 320; goto __pyx_L1;}
  __pyx_d8 = __pyx_8;
  __pyx_8 = 0;
  __pyx_9 = __Pyx_GetName(__pyx_m, __pyx_n_IP_PROTO_IP); if (!__pyx_9) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 320; goto __pyx_L1;}
  __pyx_d9 = __pyx_9;
  __pyx_9 = 0;
  __pyx_10 = __Pyx_GetName(__pyx_m, __pyx_n_IP_ADDR_ANY); if (!__pyx_10) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 321; goto __pyx_L1;}
  __pyx_d10 = __pyx_10;
  __pyx_10 = 0;
  __pyx_11 = __Pyx_GetName(__pyx_m, __pyx_n_IP_ADDR_ANY); if (!__pyx_11) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 321; goto __pyx_L1;}
  __pyx_d11 = __pyx_11;
  __pyx_11 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":354 */
  __pyx_12 = PyInt_FromLong(16); if (!__pyx_12) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 354; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP6_ADDR_LEN, __pyx_12) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 354; goto __pyx_L1;}
  Py_DECREF(__pyx_12); __pyx_12 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":355 */
  __pyx_12 = PyInt_FromLong(128); if (!__pyx_12) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 355; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP6_ADDR_BITS, __pyx_12) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 355; goto __pyx_L1;}
  Py_DECREF(__pyx_12); __pyx_12 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":357 */
  __pyx_12 = PyInt_FromLong(40); if (!__pyx_12) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 357; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP6_HDR_LEN, __pyx_12) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 357; goto __pyx_L1;}
  Py_DECREF(__pyx_12); __pyx_12 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":358 */
  __pyx_12 = __Pyx_GetName(__pyx_m, __pyx_n_IP6_HDR_LEN); if (!__pyx_12) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 358; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP6_LEN_MIN, __pyx_12) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 358; goto __pyx_L1;}
  Py_DECREF(__pyx_12); __pyx_12 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":359 */
  __pyx_12 = PyInt_FromLong(65535); if (!__pyx_12) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 359; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP6_LEN_MAX, __pyx_12) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 359; goto __pyx_L1;}
  Py_DECREF(__pyx_12); __pyx_12 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":361 */
  __pyx_12 = PyInt_FromLong(1280); if (!__pyx_12) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 361; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP6_MTU_MIN, __pyx_12) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 361; goto __pyx_L1;}
  Py_DECREF(__pyx_12); __pyx_12 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":363 */
  __pyx_12 = PyInt_FromLong(64); if (!__pyx_12) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 363; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP6_HLIM_DEFAULT, __pyx_12) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 363; goto __pyx_L1;}
  Py_DECREF(__pyx_12); __pyx_12 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":364 */
  __pyx_12 = PyInt_FromLong(255); if (!__pyx_12) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 364; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP6_HLIM_MAX, __pyx_12) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 364; goto __pyx_L1;}
  Py_DECREF(__pyx_12); __pyx_12 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":366 */
  __pyx_12 = PyString_FromStringAndSize(__pyx_k132,16); if (!__pyx_12) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 366; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP6_ADDR_UNSPEC, __pyx_12) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 366; goto __pyx_L1;}
  Py_DECREF(__pyx_12); __pyx_12 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":367 */
  __pyx_12 = PyString_FromStringAndSize(__pyx_k134,16); if (!__pyx_12) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 367; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_IP6_ADDR_LOOPBACK, __pyx_12) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 367; goto __pyx_L1;}
  Py_DECREF(__pyx_12); __pyx_12 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":394 */
  __pyx_12 = PyInt_FromLong(0); if (!__pyx_12) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 394; goto __pyx_L1;}
  __pyx_d12 = __pyx_12;
  __pyx_12 = 0;
  __pyx_13 = PyInt_FromLong(0); if (!__pyx_13) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 394; goto __pyx_L1;}
  __pyx_d13 = __pyx_13;
  __pyx_13 = 0;
  __pyx_14 = PyInt_FromLong(0); if (!__pyx_14) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 394; goto __pyx_L1;}
  __pyx_d14 = __pyx_14;
  __pyx_14 = 0;
  __pyx_15 = __Pyx_GetName(__pyx_m, __pyx_n_IP_PROTO_IPV6); if (!__pyx_15) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 394; goto __pyx_L1;}
  __pyx_d15 = __pyx_15;
  __pyx_15 = 0;
  __pyx_16 = __Pyx_GetName(__pyx_m, __pyx_n_IP6_HLIM_DEFAULT); if (!__pyx_16) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 394; goto __pyx_L1;}
  __pyx_d16 = __pyx_16;
  __pyx_16 = 0;
  __pyx_17 = __Pyx_GetName(__pyx_m, __pyx_n_IP6_ADDR_UNSPEC); if (!__pyx_17) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 395; goto __pyx_L1;}
  __pyx_d17 = __pyx_17;
  __pyx_17 = 0;
  __pyx_18 = __Pyx_GetName(__pyx_m, __pyx_n_IP6_ADDR_UNSPEC); if (!__pyx_18) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 395; goto __pyx_L1;}
  __pyx_d18 = __pyx_18;
  __pyx_18 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":430 */
  __pyx_19 = PyInt_FromLong(0); if (!__pyx_19) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 430; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ADDR_TYPE_NONE, __pyx_19) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 430; goto __pyx_L1;}
  Py_DECREF(__pyx_19); __pyx_19 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":431 */
  __pyx_19 = PyInt_FromLong(1); if (!__pyx_19) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 431; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ADDR_TYPE_ETH, __pyx_19) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 431; goto __pyx_L1;}
  Py_DECREF(__pyx_19); __pyx_19 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":432 */
  __pyx_19 = PyInt_FromLong(2); if (!__pyx_19) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 432; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ADDR_TYPE_IP, __pyx_19) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 432; goto __pyx_L1;}
  Py_DECREF(__pyx_19); __pyx_19 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":433 */
  __pyx_19 = PyInt_FromLong(3); if (!__pyx_19) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 433; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ADDR_TYPE_IP6, __pyx_19) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 433; goto __pyx_L1;}
  Py_DECREF(__pyx_19); __pyx_19 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":443 */
  Py_INCREF(Py_None);
  __pyx_d19 = Py_None;
  __pyx_19 = __Pyx_GetName(__pyx_m, __pyx_n_ADDR_TYPE_NONE); if (!__pyx_19) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 443; goto __pyx_L1;}
  __pyx_d20 = __pyx_19;
  __pyx_19 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":665 */
  __pyx_20 = PyInt_FromLong(8); if (!__pyx_20) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 665; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ARP_HDR_LEN, __pyx_20) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 665; goto __pyx_L1;}
  Py_DECREF(__pyx_20); __pyx_20 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":666 */
  __pyx_20 = PyInt_FromLong(20); if (!__pyx_20) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 666; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ARP_ETHIP_LEN, __pyx_20) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 666; goto __pyx_L1;}
  Py_DECREF(__pyx_20); __pyx_20 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":668 */
  __pyx_20 = PyInt_FromLong(0x0001); if (!__pyx_20) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 668; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ARP_HRD_ETH, __pyx_20) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 668; goto __pyx_L1;}
  Py_DECREF(__pyx_20); __pyx_20 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":669 */
  __pyx_20 = PyInt_FromLong(0x0006); if (!__pyx_20) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 669; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ARP_HRD_IEEE802, __pyx_20) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 669; goto __pyx_L1;}
  Py_DECREF(__pyx_20); __pyx_20 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":671 */
  __pyx_20 = PyInt_FromLong(0x0800); if (!__pyx_20) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 671; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ARP_PRO_IP, __pyx_20) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 671; goto __pyx_L1;}
  Py_DECREF(__pyx_20); __pyx_20 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":673 */
  __pyx_20 = PyInt_FromLong(1); if (!__pyx_20) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 673; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ARP_OP_REQUEST, __pyx_20) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 673; goto __pyx_L1;}
  Py_DECREF(__pyx_20); __pyx_20 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":674 */
  __pyx_20 = PyInt_FromLong(2); if (!__pyx_20) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 674; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ARP_OP_REPLY, __pyx_20) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 674; goto __pyx_L1;}
  Py_DECREF(__pyx_20); __pyx_20 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":675 */
  __pyx_20 = PyInt_FromLong(3); if (!__pyx_20) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 675; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ARP_OP_REVREQUEST, __pyx_20) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 675; goto __pyx_L1;}
  Py_DECREF(__pyx_20); __pyx_20 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":676 */
  __pyx_20 = PyInt_FromLong(4); if (!__pyx_20) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 676; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ARP_OP_REVREPLY, __pyx_20) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 676; goto __pyx_L1;}
  Py_DECREF(__pyx_20); __pyx_20 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":737 */
  Py_INCREF(Py_None);
  __pyx_d21 = Py_None;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":759 */
  __pyx_20 = __Pyx_GetName(__pyx_m, __pyx_n_ARP_OP_REQUEST); if (!__pyx_20) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 759; goto __pyx_L1;}
  __pyx_d22 = __pyx_20;
  __pyx_20 = 0;
  __pyx_21 = __Pyx_GetName(__pyx_m, __pyx_n_ETH_ADDR_UNSPEC); if (!__pyx_21) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 760; goto __pyx_L1;}
  __pyx_d23 = __pyx_21;
  __pyx_21 = 0;
  __pyx_22 = __Pyx_GetName(__pyx_m, __pyx_n_IP_ADDR_ANY); if (!__pyx_22) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 760; goto __pyx_L1;}
  __pyx_d24 = __pyx_22;
  __pyx_22 = 0;
  __pyx_23 = __Pyx_GetName(__pyx_m, __pyx_n_ETH_ADDR_UNSPEC); if (!__pyx_23) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 761; goto __pyx_L1;}
  __pyx_d25 = __pyx_23;
  __pyx_23 = 0;
  __pyx_24 = __Pyx_GetName(__pyx_m, __pyx_n_IP_ADDR_ANY); if (!__pyx_24) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 761; goto __pyx_L1;}
  __pyx_d26 = __pyx_24;
  __pyx_24 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":805 */
  __pyx_25 = PyInt_FromLong(20); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 805; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_HDR_LEN, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 805; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":807 */
  __pyx_25 = PyInt_FromLong(0x01); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 807; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TH_FIN, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 807; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":808 */
  __pyx_25 = PyInt_FromLong(0x02); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 808; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TH_SYN, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 808; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":809 */
  __pyx_25 = PyInt_FromLong(0x04); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 809; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TH_RST, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 809; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":810 */
  __pyx_25 = PyInt_FromLong(0x08); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 810; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TH_PUSH, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 810; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":811 */
  __pyx_25 = PyInt_FromLong(0x10); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 811; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TH_ACK, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 811; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":812 */
  __pyx_25 = PyInt_FromLong(0x20); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 812; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TH_URG, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 812; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":813 */
  __pyx_25 = PyInt_FromLong(0x40); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 813; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TH_ECE, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 813; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":814 */
  __pyx_25 = PyInt_FromLong(0x80); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 814; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TH_CWR, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 814; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":816 */
  __pyx_25 = PyInt_FromLong(65535); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 816; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_PORT_MAX, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 816; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":817 */
  __pyx_25 = PyInt_FromLong(65535); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 817; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_WIN_MAX, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 817; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":819 */
  __pyx_25 = PyInt_FromLong(0); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 819; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_EOL, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 819; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":820 */
  __pyx_25 = PyInt_FromLong(1); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 820; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_NOP, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 820; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":821 */
  __pyx_25 = PyInt_FromLong(2); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 821; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_MSS, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 821; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":822 */
  __pyx_25 = PyInt_FromLong(3); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 822; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_WSCALE, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 822; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":823 */
  __pyx_25 = PyInt_FromLong(4); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 823; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_SACKOK, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 823; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":824 */
  __pyx_25 = PyInt_FromLong(5); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 824; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_SACK, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 824; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":825 */
  __pyx_25 = PyInt_FromLong(6); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 825; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_ECHO, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 825; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":826 */
  __pyx_25 = PyInt_FromLong(7); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 826; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_ECHOREPLY, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 826; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":827 */
  __pyx_25 = PyInt_FromLong(8); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 827; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_TIMESTAMP, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 827; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":828 */
  __pyx_25 = PyInt_FromLong(9); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 828; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_POCONN, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 828; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":829 */
  __pyx_25 = PyInt_FromLong(10); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 829; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_POSVC, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 829; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":830 */
  __pyx_25 = PyInt_FromLong(11); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 830; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_CC, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 830; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":831 */
  __pyx_25 = PyInt_FromLong(12); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 831; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_CCNEW, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 831; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":832 */
  __pyx_25 = PyInt_FromLong(13); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 832; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_CCECHO, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 832; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":833 */
  __pyx_25 = PyInt_FromLong(14); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 833; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_ALTSUM, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 833; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":834 */
  __pyx_25 = PyInt_FromLong(15); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 834; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_ALTSUMDATA, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 834; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":835 */
  __pyx_25 = PyInt_FromLong(16); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 835; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_SKEETER, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 835; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":836 */
  __pyx_25 = PyInt_FromLong(17); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 836; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_BUBBA, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 836; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":837 */
  __pyx_25 = PyInt_FromLong(18); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 837; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_TRAILSUM, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 837; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":838 */
  __pyx_25 = PyInt_FromLong(19); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 838; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_MD5, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 838; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":839 */
  __pyx_25 = PyInt_FromLong(20); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 839; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_SCPS, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 839; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":840 */
  __pyx_25 = PyInt_FromLong(21); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 840; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_SNACK, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 840; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":841 */
  __pyx_25 = PyInt_FromLong(22); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 841; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_REC, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 841; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":842 */
  __pyx_25 = PyInt_FromLong(23); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 842; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_CORRUPT, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 842; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":843 */
  __pyx_25 = PyInt_FromLong(24); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 843; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_SNAP, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 843; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":844 */
  __pyx_25 = PyInt_FromLong(26); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 844; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_TCPCOMP, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 844; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":845 */
  __pyx_25 = PyInt_FromLong(27); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 845; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TCP_OPT_MAX, __pyx_25) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 845; goto __pyx_L1;}
  Py_DECREF(__pyx_25); __pyx_25 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":847 */
  __pyx_25 = PyInt_FromLong(1); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 847; goto __pyx_L1;}
  __pyx_d27 = __pyx_25;
  __pyx_25 = 0;
  __pyx_26 = PyInt_FromLong(0); if (!__pyx_26) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 847; goto __pyx_L1;}
  __pyx_d28 = __pyx_26;
  __pyx_26 = 0;
  __pyx_27 = __Pyx_GetName(__pyx_m, __pyx_n_TH_SYN); if (!__pyx_27) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 847; goto __pyx_L1;}
  __pyx_d29 = __pyx_27;
  __pyx_27 = 0;
  __pyx_28 = __Pyx_GetName(__pyx_m, __pyx_n_TCP_WIN_MAX); if (!__pyx_28) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 848; goto __pyx_L1;}
  __pyx_d30 = __pyx_28;
  __pyx_28 = 0;
  __pyx_29 = PyInt_FromLong(0); if (!__pyx_29) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 848; goto __pyx_L1;}
  __pyx_d31 = __pyx_29;
  __pyx_29 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":870 */
  __pyx_30 = PyInt_FromLong(8); if (!__pyx_30) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 870; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_UDP_HDR_LEN, __pyx_30) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 870; goto __pyx_L1;}
  Py_DECREF(__pyx_30); __pyx_30 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":871 */
  __pyx_30 = PyInt_FromLong(65535); if (!__pyx_30) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 871; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_UDP_PORT_MAX, __pyx_30) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 871; goto __pyx_L1;}
  Py_DECREF(__pyx_30); __pyx_30 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":873 */
  __pyx_30 = __Pyx_GetName(__pyx_m, __pyx_n_UDP_HDR_LEN); if (!__pyx_30) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 873; goto __pyx_L1;}
  __pyx_d32 = __pyx_30;
  __pyx_30 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":912 */
  __pyx_31 = PyInt_FromLong(1); if (!__pyx_31) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 912; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_INTF_TYPE_OTHER, __pyx_31) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 912; goto __pyx_L1;}
  Py_DECREF(__pyx_31); __pyx_31 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":913 */
  __pyx_31 = PyInt_FromLong(6); if (!__pyx_31) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 913; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_INTF_TYPE_ETH, __pyx_31) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 913; goto __pyx_L1;}
  Py_DECREF(__pyx_31); __pyx_31 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":914 */
  __pyx_31 = PyInt_FromLong(24); if (!__pyx_31) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 914; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_INTF_TYPE_LOOPBACK, __pyx_31) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 914; goto __pyx_L1;}
  Py_DECREF(__pyx_31); __pyx_31 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":915 */
  __pyx_31 = PyInt_FromLong(53); if (!__pyx_31) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 915; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_INTF_TYPE_TUN, __pyx_31) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 915; goto __pyx_L1;}
  Py_DECREF(__pyx_31); __pyx_31 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":917 */
  __pyx_31 = PyInt_FromLong(0x01); if (!__pyx_31) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 917; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_INTF_FLAG_UP, __pyx_31) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 917; goto __pyx_L1;}
  Py_DECREF(__pyx_31); __pyx_31 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":918 */
  __pyx_31 = PyInt_FromLong(0x02); if (!__pyx_31) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 918; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_INTF_FLAG_LOOPBACK, __pyx_31) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 918; goto __pyx_L1;}
  Py_DECREF(__pyx_31); __pyx_31 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":919 */
  __pyx_31 = PyInt_FromLong(0x04); if (!__pyx_31) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 919; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_INTF_FLAG_POINTOPOINT, __pyx_31) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 919; goto __pyx_L1;}
  Py_DECREF(__pyx_31); __pyx_31 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":920 */
  __pyx_31 = PyInt_FromLong(0x08); if (!__pyx_31) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 920; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_INTF_FLAG_NOARP, __pyx_31) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 920; goto __pyx_L1;}
  Py_DECREF(__pyx_31); __pyx_31 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":921 */
  __pyx_31 = PyInt_FromLong(0x10); if (!__pyx_31) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 921; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_INTF_FLAG_BROADCAST, __pyx_31) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 921; goto __pyx_L1;}
  Py_DECREF(__pyx_31); __pyx_31 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":922 */
  __pyx_31 = PyInt_FromLong(0x20); if (!__pyx_31) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 922; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_INTF_FLAG_MULTICAST, __pyx_31) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 922; goto __pyx_L1;}
  Py_DECREF(__pyx_31); __pyx_31 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1037 */
  Py_INCREF(Py_None);
  __pyx_d33 = Py_None;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1136 */
  Py_INCREF(Py_None);
  __pyx_d34 = Py_None;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1182 */
  __pyx_31 = PyInt_FromLong(1); if (!__pyx_31) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1182; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_FW_OP_ALLOW, __pyx_31) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1182; goto __pyx_L1;}
  Py_DECREF(__pyx_31); __pyx_31 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1183 */
  __pyx_31 = PyInt_FromLong(2); if (!__pyx_31) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1183; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_FW_OP_BLOCK, __pyx_31) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1183; goto __pyx_L1;}
  Py_DECREF(__pyx_31); __pyx_31 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1185 */
  __pyx_31 = PyInt_FromLong(1); if (!__pyx_31) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1185; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_FW_DIR_IN, __pyx_31) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1185; goto __pyx_L1;}
  Py_DECREF(__pyx_31); __pyx_31 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1186 */
  __pyx_31 = PyInt_FromLong(2); if (!__pyx_31) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1186; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_FW_DIR_OUT, __pyx_31) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1186; goto __pyx_L1;}
  Py_DECREF(__pyx_31); __pyx_31 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1272 */
  Py_INCREF(Py_None);
  __pyx_d35 = Py_None;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1370 */
  Py_INCREF(Py_None);
  __pyx_d36 = Py_None;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1489 */
  __pyx_31 = PyInt_FromLong(1500); if (!__pyx_31) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1489; goto __pyx_L1;}
  __pyx_d37 = __pyx_31;
  __pyx_31 = 0;

  /* "/tmp/B.2c9db01e-cc45-4d54-b986-4ea5b7f35fe7/BUILD/libdnet-1.12/python/dnet.pyx":1530 */
  return;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  Py_XDECREF(__pyx_6);
  Py_XDECREF(__pyx_7);
  Py_XDECREF(__pyx_8);
  Py_XDECREF(__pyx_9);
  Py_XDECREF(__pyx_10);
  Py_XDECREF(__pyx_11);
  Py_XDECREF(__pyx_12);
  Py_XDECREF(__pyx_13);
  Py_XDECREF(__pyx_14);
  Py_XDECREF(__pyx_15);
  Py_XDECREF(__pyx_16);
  Py_XDECREF(__pyx_17);
  Py_XDECREF(__pyx_18);
  Py_XDECREF(__pyx_19);
  Py_XDECREF(__pyx_20);
  Py_XDECREF(__pyx_21);
  Py_XDECREF(__pyx_22);
  Py_XDECREF(__pyx_23);
  Py_XDECREF(__pyx_24);
  Py_XDECREF(__pyx_25);
  Py_XDECREF(__pyx_26);
  Py_XDECREF(__pyx_27);
  Py_XDECREF(__pyx_28);
  Py_XDECREF(__pyx_29);
  Py_XDECREF(__pyx_30);
  Py_XDECREF(__pyx_31);
  __Pyx_AddTraceback("dnet");
}

static char *__pyx_filenames[] = {
  "dnet.pyx",
};

/* Runtime support code */

static void __pyx_init_filenames(void) {
  __pyx_f = __pyx_filenames;
}

static void __Pyx_Raise(PyObject *type, PyObject *value, PyObject *tb) {
    if (value == Py_None)
        value = NULL;
    if (tb == Py_None)
        tb = NULL;
    Py_XINCREF(type);
    Py_XINCREF(value);
    Py_XINCREF(tb);
    if (tb && !PyTraceBack_Check(tb)) {
        PyErr_SetString(PyExc_TypeError,
            "raise: arg 3 must be a traceback or None");
        goto raise_error;
    }
    #if PY_VERSION_HEX < 0x02050000
    if (!PyClass_Check(type))
    #else
    if (!PyType_Check(type))
    #endif
    {
        /* Raising an instance.  The value should be a dummy. */
        if (value) {
            PyErr_SetString(PyExc_TypeError,
                "instance exception may not have a separate value");
            goto raise_error;
        }
        /* Normalize to raise <class>, <instance> */
        value = type;
        #if PY_VERSION_HEX < 0x02050000
            if (PyInstance_Check(type)) {
                type = (PyObject*) ((PyInstanceObject*)type)->in_class;
                Py_INCREF(type);
            }
            else {
                PyErr_SetString(PyExc_TypeError,
                    "raise: exception must be an old-style class or instance");
                goto raise_error;
            }
        #else
            type = (PyObject*) type->ob_type;
            Py_INCREF(type);
            if (!PyType_IsSubtype((PyTypeObject *)type, (PyTypeObject *)PyExc_BaseException)) {
                PyErr_SetString(PyExc_TypeError,
                    "raise: exception class must be a subclass of BaseException");
                goto raise_error;
            }
        #endif
    }
    PyErr_Restore(type, value, tb);
    return;
raise_error:
    Py_XDECREF(value);
    Py_XDECREF(type);
    Py_XDECREF(tb);
    return;
}

static PyObject *__Pyx_GetName(PyObject *dict, PyObject *name) {
    PyObject *result;
    result = PyObject_GetAttr(dict, name);
    if (!result)
        PyErr_SetObject(PyExc_NameError, name);
    return result;
}

static int __Pyx_ArgTypeTest(PyObject *obj, PyTypeObject *type, int none_allowed, char *name) {
    if (!type) {
        PyErr_Format(PyExc_SystemError, "Missing type object");
        return 0;
    }
    if ((none_allowed && obj == Py_None) || PyObject_TypeCheck(obj, type))
        return 1;
    PyErr_Format(PyExc_TypeError,
        "Argument '%s' has incorrect type (expected %s, got %s)",
        name, type->tp_name, obj->ob_type->tp_name);
    return 0;
}

static void __Pyx_UnpackError(void) {
    PyErr_SetString(PyExc_ValueError, "unpack sequence of wrong size");
}

static PyObject *__Pyx_UnpackItem(PyObject *iter) {
    PyObject *item;
    if (!(item = PyIter_Next(iter))) {
        if (!PyErr_Occurred())
            __Pyx_UnpackError();
    }
    return item;
}

static int __Pyx_EndUnpack(PyObject *iter) {
    PyObject *item;
    if ((item = PyIter_Next(iter))) {
        Py_DECREF(item);
        __Pyx_UnpackError();
        return -1;
    }
    else if (!PyErr_Occurred())
        return 0;
    else
        return -1;
}

static int __Pyx_InitStrings(__Pyx_StringTabEntry *t) {
    while (t->p) {
        *t->p = PyString_FromStringAndSize(t->s, t->n - 1);
        if (!*t->p)
            return -1;
        if (t->i)
            PyString_InternInPlace(t->p);
        ++t;
    }
    return 0;
}

#include "compile.h"
#include "frameobject.h"
#include "traceback.h"

static void __Pyx_AddTraceback(char *funcname) {
    PyObject *py_srcfile = 0;
    PyObject *py_funcname = 0;
    PyObject *py_globals = 0;
    PyObject *empty_tuple = 0;
    PyObject *empty_string = 0;
    PyCodeObject *py_code = 0;
    PyFrameObject *py_frame = 0;
    
    py_srcfile = PyString_FromString(__pyx_filename);
    if (!py_srcfile) goto bad;
    py_funcname = PyString_FromString(funcname);
    if (!py_funcname) goto bad;
    py_globals = PyModule_GetDict(__pyx_m);
    if (!py_globals) goto bad;
    empty_tuple = PyTuple_New(0);
    if (!empty_tuple) goto bad;
    empty_string = PyString_FromString("");
    if (!empty_string) goto bad;
    py_code = PyCode_New(
        0,            /*int argcount,*/
        0,            /*int nlocals,*/
        0,            /*int stacksize,*/
        0,            /*int flags,*/
        empty_string, /*PyObject *code,*/
        empty_tuple,  /*PyObject *consts,*/
        empty_tuple,  /*PyObject *names,*/
        empty_tuple,  /*PyObject *varnames,*/
        empty_tuple,  /*PyObject *freevars,*/
        empty_tuple,  /*PyObject *cellvars,*/
        py_srcfile,   /*PyObject *filename,*/
        py_funcname,  /*PyObject *name,*/
        __pyx_lineno,   /*int firstlineno,*/
        empty_string  /*PyObject *lnotab*/
    );
    if (!py_code) goto bad;
    py_frame = PyFrame_New(
        PyThreadState_Get(), /*PyThreadState *tstate,*/
        py_code,             /*PyCodeObject *code,*/
        py_globals,          /*PyObject *globals,*/
        0                    /*PyObject *locals*/
    );
    if (!py_frame) goto bad;
    py_frame->f_lineno = __pyx_lineno;
    PyTraceBack_Here(py_frame);
bad:
    Py_XDECREF(py_srcfile);
    Py_XDECREF(py_funcname);
    Py_XDECREF(empty_tuple);
    Py_XDECREF(empty_string);
    Py_XDECREF(py_code);
    Py_XDECREF(py_frame);
}
